<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: logs.php,v 1.10 2008/10/24 12:36:06 patrick Exp $
 *
 */

include('../serverlib/admin.inc.php');
RequestPrivileges(PRIVILEGES_ADMIN);

if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'logs';

$tabs = array(
	0 => array(
		'title'		=> $lang_admin['logs'],
		'link'		=> 'logs.php?',
		'active'	=> $_REQUEST['action'] == 'logs'
	),
	1 => array(
		'title'		=> $lang_admin['archiving'],
		'link'		=> 'logs.php?action=archiving&',
		'active'	=> $_REQUEST['action'] == 'archiving'
	)
);

/**
 * logs
 */
if($_REQUEST['action'] == 'logs')
{
	$prioImg = array(
		PRIO_DEBUG		=> 'debug',
		PRIO_ERROR		=> 'error',
		PRIO_NOTE		=> 'info',
		PRIO_WARNING	=> 'warning',
		PRIO_PLUGIN		=> 'plugin'
	);
	$start = isset($_REQUEST['startDay']) ? SmartyDateTime('start')
				: (isset($_REQUEST['start']) ? (int)$_REQUEST['start']
					: mktime(0, 0, 0, date('m'), date('d'), date('Y')));
	$end = isset($_REQUEST['endDay']) ? SmartyDateTime('end') + 59
				: (isset($_REQUEST['end']) ? (int)$_REQUEST['end']
					: time());
	$addQ = isset($_REQUEST['q']) && trim($_REQUEST['q']) != ''
		? ' AND eintrag LIKE \'%' . mysql_escape_string($_REQUEST['q']) . '%\''
		: '';
	$prio = isset($_REQUEST['prio']) && is_array($_REQUEST['prio'])
		? $_REQUEST['prio']
		: array(PRIO_DEBUG => false, PRIO_ERROR => true, PRIO_NOTE => true,
				PRIO_WARNING => true, PRIO_PLUGIN => true);
	
	/**
	 * export?
	 */
	$exportMode = false;
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'export')
	{
		$exportMode = true;
		header('Pragma: public');
		header('Content-Type: text/plain');
		header(sprintf('Content-Disposition: attachment; filename=b1gMailLog-%d-%d.log',
			$start, $end));
		
		// header
		echo '#' . "\n";
		echo '# b1gMail ' . B1GMAIL_VERSION . "\n";
		echo '# Log file' . "\n";
		echo '#' . "\n";
		echo '# From: ' . date('r', $start) . "\n";
		echo '# To: ' . date('r', $end) . "\n";
		echo '# Generated: ' . date('r') . "\n";
		echo '#' . "\n";
		echo "\n";		
	}
	
	$entries = array();
	$res = $db->Query('SELECT prio,eintrag,zeitstempel FROM {pre}logs WHERE zeitstempel>='.$start.' AND zeitstempel<='.$end.$addQ.' AND prio IN ? ORDER BY id ASC',
		array_keys($prio));
	while($row = $res->FetchArray())
	{
		if($exportMode)
		{
			printf('%s [%d]: %s' . "\n",
				date('r', $row['zeitstempel']),
				$row['prio'],
				$row['eintrag']);
		}
		else 
		{
			$row['prioImg'] = $prioImg[$row['prio']];
			$entries[] = $row;
		}
	}
	$res->Free();
	
	if($exportMode)
		die();
	
	$prioQ = '';
	foreach($prio as $key=>$val)
		$prioQ .= '&prio[' . ((int)$key) . ']=true';
		
	$tpl->assign('prioQ', $prioQ);
	$tpl->assign('prio', $prio);
	$tpl->assign('q', isset($_REQUEST['q']) ? $_REQUEST['q'] : '');
	$tpl->assign('ueQ', isset($_REQUEST['q']) ? urlencode($_REQUEST['q']) : '');
	$tpl->assign('start', $start);
	$tpl->assign('end', $end);
	$tpl->assign('entries', $entries);
	$tpl->assign('page', 'logs.tpl');
}

/**
 * archiving
 */
else if($_REQUEST['action'] == 'archiving')
{
	/**
	 * do it?
	 */
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'archive')
	{
		$date = SmartyDateTime('date');
		$archive = isset($_REQUEST['saveCopy']);
		
		if($archive)
		{
			$fileName = B1GMAIL_REL . 'logs/b1gMailLog-' . time() . '.log';
			if(PHPNumVersion() >= 430 && function_exists('gzopen'))
			{
				$fp = fopen('compress.bzip2://' . $fileName . '.bz2', 'w+');
			}
			
			if(!isset($fp) || !$fp)
			{
				$fp = fopen($fileName, 'w+');
			}
			
			if(!$fp)
			{
				DisplayError(0x15, 'Cannot create log archive file',
					'Failed to create a new log archive file. The archiving procedure has been aborted.',
					sprintf("File:\n%s", $fileName),
					__FILE__,
					__LINE__);
				die();
			}
			
			fwrite($fp, '#' . "\n");
			fwrite($fp, '# b1gMail ' . B1GMAIL_VERSION . "\n");
			fwrite($fp, '# Log file' . "\n");
			fwrite($fp, '#' . "\n");
			fwrite($fp, '# To: ' . date('r', $date) . "\n");
			fwrite($fp, '# Generated: ' . date('r') . "\n");
			fwrite($fp, '#' . "\n");
			fwrite($fp, "\n");	
		
			$res = $db->Query('SELECT prio,eintrag,zeitstempel FROM {pre}logs WHERE zeitstempel<'.$date.' ORDER BY id ASC');
			while($row = $res->FetchArray())
			{
				fwrite($fp, sprintf('%s [%d]: %s' . "\n",
						date('r', $row['zeitstempel']),
						$row['prio'],
						$row['eintrag']));
			}
			$res->Free();
			
			fclose($fp);
		}
		
		$db->Query('DELETE FROM {pre}logs WHERE zeitstempel<'.$date);
	}
	
	$tpl->assign('page', 'logs.archiving.tpl');
}

$tpl->assign('tabs', $tabs);
$tpl->assign('title', $lang_admin['tools'] . ' &raquo; ' . $lang_admin['logs']);
$tpl->display('page.tpl');
?>