<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: maintenance.php,v 1.8 2007/12/04 20:31:39 patrick Exp $
 *
 */

include('../serverlib/admin.inc.php');
include('../serverlib/mailbox.class.php');
RequestPrivileges(PRIVILEGES_ADMIN);

if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'inactive';

$tabs = array(
	0 => array(
		'title'		=> $lang_admin['inactiveusers'],
		'link'		=> 'maintenance.php?',
		'active'	=> $_REQUEST['action'] == 'inactive'
	),
	1 => array(
		'title'		=> $lang_admin['trash'],
		'link'		=> 'maintenance.php?action=trash&',
		'active'	=> $_REQUEST['action'] == 'trash'
	)
);

if($bm_prefs['receive_method'] == 'pop3')
	$tabs[] = array(
		'title'		=> $lang_admin['pop3gateway'],
		'link'		=> 'maintenance.php?action=pop3gateway&',
		'active'	=> $_REQUEST['action'] == 'pop3gateway'	
	);

/**
 * inactive users
 */
if($_REQUEST['action'] == 'inactive')
{
	//
	// form
	//
	if(!isset($_REQUEST['do']))
	{
		// assign
		$tpl->assign('groups', BMGroup::GetSimpleGroupList());
		$tpl->assign('page', 'maintenance.inactive.tpl');
	}
	
	//
	// exec
	//
	else if($_REQUEST['do'] == 'exec')
	{
		// conditions
		$condition = array();
		if(isset($_REQUEST['queryTypeLogin']))
		{
			$timeDiff = time() - max(1, $_REQUEST['loginDays']) * TIME_ONE_DAY;
			$condition[] = sprintf('(lastlogin<%d AND last_notify<%d AND last_pop3<%d AND last_imap<%d)',
				$timeDiff, $timeDiff, $timeDiff, $timeDiff);
		}
		if(isset($_REQUEST['queryTypeGroups'])
			&& isset($_REQUEST['groups'])
			&& is_array($_REQUEST['groups'])
			&& count($_REQUEST['groups']) > 0)
		{
			$condition[] = '(gruppe IN (' . implode(',', array_keys($_REQUEST['groups'])) . '))';
		}
		
		// conditions given?
		if(count($condition) == 0)
		{
			header('Location: maintenance.php?sid=' . session_id());
			exit();
		}
		$condition = 'WHERE ' . implode(' AND ', $condition);
		
		// update
		$affectedUsers = 0;
		$action = $_REQUEST['queryAction'];
		if($action == 'lock')
		{
			$db->Query('UPDATE {pre}users SET gesperrt=? ' . $condition,
				'yes');
			$affectedUsers = $db->AffectedRows();
		}
		else if($action == 'move')
		{
			$db->Query('UPDATE {pre}users SET gruppe=? ' . $condition,
				$_REQUEST['moveGroup']);
			$affectedUsers = $db->AffectedRows();
		}
		else if($action == 'delete')
		{
			$db->Query('UPDATE {pre}users SET gesperrt=? ' . $condition,
				'delete');
			$affectedUsers = $db->AffectedRows();
		}
		
		// assign
		$tpl->assign('msgTitle', $lang_admin['inactiveusers']);
		$tpl->assign('msgText', sprintf($lang_admin['activity_done'], $affectedUsers));
		$tpl->assign('msgIcon', 'info32');
		$tpl->assign('backLink', 'maintenance.php?');
		$tpl->assign('page', 'msg.tpl');
	}
}

/**
 * trash
 */
else if($_REQUEST['action'] == 'trash')
{
	//
	// form
	//
	if(!isset($_REQUEST['do']))
	{
		// assign
		$tpl->assign('groups', BMGroup::GetSimpleGroupList());
		$tpl->assign('page', 'maintenance.trash.tpl');
	}
	
	//
	// exec
	//
	else if($_REQUEST['do'] == 'exec')
	{
		if(!isset($_REQUEST['groups']) || !is_array($_REQUEST['groups'])
			|| count($_REQUEST['groups']) < 1)
		{
			header('Location: maintenance.php?action=trash&sid=' . session_id());
			exit();
		}
		
		// group list
		$mails = $mailSizes = 0;
		$res = $db->Query('SELECT id,email FROM {pre}users WHERE gruppe IN(' . implode(',', array_keys($_REQUEST['groups'])) . ')');
		while($row = $res->FetchArray(MYSQL_ASSOC))
		{
			$user = _new('BMUser', array($row['id']));
			$mailbox = _new('BMMailbox', array($row['id'], $row['email'], $user));
			
			$trashMails = $mailbox->GetMailList(FOLDER_TRASH);
			foreach($trashMails as $mailID=>$mail)
			{
				if((!isset($_REQUEST['daysOnly'])
					|| $mail['timestamp'] < time()-max(1, $_REQUEST['days'])*TIME_ONE_DAY)
					&& (!isset($_REQUEST['sizesOnly'])
						|| $mail['size'] > max(1, $_REQUEST['size']) * 1024))
				{
					// delete
					$mailbox->DeleteMail($mailID);
					
					// stats
					$mails++;
					$mailSizes += $mail['size'];
				}
			}
			
			unset($mailbox);
			unset($user);
		}
		$res->Free();
		
		// assign
		$tpl->assign('msgTitle', $lang_admin['trash']);
		$tpl->assign('msgText', sprintf($lang_admin['trash_done'], $mails, round($mailSizes/1024/1024, 2)));
		$tpl->assign('msgIcon', 'info32');
		$tpl->assign('backLink', 'maintenance.php?action=trash&');
		$tpl->assign('page', 'msg.tpl');
	}
}

/**
 * pop3 gateway
 */
else if($_REQUEST['action'] == 'pop3gateway')
{
	// fetch
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'fetch')
	{
		$perPage = max(isset($_REQUEST['perpage']) ? (int)$_REQUEST['perpage'] : 50, 1);
		if(!class_exists('BMPOP3Gateway'))
			include(B1GMAIL_REL . 'serverlib/pop3gateway.class.php');
		
		$pop3Gateway = _new('BMPOP3Gateway');
		list($mailCount, $processedMails) = $pop3Gateway->Run($perPage);
		
		if($mailCount == 0 || $mailCount == 0)
		{
			die('DONE');
		}
		else 
		{
			die($processedMails . '/' . $mailCount);
		}
	}
	
	// assign
	$tpl->assign('page', 'maintenance.pop3gateway.tpl');
}

$tpl->assign('tabs', $tabs);
$tpl->assign('title', $lang_admin['prefs'] . ' &raquo; ' . $lang_admin['maintenance']);
$tpl->display('page.tpl');
?>