<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: newsletter.php,v 1.10 2008/10/09 10:03:01 patrick Exp $
 *
 */

include('../serverlib/admin.inc.php');
include('../serverlib/mailbuilder.class.php');
RequestPrivileges(PRIVILEGES_ADMIN);

if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'newsletter';

$tabs = array(
	0 => array(
		'title'		=> $lang_admin['newsletter'],
		'link'		=> 'newsletter.php?',
		'active'	=> $_REQUEST['action'] == 'newsletter'
	)
);

if($_REQUEST['action'] == 'newsletter')
{
	//
	// form
	//
	if(!isset($_REQUEST['do']))
	{
		// assign
		$tpl->assign('from', sprintf('"%s - %s" <%s>',
			$bm_prefs['titel'],
			$lang_admin['team'],
			GetPostmasterMail()));
		$tpl->assign('groups', BMGroup::GetSimpleGroupList());
		$tpl->assign('usertpldir', B1GMAIL_REL . 'templates/' . $bm_prefs['template'] . '/');
		$tpl->assign('page', 'newsletter.tpl');
	}
	
	//
	// determine recipient count
	//
	else if($_REQUEST['do'] == 'determineRecipients')
	{
		$groups = ereg_replace('[^0-9,]', '', $_REQUEST['groups']);
		$sendto = $_REQUEST['sendto'];
		
		// status?
		$lockedValues 			= array();
		$statusActive 			= isset($_REQUEST['statusActive']);
		$statusLocked 			= isset($_REQUEST['statusLocked']);
		$statusNotActivated 	= isset($_REQUEST['statusNotActivated']);
		$statusDeleted 			= isset($_REQUEST['statusDeleted']);
		if($statusActive) 		$lockedValues[] = '\'no\'';
		if($statusLocked) 		$lockedValues[] = '\'yes\'';
		if($statusNotActivated) $lockedValues[] = '\'locked\'';
		
		// no groups or locked values?
		if(trim($groups) == '' || count($lockedValues) == 0)
			die('0');
		
		// determine count
		$res = $db->Query('SELECT COUNT(*) FROM {pre}users WHERE gesperrt IN(' . implode(',', $lockedValues) . ') AND gruppe IN(' . $groups . ')'
					. ($sendto == 'altmails' ? ' AND LENGTH(altmail)>3' : '')
					. ($bm_prefs['allow_newsletter_optout'] == 'yes' ? ' AND newsletter_optin=\'yes\'' : ''));
		list($recpCount) = $res->FetchArray(MYSQL_NUM);
		$res->Free();
		
		die($recpCount);
	}
	
	//
	// send initiator
	//
	else if($_REQUEST['do'] == 'send')
	{
		// groups?
		$groups = array();
		foreach($_POST as $key=>$val)
			if(substr($key, 0, 6) == 'group_')
				$groups[] = (int)substr($key, 6);
		
		// sendto?
		$sendto = $_REQUEST['sendto'];
		
		// status?
		$lockedValues 			= array();
		$statusActive 			= isset($_REQUEST['statusActive']);
		$statusLocked 			= isset($_REQUEST['statusLocked']);
		$statusNotActivated 	= isset($_REQUEST['statusNotActivated']);
		$statusDeleted 			= isset($_REQUEST['statusDeleted']);
		if($statusActive) 		$lockedValues[] = '\'no\'';
		if($statusLocked) 		$lockedValues[] = '\'yes\'';
		if($statusNotActivated) $lockedValues[] = '\'locked\'';
		
		// no groups or locked values?
		if(count($groups) == 0 || count($lockedValues) == 0)
			die('No recipients');
		
		// build condition
		$condition = 'gesperrt IN(' . implode(',', $lockedValues) . ') AND gruppe IN(' . implode(',', $groups) . ')'
			. ($sendto == 'altmails' ? ' AND LENGTH(altmail)>3' : '');
		if($bm_prefs['allow_newsletter_optout'] == 'yes')
			$condition .= ' AND newsletter_optin=\'yes\'';
		
		// determine count
		$res = $db->Query('SELECT COUNT(*) FROM {pre}users WHERE ' . $condition);
		list($recpCount) = $res->FetchArray(MYSQL_NUM);
		$res->Free();
		if($recpCount == 0)
			die('No recipients');
		
		// put newsletter info to array
		$newsletter = array(
			'from'			=> $_REQUEST['from'],
			'subject'		=> $_REQUEST['subject'],
			'priority'		=> $_REQUEST['priority'],
			'text'			=> $_REQUEST['emailText'],
			'textMode'		=> $_REQUEST['mode'],
			'sendto'		=> $sendto,
			'condition'		=> $condition,
			'recpCount'		=> $recpCount,
			'success'		=> 0,
			'failed'		=> 0
		);
		
		// save array to session
		if(!isset($_SESSION['newsletters']))
			$_SESSION['newsletters'] = array();
		$newsletterID = GenerateRandomKey('newsletter');
		$_SESSION['newsletters'][$newsletterID] = $newsletter;
	
		// assign
		$tpl->assign('id', $newsletterID);
		$tpl->assign('recpCount', $recpCount);
		$tpl->assign('perPage', max(1, (int)$_REQUEST['perpage']));
		$tpl->assign('page', 'newsletter.send.tpl');
	}
	
	//
	// send step
	//
	else if($_REQUEST['do'] == 'sendStep'
		&& isset($_REQUEST['id'])
		&& isset($_REQUEST['perpage'])
		&& isset($_REQUEST['pos']))
	{
		// check input
		$id = $_REQUEST['id'];
		if(!isset($_SESSION['newsletters']) || !isset($_SESSION['newsletters'][$id]))
			die('DONE');
		
		// get newsletter data
		$newsletter = $_SESSION['newsletters'][$id];
		
		// position
		$pos = (int)$_REQUEST['pos'];
		
		// get count
		$res = $db->Query('SELECT COUNT(*) FROM {pre}users WHERE ' . $newsletter['condition']);
		list($count) = $res->FetchArray(MYSQL_NUM);
		$res->Free();
		
		if($pos >= $count)
		{
			die('DONE');
		}
		else 
		{
			// select recipients
			$res = $db->Query('SELECT id,email,altmail,vorname,nachname FROM {pre}users WHERE '
				. $newsletter['condition'] . ' ORDER BY id ASC LIMIT ' . $pos . ',' . max(1, (int)$_REQUEST['perpage']));
			while($row = $res->FetchArray(MYSQL_ASSOC))
			{
				$to = $newsletter['sendto'] == 'altmails' ? $row['altmail'] : $row['email'];

				// create text
				$text = $newsletter['text'];
				$text = str_replace('%%email%%', 		$row['email'], 		$text);
				$text = str_replace('%%firstname%%', 	$row['vorname'], 	$text);
				$text = str_replace('%%lastname%%', 	$row['nachname'], 	$text);
				
				// create mail
				$mail = _new('BMMailBuilder', array(true));
				$mail->AddHeaderField('From',		$newsletter['from']);
				$mail->AddHeaderField('To',			$to);
				$mail->AddHeaderField('Subject',	$newsletter['subject']);
				
				// priority
				if($newsletter['priority'] != 0)
				{
					$mail->AddHeaderField('X-Priority', $newsletter['priority'] == ITEMPRIO_HIGH
						? 1
						: ($newsletter['priority'] == ITEMPRIO_LOW
							? 5
							: 3));
				}
				
				// text
				$mail->AddText($text,
					$newsletter['textMode'] == 'html' ? 'html' : 'plain',
					$currentCharset);
			
				// send
				$result = $mail->Send() !== false;
				$mail->CleanUp();
				
				// stats
				if($result)
					$_SESSION['newsletters'][$id]['success']++;
				else
					$_SESSION['newsletters'][$id]['failed']++;
				
				$pos++;
			}
			$res->Free();
			
			if($pos >= $count)
				die('DONE');
			else 
				die($pos . '/' . $count);
		}
	}
	
	//
	// done
	//
	else if($_REQUEST['do'] == 'done'
		&& isset($_REQUEST['id'])
		&& isset($_SESSION['newsletters'])
		&& isset($_SESSION['newsletters'][$_REQUEST['id']]))
	{
		// remove entry from session
		$newsletter = $_SESSION['newsletters'][$_REQUEST['id']];
		unset($_SESSION['newsletters'][$_REQUEST['id']]);
		
		// assign
		$tpl->assign('msgTitle', $lang_admin['newsletter']);
		$tpl->assign('msgText', sprintf($lang_admin['newsletter_done'], $newsletter['success'], $newsletter['failed']));
		$tpl->assign('msgIcon', 'info32');
		$tpl->assign('backLink', 'newsletter.php?');
		$tpl->assign('page', 'msg.tpl');
	}
}

$tpl->assign('tabs', $tabs);
$tpl->assign('title', $lang_admin['usersgroups'] . ' &raquo; ' . $lang_admin['newsletter']);
$tpl->display('page.tpl');
?>