<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: optimize.php,v 1.16 2007/12/24 10:45:15 patrick Exp $
 *
 */

include('../serverlib/admin.inc.php');
RequestPrivileges(PRIVILEGES_ADMIN);

if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'db';

$tabs = array(
	0 => array(
		'title'		=> $lang_admin['db'],
		'link'		=> 'optimize.php?',
		'active'	=> $_REQUEST['action'] == 'db'
	),
	1 => array(
		'title'		=> $lang_admin['filesystem'],
		'link'		=> 'optimize.php?action=filesystem&',
		'active'	=> $_REQUEST['action'] == 'filesystem'
	),
	2 => array(
		'title'		=> $lang_admin['cache'],
		'link'		=> 'optimize.php?action=cache&',
		'active'	=> $_REQUEST['action'] == 'cache'
	)
);

/**
 * optimize DB
 */
if($_REQUEST['action'] == 'db')
{
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'execute')
	{
		if($_REQUEST['operation'] == 'struct')
		{
			// read default structure
			include('../serverlib/database.struct.php');
			$databaseStructure = unserialize(base64_decode($databaseStructure));
			
			// get tables
			$defaultTables = array();
			$res = $db->Query('SHOW TABLES');
			while($row = $res->FetchArray(MYSQL_NUM))
				$myTables[] = $row[0];
			$res->Free();
			
			// compare tables
			$result = array();
			$repair = false;
			foreach($databaseStructure as $tableName=>$tableInfo)
			{
				$tableFields = $tableInfo['fields'];
				$tableIndexes = $tableInfo['indexes'];
				
				$tableResult = array();
				$tableResult['table'] = $tableName;
				$tableResult['exists'] = false;
				$tableResult['missing'] = 0;
				$tableResult['invalid'] = 0;
				
				if(in_array($tableName, $myTables))
				{
					$tableResult['exists'] = true;
					
					// get my fields
					$myFields = array();
					$res = $db->Query('SHOW FIELDS FROM ' . $tableName);
					while($row = $res->FetchArray(MYSQL_ASSOC))
					{
						if($row['Null'] == '') $row['Null'] = 'NO';
						$myFields[$row['Field']] = array($row['Field'], $row['Type'], $row['Null'], $row['Key'], $row['Default'], $row['Extra']);
					}
					$res->Free();
					
					// get my indexes
					$myIndexes = array();
					$res = $db->Query('SHOW INDEX FROM ' . $tableName);
					while($row = $res->FetchArray(MYSQL_ASSOC))
						if(isset($myIndexes[$row['Key_name']]))
							$myIndexes[$row['Key_name']][] = $row['Column_name'];
						else 
							$myIndexes[$row['Key_name']] = array($row['Column_name']);
					$res->Free();
					
					// compare fields
					foreach($tableFields as $field)
					{
						if(!isset($myFields[$field[0]]))
							$tableResult['missing']++;
						else
						{
							$myField = $myFields[$field[0]];
							if($myField[1] != $field[1]
								|| $myField[2] != $field[2]
								|| ($myField[4] != $field[4] && !(($myField[4]==0 && $field[4]=='') || ($myField[4]=='' && $field[4]==0)))
								|| $myField[5] != $field[5])
								$tableResult['invalid']++;
						}
					}
					
					// compare indexes
					foreach($tableIndexes as $indexName=>$indexFields)
					{
						if(!isset($myIndexes[$indexName]))
							$tableResult['missing']++;
						else if($myIndexes[$indexName] != $indexFields)
							$tableResult['invalid']++;
					}
				}
				
				if(!$tableResult['exists'] || $tableResult['missing'] > 0 || $tableResult['invalid'] > 0)
					$repair = true;
				
				$result[] = $tableResult;
			}
			
			$tpl->assign('repair', $repair);
			$tpl->assign('result', $result);
			$tpl->assign('executeStruct', true);
		}
		else 
		{
			$op = $_REQUEST['operation'] == 'optimize'
					? 'OPTIMIZE TABLE '
					: 'REPAIR TABLE ';
			$result = array();
			
			foreach($_POST['tables'] as $table)
			{
				$res = $db->Query($op . $table);
				if($res)
				{
					$row = $res->FetchArray();
					$res->Free();
					
					$result[] = array(
						'table'		=> $table,
						'type'		=> $row['Msg_type'],
						'status'	=> $row['Msg_text'],
						'query'		=> $op  . $table
					);
				}
				else 
				{
					$result[] = array(
						'table'		=> $table,
						'type'		=> 'error',
						'query'		=> $op  . $table
					);				
				}
			}
			
			$tpl->assign('result', $result);
			$tpl->assign('execute', true);
		}
		
		// assign
		$tpl->assign('page', 'optimize.db.tpl');
	}
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'repairStruct')
	{
		// read default structure
		include('../serverlib/database.struct.php');
		$databaseStructure = unserialize(base64_decode($databaseStructure));
		$executedQueries = SyncDBStruct($databaseStructure);
		
		// assign
		$tpl->assign('backLink', 'optimize.php?');
		$tpl->assign('msgIcon', 'info32');
		$tpl->assign('msgTitle', $lang_admin['repairstruct']);
		$tpl->assign('msgText', $lang_admin['repairdone']);
		$tpl->assign('page', 'msg.tpl');
	}
	else 
	{
		$tables = array();
		$res = $db->Query('SHOW TABLES');
		while($row = $res->FetchArray(MYSQL_NUM))
			if(substr($row[0], 0, strlen($mysql['prefix'])) == $mysql['prefix'])
				$tables[] = $row[0];
		
		// assign
		$tpl->assign('tables', $tables);
		$tpl->assign('page', 'optimize.db.tpl');
	}
}

/**
 * optimize filesystem
 */
else if($_REQUEST['action'] == 'filesystem')
{
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'cleanupTempFiles')
	{
		CleanupTempFiles();
	}
	
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'updateMailStorage'
		&& isset($_REQUEST['perpage']) && isset($_REQUEST['pos']))
	{
		$perPage = (int)$_REQUEST['perpage'];
		$pos = (int)$_REQUEST['pos'];
		
		$res = $db->Query('SELECT COUNT(*) FROM {pre}mails');
		list($count) = $res->FetchArray(MYSQL_NUM);
		$res->Free();
		
		if($pos >= $count)
		{
			die('DONE');
		}
		else 
		{
			$res = $db->Query('SELECT id,body FROM {pre}mails ORDER BY id DESC LIMIT ' 
								. (int)$pos . ',' . (int)$perPage);
			while($row = $res->FetchArray())
			{
				$dataFileName = DataFilename($row['id'], 'msg');
				
				if($bm_prefs['storein'] == 'file'
					&& $row['body'] != 'file')
				{
					if($fp = fopen($dataFileName, 'wb'))
					{
						fwrite($fp, $row['body']);
						fclose($fp);
						
						$db->Query('UPDATE {pre}mails SET body=? WHERE id=?',
							'file',
							$row['id']);
					}
				}
				
				else if($bm_prefs['storein'] == 'db'
						&& $row['body'] == 'file')
				{
					if(file_exists($dataFileName)
						&& filesize($dataFileName) <= MAIL_DB_MAX)
					{
						$contents = getFileContents($dataFileName);
						if($contents !== false)
						{
							$db->Query('UPDATE {pre}mails SET body=? WHERE id=?',
								$contents,
								$row['id']);
							if($db->AffectedRows() == 1)
								unlink($dataFileName);
						}
					}
				}
				
				$pos++;
			}
			$res->Free();
			
			if($pos >= $count)
				die('DONE');
			else 
				die($pos . '/' . $count);
		}
	}
	
	//
	// temp files
	//
	$tempFileCount = 0;
	$tempFileSize = 0;
	$res = $db->Query('SELECT id FROM {pre}tempfiles');
	while($row = $res->FetchArray())
	{
		$tempFileCount++;
		$fileName = TempFileName($row['id']);
		$tempFileSize += @filesize($fileName);
	}
	$res->Free();
	
	$tpl->assign('tempFileCount', $tempFileCount);
	$tpl->assign('tempFileSize', $tempFileSize);
	$tpl->assign('msTitle', $bm_prefs['storein'] == 'db' ? $lang_admin['file2db'] : $lang_admin['db2file']);
	$tpl->assign('msDesc', $bm_prefs['storein'] == 'db' ? $lang_admin['file2db_desc'] : $lang_admin['db2file_desc']);
	$tpl->assign('page', 'optimize.filesystem.tpl');
}

/**
 * optimize caches
 */
else if($_REQUEST['action'] == 'cache')
{
	//
	// empty file cache
	//
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'cleanupFileCache'
		&& $bm_prefs['cache_type'] == CACHE_B1GMAIL)
	{
		$cacheManager->CleanUp(true);
	}
	
	//
	// rebuild caches
	//
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'rebuild'
		&& isset($_REQUEST['perpage']) && isset($_REQUEST['pos']))
	{
		$perpage = (int)$_REQUEST['perpage'];
		$pos = (int)$_REQUEST['pos'];
	
		//
		// rebuild mailsizes
		//
		if($_REQUEST['rebuild'] == 'mailsizes')
		{
			$res = $db->Query('SELECT COUNT(*) FROM {pre}mails');
			list($count) = $res->FetchArray(MYSQL_NUM);
			$res->Free();
			
			if($pos >= $count)
			{
				die('DONE');
			}
			else 
			{
				$res = $db->Query('SELECT id,size,LENGTH(body) AS bodylength FROM {pre}mails ORDER BY id DESC LIMIT ' 
									. (int)$pos . ',' . (int)$perpage);
				while($row = $res->FetchArray())
				{
					$cachedSize = $row['size'];
					
					if($row['bodylength'] == 4)
					{
						// file mail
						$fileName = DataFilename($row['id'], 'msg');
						if(file_exists($fileName))
							$actualSize = filesize($fileName);
						else 
							$actualSize = 4;
					}
					else 
					{
						// db mail
						$actualSize = (int)$row['bodylength'];
					}
					
					if($actualSize != $cachedSize)
						$db->Query('UPDATE {pre}mails SET size=? WHERE id=?',
							$actualSize,
							$row['id']);
					
					$pos++;
				}
				$res->Free();
				
				if($pos >= $count)
					die('DONE');
				else 
					die($pos . '/' . $count);
			}
		}
		
		//
		// rebuild disk sizes
		//
		else if($_REQUEST['rebuild'] == 'disksizes')
		{
			$res = $db->Query('SELECT COUNT(*) FROM {pre}diskfiles');
			list($count) = $res->FetchArray(MYSQL_NUM);
			$res->Free();
			
			if($pos >= $count)
			{
				die('DONE');
			}
			else 
			{
				$res = $db->Query('SELECT id,size FROM {pre}diskfiles ORDER BY id DESC LIMIT ' 
									. (int)$pos . ',' . (int)$perpage);
				while($row = $res->FetchArray())
				{
					$cachedSize = $row['size'];
					
					$fileName = DataFilename($row['id'], 'dsk');
					if(file_exists($fileName))
						$actualSize = filesize($fileName);
					else 
						$actualSize = 0;
					
					if($actualSize != $cachedSize)
						$db->Query('UPDATE {pre}diskfiles SET size=? WHERE id=?',
							$actualSize,
							$row['id']);
					
					$pos++;
				}
				$res->Free();
				
				if($pos >= $count)
					die('DONE');
				else 
					die($pos . '/' . $count);
			}
		}
		
		//
		// rebuild user sizes
		//
		else if($_REQUEST['rebuild'] == 'usersizes')
		{
			$res = $db->Query('SELECT COUNT(*) FROM {pre}users');
			list($count) = $res->FetchArray(MYSQL_NUM);
			$res->Free();
			
			if($pos >= $count)
			{
				die('DONE');
			}
			else 
			{
				$res = $db->Query('SELECT id,email,mailspace_used,diskspace_used FROM {pre}users ORDER BY id DESC LIMIT ' 
									. (int)$pos . ',' . (int)$perpage);
				while($row = $res->FetchArray())
				{
					$cachedMailSize = $row['mailspace_used'];
					$cachedDiskSize = $row['diskspace_used'];
					
					$res2 = $db->Query('SELECT SUM(size) FROM {pre}mails WHERE userid=?',
						$row['id']);
					list($actualMailSize) = $res2->FetchArray(MYSQL_NUM);
					$res2->Free();
					
					$res2 = $db->Query('SELECT SUM(size) FROM {pre}diskfiles WHERE user=?',
						$row['id']);
					list($actualDiskSize) = $res2->FetchArray(MYSQL_NUM);
					$res2->Free();
					
					if($actualDiskSize != $cachedDiskSize 
						|| $actualMailSize != $cachedMailSize)
						$db->Query('UPDATE {pre}users SET mailspace_used=?,diskspace_used=? WHERE id=?',
							$actualMailSize,
							$actualDiskSize,
							$row['id']);
					
					$pos++;
				}
				$res->Free();
				
				if($pos >= $count)
					die('DONE');
				else 
					die($pos . '/' . $count);
			}
		}
	}
	
	// retrieve cache info
	$res = $db->Query('SELECT COUNT(*),SUM(size) FROM {pre}file_cache');
	list($cacheFileCount, $cacheFileSize) = $res->FetchArray(MYSQL_NUM);
	$res->Free();
	
	// assign
	$tpl->assign('fileCache', $bm_prefs['cache_type'] == CACHE_B1GMAIL);
	$tpl->assign('cacheFileCount', $cacheFileCount);
	$tpl->assign('cacheFileSize', $cacheFileSize);
	$tpl->assign('page', 'optimize.cache.tpl');
}

$tpl->assign('tabs', $tabs);
$tpl->assign('title', $lang_admin['tools'] . ' &raquo; ' . $lang_admin['optimize']);
$tpl->display('page.tpl');
?>