<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: plugins.php,v 1.13 2009/02/18 11:24:39 patrick Exp $
 *
 */

include('../serverlib/admin.inc.php');
RequestPrivileges(PRIVILEGES_ADMIN);

if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'plugins';

$tabs = array(
	0 => array(
		'title'		=> $lang_admin['plugins'],
		'link'		=> 'plugins.php?',
		'active'	=> $_REQUEST['action'] == 'plugins'
	),
	1 => array(
		'title'		=> $lang_admin['widgets'],
		'link'		=> 'plugins.php?action=widgets&',
		'active'	=> $_REQUEST['action'] == 'widgets'
	),
	2 => array(
		'title'		=> $lang_admin['install'],
		'link'		=> 'plugins.php?action=install&',
		'active'	=> $_REQUEST['action'] == 'install'
	)
);

/**
 * plugins/widgets
 */
if($_REQUEST['action'] == 'plugins'
	|| $_REQUEST['action'] == 'widgets')
{
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'activatePlugin'
		&& isset($_REQUEST['plugin']) && isset($plugins->_inactivePlugins[$_REQUEST['plugin']]))
	{
		$plugins->activatePlugin($_REQUEST['plugin']);
		$tpl->assign('reloadMenu', true);
	}
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'deactivatePlugin'
		&& isset($_REQUEST['plugin']) && isset($plugins->_plugins[$_REQUEST['plugin']]))
	{
		$plugins->deactivatePlugin($_REQUEST['plugin']);
		$tpl->assign('reloadMenu', true);
	}
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'deletePackage'
		&& isset($_REQUEST['package']) && strlen($_REQUEST['package']) == 32)
	{
		BMPluginPackage::Uninstall($_REQUEST['package']);
		$tpl->assign('reloadMenu', true);
	}
	
	$pluginList = array();
	
	// build plugin list
	foreach($plugins->_plugins as $className=>$pluginInfo)
	{
		if(($_REQUEST['action'] == 'plugins' && ($plugins->getParam('type', $className) == BMPLUGIN_DEFAULT
													|| $plugins->getParam('type', $className) == BMPLUGIN_FILTER))
			|| ($_REQUEST['action'] == 'widgets' && $plugins->getParam('type', $className) == BMPLUGIN_WIDGET))
		{
			if(!isset($pluginList[$pluginInfo['signature']]))
				$pluginList[$pluginInfo['signature']] = array(
					'name'		=> $pluginInfo['packageName'],
					'plugins'	=> array()
				);
			$pluginList[$pluginInfo['signature']]['plugins'][] = array(
				'name'		=> $className,
				'title'		=> $plugins->getParam('name', $className),
				'version'	=> $plugins->getParam('version', $className),
				'author'	=> $plugins->getParam('author', $className),
				'type'		=> $pluginTypeTable[$plugins->getParam('type', $className)],
				'installed'	=> true
			);
		}
	}
	foreach($plugins->_inactivePlugins as $className=>$pluginInfo)
	{
		if(($_REQUEST['action'] == 'plugins' && ($pluginInfo['type'] == BMPLUGIN_DEFAULT
													|| $pluginInfo['type'] == BMPLUGIN_FILTER))
			|| ($_REQUEST['action'] == 'widgets' && $pluginInfo['type'] == BMPLUGIN_WIDGET))
		{
			if(!isset($pluginList[$pluginInfo['signature']]))
				$pluginList[$pluginInfo['signature']] = array(
					'name'		=> $pluginInfo['packageName'],
					'plugins'	=> array()
				);
			$pluginList[$pluginInfo['signature']]['plugins'][] = array(
				'name'		=> $className,
				'title'		=> $pluginInfo['name'],
				'version'	=> $pluginInfo['version'],
				'author'	=> $pluginInfo['author'],
				'type'		=> $pluginTypeTable[$pluginInfo['type']],
				'installed'	=> false
			);
		}
	}
	
	$tpl->assign('action', $_REQUEST['action']);
	$tpl->assign('plugins', $pluginList);
	$tpl->assign('page', 'plugins.list.tpl');
}

/**
 * install
 */
else if($_REQUEST['action'] == 'install')
{
	//
	// form
	//
	if(!isset($_REQUEST['do']))
	{
		$tpl->assign('page', 'plugins.install.tpl');
	}
	
	//
	// upload
	//
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'uploadPlugin')
	{
		$formatError = true;
		
		if(isset($_FILES['package']) && $_FILES['package']['error'] == 0
			&& $_FILES['package']['size'] > 0)
		{
			// request temp file
			$tempFileID = RequestTempFile(0);
			$tempFileName = TempFileName($tempFileID);
			
			// move file
			$fileName = $_FILES['package']['name'];
			move_uploaded_file($_FILES['package']['tmp_name'], $tempFileName);
			
			// open file
			$package = _new('BMPluginPackage', array($fp = fopen($tempFileName, 'rb')));
			if($package->ParseFile())
			{
				$formatError = false;
				$tpl->assign('id', 				$tempFileID);
				$tpl->assign('meta', 			$package->metaInfo);
				$tpl->assign('signature', 		$package->signature);
				$tpl->assign('versionsMatch', 	$package->metaInfo['for_b1gmail'] == B1GMAIL_VERSION);
				$tpl->assign('b1gmailVersion',	B1GMAIL_VERSION);
				$tpl->assign('page', 			'plugin.install.info.tpl');
			}
			
			// close file
			fclose($fp);
		}
		
		// invalid file => message
		if($formatError)
		{
			$tpl->assign('msgTitle', $lang_admin['install']);
			$tpl->assign('msgText', $lang_admin['plugin_formaterr']);
			$tpl->assign('msgIcon', 'error32');
			$tpl->assign('backLink', 'plugins.php?action=install&');
			$tpl->assign('page', 'msg.tpl');
		}
	}
	
	//
	// install
	//
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'installPlugin'
		&& isset($_REQUEST['id']) && ValidTempFile(0, (int)$_REQUEST['id']))
	{
		if(isset($_REQUEST['step']))
			$step = max(1, min(2, (int)$_REQUEST['step']));
		else
			$step = 1;
		
		$id = (int)$_REQUEST['id'];
		$tempFileName = TempFileName($id);
		
		// open file
		$package = _new('BMPluginPackage', array($fp = fopen($tempFileName, 'rb')));
		if($package->ParseFile())
		{
			if($step == 1)
			{
				if($package->InstallStep1())
				{
					$url = sprintf('plugins.php?action=install&do=installPlugin&id=%d&step=2&sid=%s',
						$id,
						session_id());
					header('Location: ' . $url);
					fclose($fp);
					exit();
				}
				else
				{
					$tpl->assign('msgTitle', $lang_admin['install']);
					$tpl->assign('msgText', $lang_admin['plugin_insterr']);
					$tpl->assign('msgIcon', 'error32');
					$tpl->assign('backLink', 'plugins.php?action=install&');
					$tpl->assign('page', 'msg.tpl');
					fclose($fp);
					ReleaseTempFile(0, $id);
				}
			}
			
			else if($step == 2)
			{
				if($package->InstallStep2())
				{
					$tpl->assign('reloadMenu', true);
					$tpl->assign('msgTitle', $lang_admin['install']);
					$tpl->assign('msgText', $lang_admin['plugin_installed']);
					$tpl->assign('msgIcon', 'info32');
					$tpl->assign('backLink', 'plugins.php?');
					$tpl->assign('page', 'msg.tpl');
				}
				else 
				{
					$tpl->assign('msgTitle', $lang_admin['install']);
					$tpl->assign('msgText', $lang_admin['plugin_insterr']);
					$tpl->assign('msgIcon', 'error32');
					$tpl->assign('backLink', 'plugins.php?action=install&');
					$tpl->assign('page', 'msg.tpl');
				}
				
				// close and release file
				fclose($fp);
				ReleaseTempFile(0, $id);
			}
		}
	}
}

$tpl->assign('tabs', $tabs);
$tpl->assign('title', $lang_admin['plugins'] . ' &raquo; ' . $lang_admin['plugins']);
$tpl->display('page.tpl');
?>