<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: prefs.common.php,v 1.29 2009/02/02 11:12:42 patrick Exp $
 *
 */

include('../serverlib/admin.inc.php');
RequestPrivileges(PRIVILEGES_ADMIN);

if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'common';

$tabs = array(
	0 => array(
		'title'		=> $lang_admin['common'],
		'link'		=> 'prefs.common.php?',
		'active'	=> $_REQUEST['action'] == 'common'
	),
	1 => array(
		'title'		=> $lang_admin['caching'],
		'link'		=> 'prefs.common.php?action=caching&',
		'active'	=> $_REQUEST['action'] == 'caching'
	),
	2 => array(
		'title'		=> $lang_admin['signup'],
		'link'		=> 'prefs.common.php?action=signup&',
		'active'	=> $_REQUEST['action'] == 'signup'
	),
	3 => array(
		'title'		=> $lang_admin['lockedusernames'],
		'link'		=> 'prefs.common.php?action=lockedusernames&',
		'active'	=> $_REQUEST['action'] == 'lockedusernames'
	),
	4 => array(
		'title'		=> $lang_admin['license'],
		'link'		=> 'prefs.common.php?action=license&',
		'active'	=> $_REQUEST['action'] == 'license'
	)
);

/**
 * common
 */
if($_REQUEST['action'] == 'common')
{
	if(isset($_REQUEST['save'])
		&& isset($_REQUEST['titel'])
		&& isset($_REQUEST['template'])
		&& isset($_REQUEST['language'])
		&& isset($_REQUEST['adminpw']))
	{
		$domainsArray = explode("\n", $_REQUEST['domains']);
		foreach($domainsArray as $key=>$val)
			if(($val = trim($val)) != '')
				$domainsArray[$key] = $val;
			else 
				unset($domainsArray[$key]);
		$domains = implode(':', $domainsArray);
		
		// trailing slashes
		if(substr($_REQUEST['selfurl'], -1) != '/')
			$_REQUEST['selfurl'] .= '/';
		if(substr($_REQUEST['datafolder'], -1) != '/')
			$_REQUEST['datafolder'] .= '/';
		if(trim($_REQUEST['ssl_url']) !=  ''
			&& substr($_REQUEST['ssl_url'], -1) != '/')
			$_REQUEST['ssl_url'] .= '/';
		
		$db->Query('UPDATE {pre}prefs SET titel=?, domains=?, b1gmta_host=?, selfurl=?, search_engine=?, datafolder=?, adminpw=?, language=?, template=?, std_land=?, datumsformat=?, ordner_proseite=?, gut_regged=?, autocancel=?, wartung=?, structstorage=?, cron_interval=?, logouturl=?, scsf=?, contact_history=?, ip_lock=?, cookie_lock=?, allow_newsletter_optout=?, domain_combobox=?, ssl_url=?, ssl_login_option=?, ssl_login_enable=?',
			$_REQUEST['titel'],
			$domains,
			$_REQUEST['b1gmta_host'],
			$_REQUEST['selfurl'],
			$_REQUEST['search_engine'],
			$_REQUEST['datafolder'],
			$_REQUEST['adminpw'],
			$_REQUEST['language'],
			$_REQUEST['template'],
			$_REQUEST['std_land'],
			$_REQUEST['datumsformat'],
			$_REQUEST['ordner_proseite'],
			isset($_REQUEST['gut_regged']) ? 'yes' : 'no',
			isset($_REQUEST['autocancel']) ? 'yes' : 'no',
			isset($_REQUEST['wartung']) ? 'yes' : 'no',
			isset($_REQUEST['structstorage']) ? 'yes' : 'no',
			$_REQUEST['cron_interval'],
			$_REQUEST['logouturl'],
			max(1, min(10, $_REQUEST['scsf'])),
			isset($_REQUEST['contact_history']) ? 'yes' : 'no',
			isset($_REQUEST['ip_lock']) ? 'yes' : 'no',
			isset($_REQUEST['cookie_lock']) ? 'yes' : 'no',
			isset($_REQUEST['allow_newsletter_optout']) ? 'yes' : 'no',
			isset($_REQUEST['domain_combobox']) ? 'yes' : 'no',
			$_REQUEST['ssl_url'],
			isset($_REQUEST['ssl_login_option']) ? 'yes' : 'no',
			isset($_REQUEST['ssl_login_enable']) ? 'yes' : 'no');
		ReadConfig();
		
		$_SESSION['bm_adminAuth']		= md5(md5($_REQUEST['adminpw']) . $_SERVER['HTTP_USER_AGENT']);
		$_SESSION['bm_sessionToken'] 	= SessionToken();
	}
	
	// get available languages
	$languages = GetAvailableLanguages();
	$templates = GetAvailableTemplates();
	$countries = CountryList();
	
	// assign
	$bm_prefs['domains'] = str_replace(':', "\n", $bm_prefs['domains']);
	$tpl->assign('safemode',  ini_get('safe_mode'));
	$tpl->assign('languages', $languages);
	$tpl->assign('templates', $templates);
	$tpl->assign('countries', CountryList());
	$tpl->assign('page', 'prefs.common.tpl');
}

/**
 * caching
 */
else if($_REQUEST['action'] == 'caching')
{
	if(isset($_REQUEST['save']))
	{
		$serversArray = explode("\n", $_REQUEST['memcache_servers']);
		foreach($serversArray as $key=>$val)
			if(($val = trim($val)) != '')
				$serversArray[$key] = $val;
			else 
				unset($serversArray[$key]);
		$servers = implode(';', $serversArray);
		
		$db->Query('UPDATE {pre}prefs SET cache_type=?, filecache_size=?, memcache_servers=?, memcache_persistent=?, cache_parseonly=?',
			(int)$_REQUEST['cache_type'],
			$_REQUEST['filecache_size']*1024*1024,
			$servers,
			isset($_REQUEST['memcache_persistent']) ? 'yes' : 'no',
			isset($_REQUEST['cache_parseonly']) ? 'yes' : 'no');
		ReadConfig();
	}
	
	// assign
	$bm_prefs['memcache_servers'] = str_replace(';', "\n", $bm_prefs['memcache_servers']);
	$tpl->assign('memcache', class_exists('Memcache'));
	$tpl->assign('page', 'prefs.caching.tpl');
}

/**
 * signup
 */
else if($_REQUEST['action'] == 'signup')
{
	if(isset($_REQUEST['save']))
	{
		$db->Query('UPDATE {pre}prefs SET regenabled=?, usr_status=?, std_gruppe=?, minuserlength=?, notify_mail=?, welcome_mail=?, notify_to=?, f_strasse=?, f_telefon=?, f_fax=?, f_alternativ=?, f_mail2sms_nummer=?, f_safecode=?, reg_iplock=?, plz_check=?, alt_check=?, user_count_limit=?',
			isset($_REQUEST['regenabled']) ? 'yes' : 'no',
			$_REQUEST['usr_status'],
			$_REQUEST['std_gruppe'],
			$_REQUEST['minuserlength'],
			isset($_REQUEST['notify_mail']) ? 'yes' : 'no',
			isset($_REQUEST['welcome_mail']) ? 'yes' : 'no',
			$_REQUEST['notify_to'],
			$_REQUEST['f_strasse'],
			$_REQUEST['f_telefon'],
			$_REQUEST['f_fax'],
			$_REQUEST['f_alternativ'],
			$_REQUEST['f_mail2sms_nummer'],
			$_REQUEST['f_safecode'],
			$_REQUEST['reg_iplock'],
			isset($_REQUEST['plz_check']) ? 'yes' : 'no',
			isset($_REQUEST['alt_check']) ? 'yes' : 'no',
			isset($_REQUEST['user_count_limit_enable']) ? $_REQUEST['user_count_limit'] : 0);
		ReadConfig();
	}
	
	// assign
	$tpl->assign('groups', BMGroup::GetSimpleGroupList());
	$tpl->assign('page', 'prefs.signup.tpl');
}

/**
 * locked usernames
 */
else if($_REQUEST['action'] == 'lockedusernames')
{
	// delete?
	if(isset($_REQUEST['delete']))
	{
		$db->Query('DELETE FROM {pre}locked WHERE id=?',
			(int)$_REQUEST['delete']);
	}
	
	// add?
	else if(isset($_REQUEST['add'])
		&& trim($_REQUEST['benutzername']) != '')
	{
		$db->Query('INSERT INTO {pre}locked(typ,benutzername) VALUES(?,?)',
			$_REQUEST['typ'],
			$_REQUEST['benutzername']);
	}
	
	// mass action?
	else if(isset($_REQUEST['executeMassAction']))
	{
		// get locked username IDs
		$lockedIDs = array();
		foreach($_POST as $key=>$val)
			if(substr($key, 0, 7) == 'locked_')
				$lockedIDs[] = (int)substr($key, 7);
		
		if(count($lockedIDs) > 0)
		{
			if($_REQUEST['massAction'] == 'delete')
			{
				// delete row
				$db->Query('DELETE FROM {pre}locked WHERE id IN(' . implode(',', $lockedIDs) . ')');
			}
		}
	}
	
	// fetch
	$lockedUsernames = array();
	$res = $db->Query('SELECT id,typ,benutzername FROM {pre}locked ORDER BY typ,benutzername ASC');
	while($row = $res->FetchArray(MYSQL_ASSOC))
	{
		$lockedUsernames[$row['id']] = array(
			'id'		=> $row['id'],
			'type'		=> $lockedTypeTable[$row['typ']],
			'username'	=> $row['benutzername']
		);
	}
	$res->Free();
	
	// assign
	$tpl->assign('lockedUsernames', $lockedUsernames);
	$tpl->assign('lockedTypeTable', $lockedTypeTable);
	$tpl->assign('page', 'prefs.lockedusernames.tpl');
}

/**
 * license
 */
else if($_REQUEST['action'] == 'license')
{
	$tpl->assign('page', 'prefs.license.tpl');

	/**
	 * IMPORTANT INFORMATION ABOUT B1GMAIL LICENSING
	 * 
	 * We do know that it is easy to circumvent the following licensing checks.
	 * It is easy to remove the whole check or to write key-generators for
	 * our serial numbers.
	 * 
	 * It is that easy because we do not believe in encrypting or compiling our
	 * PHP source code because we want to give our customers as much flexibility
	 * as possible and because we want to make enhancements like hacks and plugins
	 * possible.
	 * 
	 * We trust in you to be honest and to buy a license if you use b1gMail.
	 * By doing so, you are not only ensuring the further development of b1gMail.
	 * By owning a valid license, you get many benefits, like free E-Mail support,
	 * access to the latest extensions, updates, patches and important security
	 * updates and the ability to have influence in new releases.
	 * 
	 * Thanks for your support and for making b1gMail possible!
	 * 
	 * The b1gMail team
	 */
	if(isset($_REQUEST['save']))
	{
		$serial = array(strtoupper($_REQUEST['serial_1']),
						strtoupper($_REQUEST['serial_2']),
						strtoupper($_REQUEST['serial_3']),
						strtoupper($_REQUEST['serial_4']));
		$check = strtoupper(md5($serial[1] . $serial[0] . $serial[2]));
		if(strlen(implode('-', $serial)) != 19
			|| $serial[3][0] != $check[5]
			|| $serial[3][1] != $check[23]
			|| $serial[3][2] != $check[8]
			|| $serial[3][3] != $check[31])
		{
			$tpl->assign('msgTitle',		$lang_admin['license']);
			$tpl->assign('msgText',			$lang_admin['invalidserial']);
			$tpl->assign('msgIcon',			'error32');
			$tpl->assign('page',			'msg.tpl');
		}
		else 
		{
			$serial = implode('-', $serial);
			$db->Query('UPDATE {pre}prefs SET serial=?',
				$serial);
			ReadConfig();
		}
	}
	
	// assign
	$serial = explode('-', $bm_prefs['serial']);
	$tpl->assign('version', 		B1GMAIL_VERSION);
	$tpl->assign('licenseDomain', 	B1GMAIL_LICDOMAIN);
	$tpl->assign('licenseNo', 		B1GMAIL_LICNR);
	$tpl->assign('licenseDate', 	B1GMAIL_DLDATE);
	$tpl->assign('serial_1', 		$serial[0]);
	$tpl->assign('serial_2', 		$serial[1]);
	$tpl->assign('serial_3', 		$serial[2]);
	$tpl->assign('serial_4', 		$serial[3]);
}

$tpl->assign('bm_prefs', $bm_prefs);
$tpl->assign('tabs', $tabs);
$tpl->assign('title', $lang_admin['prefs'] . ' &raquo; ' . $lang_admin['common']);
$tpl->display('page.tpl');
?>