<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: prefs.recvrules.php,v 1.12 2008/10/24 12:36:06 patrick Exp $
 *
 */

include('../serverlib/admin.inc.php');
RequestPrivileges(PRIVILEGES_ADMIN);

if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'recvrules';

$tabs = array(
	0 => array(
		'title'		=> $lang_admin['recvrules'],
		'link'		=> 'prefs.recvrules.php?',
		'active'	=> $_REQUEST['action'] == 'recvrules'
	)/*,
	1 => array(
		'title'		=> $lang_admin['autodetection'],
		'link'		=> 'prefs.recvrules.php?action=autodetection&',
		'active'	=> $_REQUEST['action'] == 'autodetection'
	)*/
);

/**
 * receive rules
 */
if($_REQUEST['action'] == 'recvrules')
{
	if(!isset($_REQUEST['do']))
		$_REQUEST['do'] = 'list';
		
	//
	// list
	//
	if($_REQUEST['do'] == 'list')
	{
		// add?
		if(isset($_REQUEST['add']))
		{
			$db->Query('INSERT INTO {pre}recvrules(field,expression,action,value,type) VALUES(?,?,?,?,?)',
				$_REQUEST['field'],
				$_REQUEST['expression'],
				(int)$_REQUEST['ruleAction'],
				(int)$_REQUEST['value'],
				(int)$_REQUEST['type']);
		}
		
		// delete
		if(isset($_REQUEST['delete']))
		{
			$db->Query('DELETE FROM {pre}recvrules WHERE id=?',
				(int)$_REQUEST['delete']);
		}
		
		// import
		if(isset($_REQUEST['import']))
		{
			if(isset($_FILES['rulefile'])
				&& $_FILES['rulefile']['error'] == 0
				&& $_FILES['rulefile']['size'] > 5)
			{
				// request temp file
				$tempFileID = RequestTempFile(0);
				$tempFileName = TempFileName($tempFileID);
				
				// move uploaded file to temp file
				if(move_uploaded_file($_FILES['rulefile']['tmp_name'], $tempFileName))
				{
					// read file
					$fp = fopen($tempFileName, 'rb');
					$importData = fread($fp, filesize($tempFileName));
					fclose($fp);
					
					// try to unserialize
					$importArray = @unserialize($importData);
					
					// check format
					if(is_array($importArray)
						&& isset($importArray['type'])
						&& $importArray['type'] = 'b1gMailRuleFile'
						&& count($importArray['data']) > 0)
					{
						// import
						foreach($importArray['data'] as $rule)
						{
							$db->Query('INSERT INTO {pre}recvrules(field,expression,action,value,type) VALUES(?,?,?,?,?)',
								$rule['field'],
								$rule['expression'],
								$rule['action'],
								$rule['value'],
								$rule['type']);
						}
					}
				}
				
				// release temp file
				ReleaseTempFile(0, $tempFileID);
			}
		}
		
		// mass action
		if(isset($_REQUEST['executeMassAction']))
		{
			// get rule IDs
			$ruleIDs = array();
			foreach($_POST as $key=>$val)
				if(substr($key, 0, 5) == 'rule_')
					$ruleIDs[] = (int)substr($key, 5);
			
			if(count($ruleIDs) > 0)
			{
				if($_REQUEST['massAction'] == 'delete')
				{
					// delete row
					$db->Query('DELETE FROM {pre}recvrules WHERE id IN(' . implode(',', $ruleIDs) . ')');
				}
				else if($_REQUEST['massAction'] == 'export')
				{
					// get rows
					$exportArray = array();
					$res = $db->Query('SELECT field,expression,action,value,type FROM {pre}recvrules WHERE id IN(' . implode(',', $ruleIDs) . ') ORDER BY id ASC');
					while($row = $res->FetchArray(MYSQL_ASSOC))
						$exportArray[] = $row;
					$res->Free();
					
					// export as file
					$exportData = serialize(array('type' => 'b1gMailRuleFile', 'data' => $exportArray));
					header('Pragma: public');
					header('Content-Type: application/octet-stream');
					header('Content-Disposition: attachment; filename=rules.bmrecvrules');
					header('Content-Length: ' . strlen($exportData));
					echo($exportData);
					exit();		
				}
			}
		}
		
		// retrieve rules
		$rules = array();
		$res = $db->Query('SELECT id,field,expression,action,value,type FROM {pre}recvrules ORDER BY type,action,id ASC');
		while($row = $res->FetchArray(MYSQL_ASSOC))
		{
			$rules[$row['id']] = array(
				'id'			=> $row['id'],
				'field'			=> $row['field'],
				'expression'	=> $row['expression'],
				'action'		=> $ruleActionTable[$row['action']],
				'value'			=> $row['value'],
				'type'			=> $ruleTypeTable[$row['type']]
			);
		}
		$res->Free();
		
		// assign
		$tpl->assign('ruleActionTable', $ruleActionTable);
		$tpl->assign('ruleTypeTable', $ruleTypeTable);
		$tpl->assign('rules', $rules);
		$tpl->assign('page', 'prefs.recvrules.tpl');
	}
	
	//
	// edit
	//
	else if($_REQUEST['do'] == 'edit')
	{
		// save?
		if(isset($_REQUEST['save']))
		{
			$db->Query('UPDATE {pre}recvrules SET field=?, expression=?, action=?, value=?, type=? WHERE id=?',
				$_REQUEST['field'],
				$_REQUEST['expression'],
				(int)$_REQUEST['ruleAction'],
				(int)$_REQUEST['value'],
				(int)$_REQUEST['type'],
				(int)$_REQUEST['id']);
			header('Location: prefs.recvrules.php?sid=' . session_id());
			exit();
		}
		
		// get rule data
		$res = $db->Query('SELECT id,field,expression,action,value,type FROM {pre}recvrules WHERE id=?',
			(int)$_REQUEST['id']);
		assert('$res->RowCount() != 0');
		$rule = $res->FetchArray(MYSQL_ASSOC);
		$res->Free();
		
		// assign
		$tpl->assign('rule', $rule);
		$tpl->assign('ruleActionTable', $ruleActionTable);
		$tpl->assign('ruleTypeTable', $ruleTypeTable);
		$tpl->assign('page', 'prefs.recvrules.edit.tpl');
	}
}

$tpl->assign('tabs', $tabs);
$tpl->assign('title', $lang_admin['prefs'] . ' &raquo; ' . $lang_admin['recvrules']);
$tpl->display('page.tpl');
?>