<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: stats.php,v 1.6 2007/12/04 20:31:39 patrick Exp $
 *
 */

include('../serverlib/admin.inc.php');
include('../serverlib/barchart.class.php');
include('../serverlib/chart.class.php');
RequestPrivileges(PRIVILEGES_ADMIN);

if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'common';
	
$tabs = array(
	0 => array(
		'title'		=> $lang_admin['commonstats'],
		'link'		=> 'stats.php?',
		'active'	=> $_REQUEST['action'] == 'common'
	),
	1 => array(
		'title'		=> $lang_admin['emailstats'],
		'link'		=> 'stats.php?action=email&',
		'active'	=> $_REQUEST['action'] == 'email'
	),
	2 => array(
		'title'		=> $lang_admin['spaceusage'],
		'link'		=> 'stats.php?action=usage&',
		'active'	=> $_REQUEST['action'] == 'usage'
	)
);

/**
 * common-/email-stats - basically the same, but seperated for the user
 */
if($_REQUEST['action'] == 'common'
	|| $_REQUEST['action'] == 'email')
{
	// show chart?
	if(isset($_REQUEST['do']) && $_REQUEST['do']=='showChart'
		&& isset($_REQUEST['statType']) && isset($_REQUEST['time']))
	{
		$statTypeItem = $_REQUEST['statType'];
		$time = (int)$_REQUEST['time'];
		$rawData = GetStatData($statTypeItem, $time);
		$data = array();
		
		foreach($rawData as $key=>$val)
			$data[$key] = array_pop($val);
	
		$chart = new BMChart(sprintf('%s (%d/%d)', $lang_admin['stat_'.$statTypeItem], date('m', $time), date('Y', $time)),
			520,
			280);
		$chart->SetData($data);
		$chart->Display();
		exit();
	}
	
	// time?
	if(!isset($_REQUEST['timeMonth']))
		$time = mktime(0, 0, 0, date('m'), 1, date('Y'));
	else 
		$time = mktime(0, 0, 0, $_REQUEST['timeMonth'], 1, $_REQUEST['timeYear']);
	
	// common stats
	if($_REQUEST['action'] == 'common')
	{
		$mode = 'common';
		$statTypes = array('login', 'signup', 'sms', 'wd');
	}
	
	// email stats
	else 
	{
		$mode = 'email';
		$statTypes = array('receive', 'send', 'sysmail');
	}
	
	// stat type
	$statType = isset($_REQUEST['statType'])
				? $_REQUEST['statType']
				: $statTypes[0];
				
	// special types
	$statsSpecial = array(
		'login'		=> array('login', 'mobile_login'),
		'send'		=> array('send', 'send_intern', 'send_extern'),
		'wd'		=> array('wd_down', 'wd_up'),
		'receive'	=> array('receive', 'infected', 'spam')
	);
	if(isset($statsSpecial[$statType]))
		$statTypeList = $statsSpecial[$statType];
	else 
		$statTypeList = array($statType);
	
	// build stats
	$stats = array();
	foreach($statTypeList as $statTypeItem)
		$stats[] = array(
			'title'		=> sprintf('%s (%d/%d)', $lang_admin['stat_'.$statTypeItem], date('m', $time), date('Y', $time)),
			'key'		=> $statTypeItem,
			'data'		=> GetStatData($statTypeItem, $time)
		);
	
	// assign
	$tpl->assign('stats', $stats);
	$tpl->assign('time', $time);
	$tpl->assign('modeTitle', $lang_admin[$mode.'stats']);
	$tpl->assign('statType', $statType);
	$tpl->assign('statTypes', $statTypes);
	$tpl->assign('mode', $mode);
	$tpl->assign('page', 'stats.view.tpl');
}

/**
 * space usage
 */
else if($_REQUEST['action'] == 'usage')
{
	// get data
	$byCategory = GetCategorizedSpaceUsage();
	$byGroup = GetGroupSpaceUsage();
	
	// get user count
	$res = $db->Query('SELECT COUNT(*) FROM {pre}users');
	list($userCount) = $res->FetchArray(MYSQL_NUM);
	$res->Free();

	// image output?
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'showSpaceByCategory')
	{
		$data = array();
		foreach($byCategory as $key=>$val)
			$data[$lang_admin[$key]] = $val;
		
		$chart = _new('BMBarChart', array($lang_admin['usagebycategory'], 500, 90));
		$chart->SetData($data);
		$chart->Display();
		exit();
	}
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'showSpaceByGroup')
	{
		$data = array();
		foreach($byGroup as $val)
			$data[$val['title']] = $val['size'];
		
		$chart = _new('BMBarChart', array($lang_admin['usagebygroup'], 500, 90));
		$chart->SetData($data);
		$chart->Display();
		exit();
	}
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'showSpaceAverageByGroup')
	{
		$data = array();
		foreach($byGroup as $val)
			$data[$val['title']] = (int)round($val['size']/$val['users'], 0);
		$chart = _new('BMBarChart', array($lang_admin['usagebygroup'] . ' (' . $lang_admin['useraverage'] . ')', 500, 90));
		$chart->SetData($data);
		$chart->Display();
		exit();
	}
	
	// assign
	$tpl->assign('userCount', $userCount);
	$tpl->assign('byCategory', $byCategory);
	$tpl->assign('byGroup', $byGroup);
	$tpl->assign('page', 'stats.usage.tpl');
}

$tpl->assign('tabs', $tabs);
$tpl->assign('title', $lang_admin['tools'] . ' &raquo; ' . $lang_admin['stats']);
$tpl->display('page.tpl');
?>