<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: users.php,v 1.29 2008/06/05 18:26:50 patrick Exp $
 *
 */

include('../serverlib/admin.inc.php');
include('../serverlib/mailbox.class.php');
RequestPrivileges(PRIVILEGES_ADMIN);

if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'users';

$tabs = array(
	0 => array(
		'title'		=> $lang_admin['users'],
		'link'		=> 'users.php?',
		'active'	=> $_REQUEST['action'] == 'users'
	),
	1 => array(
		'title'		=> $lang_admin['search'],
		'link'		=> 'users.php?action=search&',
		'active'	=> $_REQUEST['action'] == 'search'
	),
	2 => array(
		'title'		=> $lang_admin['create'],
		'link'		=> 'users.php?action=create&',
		'active'	=> $_REQUEST['action'] == 'create'
	)
);

/**
 * users
 */
if($_REQUEST['action'] == 'users')
{
	if(!isset($_REQUEST['do']))
		$_REQUEST['do'] = 'list';

	//
	// list
	//
	if($_REQUEST['do'] == 'list')
	{
		// single action?
		if(isset($_REQUEST['singleAction']))
		{
			if($_REQUEST['singleAction'] == 'lock')
			{
				$db->Query('UPDATE {pre}users SET gesperrt=? WHERE id=?',
					'yes',
					$_REQUEST['singleID']);
			}
			else if($_REQUEST['singleAction'] == 'unlock'
						|| $_REQUEST['singleAction'] == 'activate'
						|| $_REQUEST['singleAction'] == 'recover')
			{
				$db->Query('UPDATE {pre}users SET gesperrt=? WHERE id=?',
					'no',
					$_REQUEST['singleID']);
			}
			else if($_REQUEST['singleAction'] == 'delete')
			{
				$res = $db->Query('SELECT gesperrt FROM {pre}users WHERE id=?',
					$_REQUEST['singleID']);
				list($userStatus) = $res->FetchArray(MYSQL_NUM);
				$res->Free();
				
				if($userStatus != 'delete')
				{
					$db->Query('UPDATE {pre}users SET gesperrt=? WHERE id=?',
						'delete',
						$_REQUEST['singleID']);
				}
				else 
				{
					DeleteUser((int)$_REQUEST['singleID']);
				}
			}
			else if($_REQUEST['singleAction'] == 'emptyTrash')
			{
				// get user info
				$userObject = _new('BMUser', array($_REQUEST['singleID']));
				$userRow = $userObject->Fetch();
				$userMail = $userRow['email'];
				
				// open mailbox
				$mailbox = _new('BMMailbox', array($_REQUEST['singleID'], $userMail, $userObject));
				
				// empty trash
				$deletedMails = $mailbox->EmptyFolder(FOLDER_TRASH);
			}
		}
		
		// mass action
		if(isset($_REQUEST['executeMassAction']))
		{
			// get user IDs
			$userIDs = array();
			foreach($_POST as $key=>$val)
				if(substr($key, 0, 5) == 'user_')
					$userIDs[] = (int)substr($key, 5);
			
			if(count($userIDs) > 0)
			{
				if($_REQUEST['massAction'] == 'delete')
				{
					// get states
					$markIDs = $deleteIDs = array();
					$res = $db->Query('SELECT id,gesperrt FROM {pre}users WHERE id IN(' . implode(',', $userIDs) . ')');
					while($row = $res->FetchArray(MYSQL_ASSOC))
						if($row['gesperrt'] == 'delete')
							$deleteIDs[] = $row['id'];
						else 
							$markIDs[] = $row['id'];
					
					// mark users
					if(count($markIDs) > 0)
						$db->Query('UPDATE {pre}users SET gesperrt=? WHERE id IN(' . implode(',', $markIDs) . ')',
							'delete');
					
					// delete users
					foreach($deleteIDs as $userID)
						DeleteUser($userID);
				}
				else if($_REQUEST['massAction'] == 'restore'
						|| $_REQUEST['massAction'] == 'unlock')
				{
					$db->Query('UPDATE {pre}users SET gesperrt=? WHERE id IN(' . implode(',', $userIDs) . ')',
						'no');
				}
				else if($_REQUEST['massAction'] == 'lock')
				{
					$db->Query('UPDATE {pre}users SET gesperrt=? WHERE id IN(' . implode(',', $userIDs) . ')',
						'yes');
				}
				else if(substr($_REQUEST['massAction'], 0, 7) == 'moveto_')
				{
					$groupID = (int)substr($_REQUEST['massAction'], 7);
					$db->Query('UPDATE {pre}users SET gruppe=? WHERE id IN(' . implode(',', $userIDs) . ')',
						$groupID);
				}
			}
		}
		
		// sort options
		$sortBy = isset($_REQUEST['sortBy'])
					? $_REQUEST['sortBy']
					: 'email';
		$sortOrder = isset($_REQUEST['sortOrder'])
						? strtolower($_REQUEST['sortOrder'])
						: 'asc';
		$perPage = max(1, isset($_REQUEST['perPage'])
						? (int)$_REQUEST['perPage']
						: 50);
		
		// filter options
		$statusActive = $statusLocked = $statusNotActivated = $statusDeleted = true;
		if(isset($_REQUEST['filter']))
		{
			$statusActive = isset($_REQUEST['statusActive']);
			$statusLocked = isset($_REQUEST['statusLocked']);
			$statusNotActivated = isset($_REQUEST['statusNotActivated']);
			$statusDeleted = isset($_REQUEST['statusDeleted']);
		}
		$groups = BMGroup::GetSimpleGroupList();
		
		// query stuff
		$groupIDs = array();
		foreach($groups as $groupID=>$groupInfo)
		{
			$groups[$groupID]['checked'] = ((!isset($_REQUEST['filter']) && !isset($_REQUEST['onlyGroup']))
											|| isset($_REQUEST['group_'.$groupID]))
											|| (isset($_REQUEST['onlyGroup']) && $_REQUEST['onlyGroup'] == $groupID)
											|| isset($_REQUEST['allGroups']);
			if($groups[$groupID]['checked'])
				$groupIDs[] = $groupID;
		}
		$lockedValues = array();
		if($statusActive) 		$lockedValues[] = '\'no\'';
		if($statusLocked) 		$lockedValues[] = '\'yes\'';
		if($statusNotActivated) $lockedValues[] = '\'locked\'';
		if($statusDeleted) 		$lockedValues[] = '\'delete\'';
		$queryGroups = count($groupIDs) > 0 ? implode(',', $groupIDs) : '0';
		$queryLocked = count($lockedValues) > 0 ? implode(',', $lockedValues) : '0';
		$theQuery = 'FROM {pre}users WHERE '
					. 'gruppe IN(' . $queryGroups . ') AND '
					. 'gesperrt IN (' . $queryLocked . ')';
		
		// search?
		if(isset($_REQUEST['query']))
		{
			$query = unserialize($_REQUEST['query']);
			
			if(is_array($query) && count($query) == 2
				&& is_array($query[1]) && is_string($query[0])
				&& count($query[1]) > 0)
			{
				list($queryString, $queryFields) = $query;
				
				// query suffix
				$theQuery .= sprintf(' AND CONCAT(%s) LIKE \'%%%s%%\'',
					implode(',', $queryFields),
					$db->Escape($queryString));
				
				// template stuff
				$tabs[0]['active'] = false;
				$tabs[1]['active'] = true;
				$tpl->assign('searchQuery', $queryString);
			}
		}
		
		// page calculation
		$res = $db->Query('SELECT COUNT(*) ' . $theQuery);
		list($userCount) = $res->FetchArray(MYSQL_NUM);
		$res->Free();
		$pageCount = ceil($userCount / $perPage);
		$pageNo = isset($_REQUEST['page'])
					? max(1, min($pageCount, (int)$_REQUEST['page']))
					: 1;
		$startPos = max(0, min($perPage*($pageNo-1), $userCount));
		
		// do the query!
		$users = array();
		$res = $db->Query('SELECT id,email,vorname,nachname,strasse,hnr,plz,ort,gruppe,gesperrt ' . $theQuery . ' '
					. 'ORDER BY ' . $sortBy . ' '
					. $sortOrder . ' ' 
					. 'LIMIT ' . $startPos . ',' . $perPage);
		while($row = $res->FetchArray())
		{
			$aliases = array();
			$aliasRes = $db->Query('SELECT email FROM {pre}aliase WHERE type=? AND user=? ORDER BY email ASC',
				ALIAS_RECIPIENT|ALIAS_SENDER,
				$row['id']);
			while($aliasRow = $aliasRes->FetchArray())
				$aliases[] = $aliasRow['email'];
			$aliasRes->Free();
			
			$row['groupName'] 	= isset($groups[$row['gruppe']])
									? $groups[$row['gruppe']]['title']
									: $lang_admin['missing'];
			$row['aliases'] 	= count($aliases) > 0
									? implode(', ', $aliases)
									: '';
			$row['status'] 		= $statusTable[$row['gesperrt']];
			$row['statusImg'] 	= $statusImgTable[$row['gesperrt']];
			$users[$row['id']] 	= $row;
		}
		$res->Free();
		
		// assign
		$tpl->assign('users', $users);
		$tpl->assign('pageNo', $pageNo);
		$tpl->assign('pageCount', $pageCount);
		$tpl->assign('sortBy', $sortBy);
		$tpl->assign('sortOrder', $sortOrder);
		$tpl->assign('sortOrderInv', $sortOrder == 'asc' ? 'desc' : 'asc');
		$tpl->assign('statusActive', $statusActive);
		$tpl->assign('statusLocked', $statusLocked);
		$tpl->assign('statusNotActivated', $statusNotActivated);
		$tpl->assign('statusDeleted', $statusDeleted);
		$tpl->assign('queryString', isset($_REQUEST['query']) ? $_REQUEST['query'] : '');
		$tpl->assign('groups', $groups);
		$tpl->assign('perPage', $perPage);
		$tpl->assign('page', 'users.list.tpl');
	}
	
	//
	// edit
	//
	else if($_REQUEST['do'] == 'edit')
	{		
		// save?
		if(isset($_REQUEST['save']))
		{
			// profile fields
			$profileData = array();
			$res = $db->Query('SELECT id,typ FROM {pre}profilfelder ORDER BY id ASC');
			while($row = $res->FetchArray())
				$profileData[$row['id']] = $row['typ'] == FIELD_CHECKBOX
											? isset($_REQUEST['field_'.$row['id']])
											: (isset($_REQUEST['field_'.$row['id']])
												? $_REQUEST['field_'.$row['id']]
												: false);
			$res->Free();
			
			// update common stuff
			$db->Query('UPDATE {pre}users SET profilfelder=?, email=?, vorname=?, nachname=?, strasse=?, hnr=?, plz=?, ort=?, land=?, tel=?, fax=?, mail2sms_nummer=?, altmail=?, gruppe=?, gesperrt=?, sms_kontigent=?, notes=?, re=?, fwd=?, mail2sms=?, forward=?, forward_to=?, datumsformat=?, absendername=? WHERE id=?',
				serialize($profileData),
				$_REQUEST['email'],
				$_REQUEST['vorname'],
				$_REQUEST['nachname'],
				$_REQUEST['strasse'],
				$_REQUEST['hnr'],
				$_REQUEST['plz'],
				$_REQUEST['ort'],
				$_REQUEST['land'],
				$_REQUEST['tel'],
				$_REQUEST['fax'],
				$_REQUEST['mail2sms_nummer'],
				$_REQUEST['altmail'],
				$_REQUEST['gruppe'],
				$_REQUEST['gesperrt'],
				$_REQUEST['sms_kontigent'],
				$_REQUEST['notes'],
				$_REQUEST['re'],
				$_REQUEST['fwd'],
				$_REQUEST['mail2sms'],
				$_REQUEST['forward'],
				$_REQUEST['forward_to'],
				$_REQUEST['datumsformat'],
				$_REQUEST['absendername'],
				$_REQUEST['id']);
			
			// update password?
			if(isset($_REQUEST['passwort']) && strlen(trim($_REQUEST['passwort'])) > 0)
				$db->Query('UPDATE {pre}users SET passwort=? WHERE id=?',
					md5($_REQUEST['passwort']),
					$_REQUEST['id']);
		}
		
		// move?
		if(isset($_REQUEST['moveToGroup']))
		{
			$db->Query('UPDATE {pre}users SET gruppe=? WHERE id=?',
				(int)$_REQUEST['moveToGroup'],
				(int)$_REQUEST['id']);
		}
		
		// delete alias?
		if(isset($_REQUEST['deleteAlias']))
		{
			$db->Query('DELETE FROM {pre}aliase WHERE id=? AND user=?',
				(int)$_REQUEST['deleteAlias'],
				(int)$_REQUEST['id']);
		}
		
		// get user data
		$userObject = _new('BMUser', array((int)$_REQUEST['id']));
		$userRow = $user = $userObject->Fetch();
		$userMailbox = _new('BMMailbox', array($userRow['id'], $userRow['email'], $userObject));
		
		// aliases
		$aliases = $userObject->GetAliases();
		foreach($aliases as $key=>$val)
			$aliases[$key]['type'] = $aliasTypeTable[$val['type']];
		
		// get group data
		$groupObject = $userObject->GetGroup();
		$group = $groupObject->Fetch();
		
		// used month sms
		$usedMonthSMS = $userObject->GetUsedMonthSMS();
		
		// traffic?
		if($user['traffic_status'] != (int)date('m'))
			$user['traffic_down'] = $user['traffic_up'] = 0;
		
		// get usage stuff
		$res = $db->Query('SELECT COUNT(*) FROM {pre}mails WHERE userid=?',
			$user['id']);
		list($emailMails) = $res->FetchArray(MYSQL_NUM);
		$res->Free();
		$res = $db->Query('SELECT COUNT(*) FROM {pre}folders WHERE userid=?',
			$user['id']);
		list($emailFolders) = $res->FetchArray(MYSQL_NUM);
		$res->Free();
		$res = $db->Query('SELECT COUNT(*) FROM {pre}diskfiles WHERE user=?',
			$user['id']);
		list($diskFiles) = $res->FetchArray(MYSQL_NUM);
		$res->Free();
		$res = $db->Query('SELECT COUNT(*) FROM {pre}diskfolders WHERE user=?',
			$user['id']);
		list($diskFolders) = $res->FetchArray(MYSQL_NUM);
		$res->Free();
		
		// profile fields
		$profileFields = array();
		$profileData = array();
		if(strlen($user['profilfelder']) > 2)
		{
			$profileData = @unserialize($user['profilfelder']);
			if(!is_array($profileData))
				$profileData = array();
		}
		$res = $db->Query('SELECT id,typ,feld,extra FROM {pre}profilfelder ORDER BY feld ASC');
		while($row = $res->FetchArray())
			$profileFields[] = array(
				'id'		=> $row['id'],
				'title'		=> $row['feld'],
				'type'		=> $row['typ'],
				'extra'		=> explode(',', $row['extra']),
				'value'		=> isset($profileData[$row['id']]) ? $profileData[$row['id']] : false
			);
		$res->Free();
		
		// history?
		$historyCount = 0;
		if(trim($user['contactHistory']) != '')
		{
			$contactHistory = @unserialize($user['contactHistory']);
			if(is_array($contactHistory))
				$historyCount = count($contactHistory);
		}
		
		// assign
		$tpl->assign('historyCount',	$historyCount);
		$tpl->assign('user', 			$user);
		$tpl->assign('group', 			$group);
		$tpl->assign('groups', 			BMGroup::GetSimpleGroupList());
		$tpl->assign('aliases', 		$aliases);
		$tpl->assign('usedMonthSMS', 	(int)$usedMonthSMS);
		$tpl->assign('countries', 		CountryList());
		$tpl->assign('emailMails', 		$emailMails);
		$tpl->assign('emailFolders', 	$emailFolders);
		$tpl->assign('profileFields', 	$profileFields);
		$tpl->assign('diskFiles',		$diskFiles);
		$tpl->assign('diskFolders', 	$diskFolders);
		$tpl->assign('page', 			'users.edit.tpl');
	}
	
	//
	// contact history
	//
	else if($_REQUEST['do'] == 'contactHistory'
			&& isset($_REQUEST['id']))
	{
		// get user data
		$userObject = _new('BMUser', array((int)$_REQUEST['id']));
		$user = $userObject->Fetch();
		$history = @unserialize($user['contactHistory']);
		if(!is_array($history))
			$history = array();
		$history[] = $user;
		$history = array_reverse($history);
		
		// assign
		$tpl->assign('countries',		CountryList());
		$tpl->assign('history',			$history);
		$tpl->assign('user', 			$user);
		$tpl->assign('page', 			'users.contacthistory.tpl');
	}
	
	//
	// clear contact history
	//
	else if($_REQUEST['do'] == 'clearHistory'
			&& isset($_REQUEST['id']))
	{
		$db->Query('UPDATE {pre}users SET contactHistory=? WHERE id=?',
			'',
			(int)$_REQUEST['id']);
		header('Location: users.php?do=edit&id=' . $_REQUEST['id'] . '&sid=' . session_id());
		exit();
	}
	
	//
	// login
	//
	else if($_REQUEST['do'] == 'login')
	{
		$userObject = _new('BMUser', array((int)$_REQUEST['id']));
		$userRow = $userObject->Fetch();
		
		// log this
		PutLog(sprintf('Admin logs in as user <%s> (%d) from <%s>',
				$userRow['email'],
				$userRow['id'],
				$_SERVER['REMOTE_ADDR']),
			PRIO_NOTE,
			__FILE__,
			__LINE__);
			
		// create new session
		header(sprintf('Location: ../index.php?do=login&email_full=%s&passwordMD5=%s',
			urlencode($userRow['email']),
			md5(md5($bm_prefs['adminpw']) . $_SERVER['HTTP_USER_AGENT'] . $_SERVER['REMOTE_ADDR'])));
		exit();
	}
}

/**
 * search
 */
else if($_REQUEST['action'] == 'search')
{
	// display form
	if(!isset($_REQUEST['do']))
	{
		// assign
		$tpl->assign('page', 'users.search.tpl');
	}
	
	// build search URL and redirect
	else if($_REQUEST['do'] == 'search')
	{
		// check params
		if(!isset($_REQUEST['searchIn'])
			|| !is_array($_REQUEST['searchIn'])
			|| strlen(trim($_REQUEST['q'])) < 1)
		{
			header('Location: users.php?action=search&sid=' . session_id());
			exit();
		}
		
		// collect fields
		$fields = array();
		foreach($_REQUEST['searchIn'] as $field=>$val)
		{
			if($field == 'id')
				$fields[] = 'id';
			else if($field == 'email')
				$fields[] = 'email';
			else if($field == 'altmail')
				$fields[] = 'altmail';
			else if($field == 'name')
				$fields = array_merge($fields, array('vorname', 'nachname'));
			else if($field == 'address')
				$fields = array_merge($fields, array('strasse', 'hnr', 'plz', 'ort', 'land'));
			else if($field == 'telfaxmobile')
				$fields = array_merge($fields, array('tel', 'fax', 'mail2sms_nummer'));
		}
		
		// build query string
		$queryString = serialize(array(trim($_REQUEST['q']), $fields));
		header('Location: users.php?query=' . urlencode($queryString) . '&sid='  . session_id());
		exit();
	}
}

/**
 * create user
 */
else if($_REQUEST['action'] == 'create')
{
	// create user
	if(isset($_REQUEST['create']))
	{
		$msgIcon = 'error32';
		$msgText = '?';
		
		// check address syntax
		$email = trim($_REQUEST['email']) . '@' . $_REQUEST['emailDomain'];
		if(BMUser::AddressValid($email))
		{
			// check address availability
			if(BMUser::AddressAvailable($email))
			{
				// profile fields
				$profileData = array();
				$res = $db->Query('SELECT id,typ FROM {pre}profilfelder ORDER BY id ASC');
				while($row = $res->FetchArray())
					$profileData[$row['id']] = $row['typ'] == FIELD_CHECKBOX
												? isset($_REQUEST['field_'.$row['id']])
												: (isset($_REQUEST['field_'.$row['id']])
													? $_REQUEST['field_'.$row['id']]
													: false);
				$res->Free();
				
				// create account
				$userID = BMUser::CreateAccount($email,
					$_REQUEST['vorname'],
					$_REQUEST['nachname'],
					$_REQUEST['strasse'],
					$_REQUEST['hnr'],
					$_REQUEST['plz'],
					$_REQUEST['ort'],
					$_REQUEST['land'],
					$_REQUEST['tel'],
					$_REQUEST['fax'],
					$_REQUEST['altmail'],
					$_REQUEST['mail2sms_nummer'],
					$_REQUEST['passwort'],
					$profileData,
					false);
					
				// update misc stuff
				$db->Query('UPDATE {pre}users SET mail2sms_nummer=?, gruppe=?, gesperrt=?, sms_kontigent=?, notes=? WHERE id=?',
					$_REQUEST['mail2sms_nummer'],
					$_REQUEST['gruppe'],
					$_REQUEST['gesperrt'],
					$_REQUEST['sms_kontigent'],
					$_REQUEST['notes'],
					$userID);
					
				$msgIcon = 'info32';
				$msgText = sprintf($lang_admin['accountcreated'], $userID, session_id());
				$tpl->assign('backLink',		'users.php?action=create&');
			}
			else 
			{
				$msgText = $lang_admin['addresstaken'];
				$msgIcon = 'error32';
			}
		}
		else 
		{
			$msgText = $lang_admin['addressinvalid'];
			$msgIcon = 'error32';
		}
		
		// assign
		$tpl->assign('msgTitle',		$lang_admin['create']);
		$tpl->assign('msgText',			$msgText);
		$tpl->assign('msgIcon',			$msgIcon);
		$tpl->assign('page',			'msg.tpl');
	}
	
	// display form
	else
	{
		// profile fields
		$profileFields = array();
		$res = $db->Query('SELECT id,typ,feld,extra FROM {pre}profilfelder ORDER BY feld ASC');
		while($row = $res->FetchArray())
			$profileFields[] = array(
				'id'		=> $row['id'],
				'title'		=> $row['feld'],
				'type'		=> $row['typ'],
				'extra'		=> explode(',', $row['extra'])
			);
		$res->Free();
		
		// assign
		$tpl->assign('profileFields',	$profileFields);
		$tpl->assign('groups',			BMGroup::GetSimpleGroupList());
		$tpl->assign('defaultGroup',	$bm_prefs['std_gruppe']);
		$tpl->assign('countries',		CountryList());
		$tpl->assign('defaultCountry',	$bm_prefs['std_land']);
		$tpl->assign('domainList', 		explode(':', $bm_prefs['domains']));
		$tpl->assign('page', 			'users.create.tpl');
	}
}

$tpl->assign('tabs', $tabs);
$tpl->assign('title', $lang_admin['usersgroups'] . ' &raquo; ' . $lang_admin['users']);
$tpl->display('page.tpl');
?>