<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: welcome.php,v 1.29 2009/02/03 13:41:21 patrick Exp $
 *
 */

include('../serverlib/admin.inc.php');
RequestPrivileges(PRIVILEGES_ADMIN);

if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'welcome';

$tabs = array(
	0 => array(
		'title'		=> $lang_admin['welcome'],
		'link'		=> 'welcome.php?',
		'active'	=> $_REQUEST['action'] == 'welcome'
	),
	1 => array(
		'title'		=> $lang_admin['about'],
		'link'		=> 'welcome.php?action=about&',
		'active'	=> $_REQUEST['action'] == 'about'
	)
);

if($_REQUEST['action'] == 'welcome')
{
	// 
	// actions
	//
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'saveNotes')
	{
		$db->Query('UPDATE {pre}prefs SET notes=?',
			$_REQUEST['notes']);
		$bm_prefs['notes'] = $_REQUEST['notes'];
	}
	
	//
	// license
	//
	$tpl->assign('version', B1GMAIL_VERSION);
	$tpl->assign('patchlevel', $bm_prefs['patchlevel']);
	$tpl->assign('licenseDomain', B1GMAIL_LICDOMAIN);
	$tpl->assign('licenseNo', B1GMAIL_LICNR);
	$tpl->assign('licenseSerial', $bm_prefs['serial']);
	
	//
	// overview
	//
	
	// count rows
	$userCount = BMUser::GetUserCount();
	$res = $db->Query('SELECT COUNT(*) FROM {pre}users WHERE gesperrt=?',
		'locked');
	list($notActivatedUserCount) = $res->FetchArray(MYSQL_NUM);
	$res->Free();
	$res = $db->Query('SELECT COUNT(*) FROM {pre}users WHERE gesperrt=?',
		'yes');
	list($lockedUserCount) = $res->FetchArray(MYSQL_NUM);
	$res->Free();
	$res = $db->Query('SELECT COUNT(*),SUM(size) FROM {pre}mails');
	list($emailCount, $emailSize) = $res->FetchArray(MYSQL_NUM);
	$res->Free();
	$res = $db->Query('SELECT COUNT(*) FROM {pre}folders');
	list($folderCount) = $res->FetchArray(MYSQL_NUM);
	$res->Free();
	$res = $db->Query('SELECT COUNT(*),SUM(size) FROM {pre}diskfiles');
	list($diskFileCount, $diskSize) = $res->FetchArray(MYSQL_NUM);
	$res->Free();
	$res = $db->Query('SELECT COUNT(*) FROM {pre}diskfolders');
	list($diskFolderCount) = $res->FetchArray(MYSQL_NUM);
	$res->Free();
	
	// load avg
    $loadAvg = '<i>(' . $lang_admin['unknown'] . ')</i>';
    if(!SERVER_WINDOWS && ($uptime = @exec('uptime')))
    	if(preg_match("/([0-9\.]+),[\s]+([0-9\.]+),[\s]+([0-9\.]+)/", $uptime, $match))
    		$loadAvg = implode(' ', array_slice($match, 1));

	// db size
	$dbSize = 0;
	$freeableSpace = 0;
	$tableCount = 0;
	$res = $db->Query('SHOW TABLE STATUS');
	while($row = $res->FetchArray(MYSQL_ASSOC))
	{
		if(substr($row['Name'], 0, strlen($mysql['prefix'])) == $mysql['prefix'])
		{
			$dbSize += $row['Data_length'] + $row['Index_length'];
			$freeableSpace += $row['Data_free'];
			$tableCount++;
		}
	}
	$res->Free();
	
	// assign values
	$tpl->assign('loadAvg', $loadAvg);
	$tpl->assign('userCount', $userCount);
	$tpl->assign('notActivatedUserCount', $notActivatedUserCount);
	$tpl->assign('lockedUserCount', $lockedUserCount);
	$tpl->assign('emailSize', $emailSize);
	$tpl->assign('emailCount', $emailCount);
	$tpl->assign('folderCount', $folderCount);
	$tpl->assign('diskFileCount', $diskFileCount);
	$tpl->assign('diskFolderCount', $diskFolderCount);
	$tpl->assign('diskSize', $diskSize);
	$tpl->assign('tableCount', $tableCount);
	$tpl->assign('webserver', array_shift(explode(' ', $_SERVER['SERVER_SOFTWARE'])));
	$tpl->assign('phpVersion', phpversion());
	$tpl->assign('mysqlVersion', $db->GetServerVersion());
	$tpl->assign('dbSize', $dbSize);
	
	//
	// system notices
	//
	$notices = array();
	
	// data folder?
	if(!file_exists(B1GMAIL_DATA_DIR))
		$notices[] = array('type'	=> 'error',
							'text'	=> sprintf($lang_admin['invaliddata'], B1GMAIL_DATA_DIR),
							'link'	=> 'prefs.common.php?');
	else if(!is_writeable(B1GMAIL_DATA_DIR))
		$notices[] = array('type'	=> 'error',
							'text'	=> sprintf($lang_admin['dataperms'], B1GMAIL_DATA_DIR));
	// struct storage?
	if($bm_prefs['structstorage'] == 'yes' && ini_get('safe_mode'))
		$notices[] = array('type'	=> 'error',
							'text'	=> $lang_admin['structsafewarn'],
							'link'	=> 'prefs.common.php?');
							
	// permissions
	$brokenPermissions = array();
	foreach($writeableFiles as $item)
		if(!is_writeable(B1GMAIL_REL . $item))
			$brokenPermissions[] = $item;
	if(count($brokenPermissions) > 0)
		$notices[] = array('type'	=> 'warning',
							'text'	=> sprintf($lang_admin['brokenperms'], implode(', ', $brokenPermissions)));
	
	// htaccess files
	$brokenHTAccess = array();
	foreach($htaccessFiles as $item)
		if(!file_exists(B1GMAIL_REL . $item))
			$brokenHTAccess[] = $item;
	if(count($brokenHTAccess) > 0)
		$notices[] = array('type'	=> 'warning',
							'text'	=> sprintf($lang_admin['brokenhtaccess'], implode(', ', $brokenHTAccess)));
	
	
	// caches out of sync?
	$res = $db->Query('SELECT SUM(mailspace_used),SUM(diskspace_used) FROM {pre}users');
	list($userMailSpace, $userDiskSpace) = $res->FetchArray(MYSQL_NUM);
	$res->Free();
	if((int)$userMailSpace != (int)$emailSize || (int)$userDiskSpace != (int)$diskSize)
		$notices[] = array('type'	=> 'warning',
							'text'	=> $lang_admin['cachesizesdiffer'],
							'link'	=> 'optimize.php?action=cache&');
	
	// no postmaster?
	if(BMUser::GetID(GetPostmasterMail(), true) == 0)
		$notices[] = array('type'	=> 'warning',
							'text'	=> sprintf($lang_admin['nopostmaster'], GetPostmasterMail()),
							'link'	=> 'users.php?action=create&');
	
	// maintenance mode?
	if($bm_prefs['wartung'] == 'yes')
		$notices[] = array('type'	=> 'info',
							'text'	=> $lang_admin['maintmodenote'],
							'link'	=> 'prefs.common.php?');
	
	// struct storage recommended?
	if($bm_prefs['structstorage'] == 'no' && !ini_get('safe_mode'))
		$notices[] = array('type'	=> 'info',
							'text'	=> $lang_admin['structrec'],
							'link'	=> 'prefs.common.php?');
	
	// gd?
	if(!function_exists('imagecreate'))
		$notices[] = array('type'	=> 'info',
							'text'	=> $lang_admin['gdlib']);
	
	// iconv/mbstring?
	if(!function_exists('mb_convert_encoding') && !function_exists('iconv'))
		$notices[] = array('type'	=> 'info',
							'text'	=> $lang_admin['mbstring']);
							
	// debug mode?
	if(DEBUG)
		$notices[] = array('type'	=> 'info',
							'text'	=> $lang_admin['debugmode']);
	
	// db optimizable?
	if($freeableSpace > 1024*1024*5)
		$notices[] = array('type'	=> 'info',
							'text'	=> sprintf($lang_admin['couldfree'], $freeableSpace/1024/1024),
							'link'	=> 'optimize.php?');
	
	// many logs?
	$res = $db->Query('SELECT COUNT(*) FROM {pre}logs');
	list($logCount) = $res->FetchArray(MYSQL_NUM);
	$res->Free();
	if($logCount > 250000)
		$notices[] = array('type'	=> 'info',
							'text'	=> $lang_admin['manylogs'],
							'link'	=> 'logs.php?action=archiving&');

	// users waiting for activation
	if($notActivatedUserCount > 0)
		$notices[] = array('type'	=> 'info',
							'text'	=> sprintf($lang_admin['notactnotice'], $notActivatedUserCount),
							'link'	=> 'users.php?filter=true&statusNotActivated=true&allGroups=true&');
	
	// users waiting for delete
	$res = $db->Query('SELECT COUNT(*) FROM {pre}users WHERE gesperrt=?',
		'delete');
	list($deleteCount) = $res->FetchArray(MYSQL_NUM);
	$res->Free();
	if($deleteCount > 0)
		$notices[] = array('type'	=> 'info',
							'text'	=> sprintf($lang_admin['deletenotice'], $deleteCount),
							'link'	=> 'users.php?filter=true&statusDeleted=true&allGroups=true&');
	
	//
	// plugin notices
	//
	$pluginNotices = $plugins->callFunction('getNotices', false, true);
	foreach($pluginNotices as $value)
		$notices = array_merge($notices, $value);
	$tpl->assign('notices', $notices);
	
	//
	// misc
	//
	$tpl->assign('serial', $bm_prefs['serial']);
	$tpl->assign('licnr', B1GMAIL_LICNR);
	$tpl->assign('notes', $bm_prefs['notes']);
	$tpl->assign('page', 'welcome.tpl');
}
else if($_REQUEST['action'] == 'about')
{
	$tpl->assign('patchlevel', $bm_prefs['patchlevel']);
	$tpl->assign('version', B1GMAIL_VERSION);
	$tpl->assign('page', 'about.tpl');
}

$tpl->assign('tabs', $tabs);
$tpl->assign('title', $lang_admin['welcome']);
$tpl->display('page.tpl');
?>