<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: workgroups.php,v 1.4 2007/12/05 12:02:15 patrick Exp $
 *
 */

include('../serverlib/admin.inc.php');
RequestPrivileges(PRIVILEGES_ADMIN);

if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'workgroups';

$tabs = array(
	0 => array(
		'title'		=> $lang_admin['workgroups'],
		'link'		=> 'workgroups.php?',
		'active'	=> $_REQUEST['action'] == 'workgroups'
	),
	1 => array(
		'title'		=> $lang_admin['create'],
		'link'		=> 'workgroups.php?action=create&',
		'active'	=> $_REQUEST['action'] == 'create'
	)
);

/**
 * workgroups
 */
if($_REQUEST['action'] == 'workgroups')
{
	if(!isset($_REQUEST['do']))
		$_REQUEST['do'] = 'list';

	//
	// list
	//
	if($_REQUEST['do'] == 'list')
	{		
		// mass action
		if(isset($_REQUEST['executeMassAction']))
		{
			// get group IDs
			$groupIDs = array();
			foreach($_POST as $key=>$val)
				if(substr($key, 0, 6) == 'group_')
					$groupIDs[] = (int)substr($key, 6);
			
			if(count($groupIDs) > 0)
			{
				if($_REQUEST['massAction'] == 'delete')
				{
					$db->Query('DELETE FROM {pre}workgroups_member WHERE workgroup IN(' . implode(',', $groupIDs) . ')');
					$db->Query('DELETE FROM {pre}workgroups WHERE id IN(' . implode(',', $groupIDs) . ')');
				}
			}
		}
		
		// delete?
		if(isset($_REQUEST['delete']))
		{
			$db->Query('DELETE FROM {pre}workgroups_member WHERE workgroup=?',
				(int)$_REQUEST['delete']);
			$db->Query('DELETE FROM {pre}workgroups WHERE id=?',
				(int)$_REQUEST['delete']);
		}
		
		// groups
		$groups = array();
		$res = $db->Query('SELECT id,title,email FROM {pre}workgroups ORDER BY title ASC');
		while($row = $res->FetchArray(MYSQL_ASSOC))
		{
			$res2 = $db->Query('SELECT COUNT(*) FROM {pre}workgroups_member WHERE workgroup=?',
				$row['id']);
			list($memberCount) = $res2->FetchArray(MYSQL_NUM);
			$res2->Free();
			
			$row['members'] = $memberCount;
			$groups[$row['id']] = $row;
		}
		$res->Free();
		
		// assign
		$tpl->assign('groups',		$groups);
		$tpl->assign('page', 		'workgroups.list.tpl');
	}
	
	//
	// edit
	//
	else if($_REQUEST['do'] == 'edit'
			&& isset($_REQUEST['id']))
	{		
		// save?
		if(isset($_REQUEST['save']))
		{
			$db->Query('UPDATE {pre}workgroups SET title=?,email=? WHERE id=?',
				$_REQUEST['title'],
				$_REQUEST['email'],
				(int)$_REQUEST['id']);
		}
		
		// delete member?
		else if(isset($_REQUEST['deleteMember']))
		{
			$db->Query('DELETE FROM {pre}workgroups_member WHERE user=? AND workgroup=?',
				(int)$_REQUEST['deleteMember'],
				(int)$_REQUEST['id']);
		}
		
		// add member?
		if(isset($_REQUEST['userMail'])
			&& trim($_REQUEST['userMail']) != ''
			&& ($userID = BMUser::GetID($_REQUEST['userMail'])) > 0)
		{
			$db->Query('REPLACE INTO {pre}workgroups_member(workgroup,user) VALUES(?,?)',
				(int)$_REQUEST['id'],
				$userID);
		}
		
		// fetch from DB
		$res = $db->Query('SELECT * FROM {pre}workgroups WHERE id=?',
			(int)$_REQUEST['id']);
		$group = $res->FetchArray(MYSQL_ASSOC);
		$res->Free();
		
		// members
		$members = array();
		$res = $db->Query('SELECT {pre}users.email AS email, CONCAT({pre}users.nachname,\', \',{pre}users.vorname) AS name, {pre}workgroups_member.user AS id FROM {pre}workgroups_member,{pre}users WHERE {pre}workgroups_member.workgroup=? AND {pre}users.id={pre}workgroups_member.user ORDER BY name ASC',
			(int)$_REQUEST['id']);
		while($row = $res->FetchArray(MYSQL_ASSOC))
			$members[$row['id']] = $row;
		$res->Free();
		
		// assign
		$tpl->assign('group',			$group);
		$tpl->assign('members',			$members);
		$tpl->assign('page', 			'workgroups.edit.tpl');
	}
}

/**
 * create group
 */
else if($_REQUEST['action'] == 'create')
{
	// create group
	if(isset($_REQUEST['create']))
	{
		$db->Query('INSERT INTO {pre}workgroups(title,email,addressbook,calendar,webdisk,todo,notes) VALUES(?,?,?,?,?,?,?)',
			$_REQUEST['title'],
			$_REQUEST['email'],
			'no',
			'no',
			0,
			'no',
			'no');
		$wgID = $db->InsertId();
		header('Location: workgroups.php?do=edit&id=' . $wgID . '&sid=' . session_id());
		exit();
	}
	
	// display form
	else
	{
		// assign
		$tpl->assign('create',			true);
		$tpl->assign('page', 			'workgroups.edit.tpl');
	}
}

$tpl->assign('tabs', $tabs);
$tpl->assign('title', $lang_admin['usersgroups'] . ' &raquo; ' . $lang_admin['workgroups']);
$tpl->display('page.tpl');
?>