<!--
/*
 * b1gMail7 client library
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: dragcontainer.js,v 1.8 2007/12/24 10:28:40 patrick Exp $
 *
 */

	function EBID(e)
	{
		return(document.getElementById(e));
	}

	function dragContainer(elem, cols, instanceName)
	{
		this.instanceName = instanceName;
		this.parentContainer = EBID(elem);
		this.elemContainer = EBID(elem+'_elems');
		this.name = 'dc_' + elem;
		this.cols = cols;
		this.containers = [];
		this.order = '';
		this.startDragging = false;
		this.dragID = '';
		this.margin = 4;
		this.activeTarget = false;
		
		this.onOrderChanged = function() {}
		
		this.init = function()
		{
			var elems = this.elemContainer.getElementsByTagName("div");
			for(var i=0; i<elems.length; i++)
			{
				var elem = elems[i];
				this.containers.push(elem);
			}
		}
		
		this.run = function()
		{
			// create table
			var colWidth = Math.floor(100/this.cols);
			var tableCode = '<table class="dragTable" onmouseup="' + this.instanceName + '.parentMouseUp(event)" onmousemove="' + this.instanceName + '.parentMouseMove(event)">';
			tableCode += '<tr>';
			for(var col=0; col<this.cols; col++)
				tableCode += '<td id="' + this.name + 'col_' + col + '" class="dragTableColumn" width="' + colWidth + '%">&nbsp;</td>';
			tableCode += '</tr>';
			tableCode += '</table>';
			tableCode += '<div class="dragItem" onmouseup="' + this.instanceName + '.parentMouseUp(event)" onmousemove="' + this.instanceName + '.parentMouseMove(event)" id="' + this.name + 'dc" style="display:none;position:absolute;top:0px;left:0px;"></div>';

			// render table
			this.parentContainer.innerHTML = tableCode;
			
			// create dock items
			this.createDockItems();
		}
		
		this.parseOrder = function(o)
		{
			// create result array
			var result = [];
			for(var col=0; col<this.cols; col++)
				result.push([]);
				
			// parse order string
			var rows = o.split(';');
			for(var row=0; row<rows.length; row++)
			{
				var cols = rows[row].split(',');
				for(var col=0; col<cols.length; col++)
					result[col].push(cols[col]);
			}
			
			// return
			return(result);
		}
	
		this.orderToString = function(o)
		{
			var result = [];
			
			for(var col=0; col<this.containers.length; col++)
			{
				for(var row=0; row<this.cols; row++)
				{
					if(o[row][col])
						result += o[row][col] + ',';
					else
						result += ',';
				}
				if(result.substr(result.length-1, 1) == ',')
					result = result.substr(0, result.length-1);
				result += ';';
			}
			
			if(result.substr(result.length-1, 1) == ';')
				result = result.substr(0, result.length-1);
			
			result = result.replace(/,;$/g, '');
			result = result.replace(/;,,;/g, ';');
			result = result.replace(/^,,;/g, '');
			result = result.replace(/;,,$/g, '');
			return(result);
		}
		
		this.getOrder = function()
		{
			return(this.parseOrder(this.order));
		}
		
		this.getContainerById = function(id)
		{
			for(var i=0; i<this.containers.length; i++)
				if(this.containers[i].id == id)
					return(this.containers[i]);
			return(false);
		}
		
		this.createDockItems = function()
		{
			// get order
			var order = this.getOrder();
			
			// loop through cols
			for(var col=0; col<order.length; col++)
			{
				var columnData = '';
				var colContainers = order[col];
				for(var container=0; container<colContainers.length; container++)
				{
					if(colContainers[container])
					{
						var colContainer = this.getContainerById(colContainers[container]);
						if(colContainer)
						{
							columnData += '<div class="dragTargetInactive" onmousemove="' + this.instanceName + '.targetMouseMove(event, this)" style="height:' + this.margin + 'px;" id="' + this.name + 'dragTarget_' + col + '_' + container + '"></div>';
							columnData += '<div class="dragItem" id="' + this.name + 'dragItem_' + colContainers[container] + '">';
							columnData +=	'<div class="dragBar" onmousedown="return ' + this.instanceName + '.barMouseDown(\'' + colContainers[container] + '\', event, this)">' + colContainer.title + '</div>';
							columnData +=	colContainer.innerHTML;
							columnData += '</div>';
						}
					}
				}	
				columnData += '<div class="dragTargetInactive" onmousemove="' + this.instanceName + '.targetMouseMove(event, this)" style="height:' + this.margin + 'px;" id="' + this.name + 'dragTarget_' + (col) + '_' + container + '"></div>';
				EBID(this.name + 'col_' + col).innerHTML = columnData;
			}
		}
		
		this.barMouseDown = function(id, evt, obj)
		{
			this.startDragging = true;
			this.dragID = id;
			return(false);
		}
		
		this.targetMouseMove = function(evt, obj)
		{
			if(this.startDragging)
			{
				if(this.activeTarget != obj
					&& this.activeTarget != false)
				{
					this.activeTarget.className = 'dragTargetInactive';
					this.activeTarget.style.height = this.margin + 'px';
				}
					
				var dragContainer = EBID(this.name + 'dc');
				obj.className = 'dragTargetActive';
				obj.style.height = dragContainer.style.height;
				this.activeTarget = obj;
			}
		}
		
		this.parentMouseMove = function(evt)
		{
			if(this.startDragging)
			{
				var dragItem = EBID(this.name + 'dragItem_' + this.dragID);
				var dragContainer = EBID(this.name + 'dc');
				
				dragContainer.style.left = evt.clientX + 'px';
				dragContainer.style.top = evt.clientY + 'px';
				
				if(dragContainer.style.display != '')
				{
					dragContainer.style.display = '';
					dragContainer.innerHTML = dragItem.innerHTML;
					dragContainer.style.width = (dragItem.offsetWidth ? dragItem.offsetWidth : dragItem.clientWidth) + 'px';
					dragContainer.style.height = (dragItem.offsetHeight ? dragItem.offsetHeight : dragItem.clientHeight) + 'px';
					dragItem.style.display = 'none';
				}
			}
		}
		
		this.parentMouseUp = function(evt)
		{
			if(this.startDragging)
			{
				if(this.activeTarget)
				{
					var theOrder = this.getOrder();
					var theNewOrder = [];
					var theID = this.activeTarget.id.split('_');
					var theCol = theID[theID.length-2];
					var theRow = theID[theID.length-1];
					var theItem = this.dragID;
					
					for(var col=0; col<theOrder.length; col++)
					{
						theNewOrder.push([]);
						for(var row=0; row<this.containers.length+1; row++)
						{
							if(theCol == col && theRow == row)
							{
								theNewOrder[col].push(theItem);
							}
							if(theOrder[col][row]
								&& theOrder[col][row] != theItem)
							{
								theNewOrder[col].push(theOrder[col][row]);
							}
						}
					}
					
					this.order = this.orderToString(theNewOrder);
					this.onOrderChanged();
					this.run();
				}
				else
				{
					this.run();
				}
				
				this.startDragging = false;
				this.dragID = false;
				this.activeTarget = false;
			}
		}
		
		this.calculateOrder = function()
		{
			var result  = '';
			for(var col=0; col<this.cols; col++)
			{
				var elems = EBID(this.name + 'col_' + col).getElementsByTagName('div');
				for(var i=0; i<elems.length; i++)
				{
					var elem = elems[i];
					if(elem.className == 'dragItem')
						result += elem.id.substr(this.name.length+9) + ',';
				}
				if(result.substr(-1) == ',')
					result = result.substr(0, result.length-1);
				result += ';';
			}
			if(result.substr(-1) == ';')
				result = result.substr(0, result.length-1);
			return(result);
		}
		
		this.init();
	}

//-->