<!--
/*
 * b1gMail7 client library
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: wysiwyg.js,v 1.17 2009/02/04 08:48:57 patrick Exp $
 *
 */

var __htmlEditors = [];
var __htmlEditorCurrentID;

function __htmlEditorButtonFocus(id)
{
	id = id.split('_');
	id = id[1];
	__htmlEditors[id].focus();
}

function __htmlEditorSizeChanged(id)
{
	var id2 = id.split('_');
	id2 = id2[1];
	__htmlEditors[id2].sizeCtlChanged(EBID(id));
}

function __htmlEditorFontChanged(id)
{
	var id2 = id.split('_');
	id2 = id2[1];
	__htmlEditors[id2].fontCtlChanged(EBID(id));
}

function __htmlEditorSource(a, id)
{
	var id2 = id.split('_');
	id2 = id2[1];
	__htmlEditors[id2].switchMode(a ? 'source' : 'html');
}

function __htmlEditorInsertSmiley(id)
{
	var id2 = id.split('_');
	__htmlEditors[id2[1]].insertSmiley(id2[2]);
}

function __htmlEditorHideSmilies()
{
	document.onclick = '';
	__htmlEditors[__htmlEditorCurrentID].hideSmilies();
	__htmlEditors[__htmlEditorCurrentID].focus();
}

function htmlEditor(textareaID, tbPath)
{
	this.getIFrameDocument = function()
	{
		return(this.iFrame.contentWindow.document);
	}
	
	this.focus = function()
	{
		this.iFrame.contentWindow.focus();
	}
	
	this.textToHTML = function(text)
	{
        var htmlVersion = text;
        htmlVersion = htmlVersion.replace(/\</gi, "&lt;");
        htmlVersion = htmlVersion.replace(/\>/gi, "&gt;");
        htmlVersion = htmlVersion.replace(/\n/gi, "<br />");
        return(htmlVersion);
	}
	
	this.htmlToText = function(html)
	{
		var textVersion = html;
     	textVersion = textVersion.replace(/\r/g, "");
        textVersion = textVersion.replace(/\n/g, "");
        textVersion = textVersion.replace(/\<p(.*?)\>/gi, "\r\n");
        textVersion = textVersion.replace(/\<br\>/gi, "\r\n");
        textVersion = textVersion.replace(/\<br\/\>/gi, "\r\n");
        textVersion = textVersion.replace(/\<br \/\>/gi, "\r\n");
        textVersion = textVersion.replace(/\<\/div\>/gi, "\r\n");
        textVersion = textVersion.replace(/<(.*?)>/gi, "");
        textVersion = textVersion.replace(/\&lt\;/gi, "<");
        textVersion = textVersion.replace(/\&gt\;/gi, ">");
        textVersion = textVersion.replace(/\&amp\;/gi, "&");
        textVersion = textVersion.replace(/\&quot\;/gi, "\"");
        textVersion = textVersion.replace(/\&uuml\;/gi, "ue");
        textVersion = textVersion.replace(/\&ouml\;/gi, "oe");
        textVersion = textVersion.replace(/\&auml\;/gi, "ae");
        textVersion = textVersion.replace(/\&Uuml\;/gi, "Ue");
        textVersion = textVersion.replace(/\&Ouml\;/gi, "Oe");
        textVersion = textVersion.replace(/\&Auml\;/gi, "Ae");
        textVersion = textVersion.replace(/\&szlig\;/gi, "ss");
        return(textVersion);
	}
	
	this.setText = function(text, isHTML)
	{
		if(this.mode == 'text')
		{
			this.textarea.value = isHTML ? this.htmlToText(text) : text;
		}
		else if(this.mode == 'html')
		{
			this.document.body.innerHTML = isHTML ? text : this.textToHTML(text);
		}
	}
	
	this.clear = function()
	{
		this.setText('');
	}
	
	this.reset = function()
	{
		this.switchMode(this.initialMode);
		this.setText(this.initialText, this.initialMode=='html');
	}
	
	this.insertText = function(text)
	{
		if(this.mode == 'text')
		{
			this.textarea.focus();
			
			if(document.selection)
			{
				var range = document.selection.createRange();
				range.text = text;
			}
			else if(this.textarea.selectionStart || this.textarea.selectionStart == '0')
			{
				var rangeStart = this.textarea.selectionStart,
					rangeEnd = this.textarea.selectionEnd;
				this.textarea.value = this.textarea.value.substring(0, rangeStart) + text + this.textarea.value.substring(rangeEnd, this.textarea.value.length);
				this.textarea.selectionStart = rangeStart + text.length;
				this.textarea.selectionEnd = this.textarea.selectionStart;
			}
			else
				this.textarea.value += text;
		}
		else if(this.mode == 'html')
		{
			if(this.browserIE)
			{
				var range = this.document.selection.createRange();
				if(range)
				{
					range.collapse(true);
					range.pasteHTML(text);
				}
			}
			else// if(this.browserGecko || this.browserOpera || this.browserSafari)
			{
				this.execCommand('insertHTML', text);
			}
		}
	}
	
	this.switchMode = function(newMode, initial)
	{
		if(initial)
			this.initialMode = newMode;
		if(newMode == 'html' && this.mode == 'text')
		{
			if(!initial)
				this.document.body.innerHTML = this.textToHTML(this.textarea.value);
			this.editorMainDiv.style.display = '';
			this.textarea.style.display = 'none';
			this.mode = 'html';
			return(true);
		}
		else if(newMode == 'text' && this.mode == 'html'
				&& (initial || confirm(lang['switchwarning'])))
		{
			if(!initial)
				this.textarea.value = this.htmlToText(this.document.body.innerHTML);
			this.editorMainDiv.style.display = 'none';
			this.textarea.style.display = '';
			this.mode = 'text';
			return(true);
		}
		else if(newMode == 'source' && this.mode == 'html')
		{
			if(!initial)
				this.textarea.value = this.document.body.innerHTML;
			this.editorDiv.style.display = 'none';
			this.editorMainDiv.style.display = '';
			this.textarea.style.display = '';
			this.mode = 'source';
			return(true);
		}
		else if(newMode == 'html' && this.mode == 'source')
		{
			if(!initial)
				this.document.body.innerHTML = this.textarea.value;
			this.editorDiv.style.display = '';
			this.editorMainDiv.style.display = '';
			this.textarea.style.display = 'none';
			this.mode = 'html';
			return(true);
		}
		return(false);
	}
	
	this.init = function()
	{
		// browser?
		var nav = navigator.userAgent.toLowerCase();
		if(nav.indexOf('msie') != -1)
			this.browserIE = true;
		else if(nav.indexOf('opera') != -1)
			this.browserOpera = true;
		else if(nav.indexOf('safari') != -1)
			this.browserSafari = true;
		else
			this.browserGecko = true;
		
		// find form
		var formNode = this.textarea.parentNode;
		while(formNode)
		{
			if(formNode.tagName.toLowerCase() == 'form')
			{
				this.form = formNode;
				break;
			}
			formNode = formNode.parentNode;
		}
		
		// setup editor
		var parentNode = this.textarea.parentNode,
			width = this.textarea.style.width,
			height = this.textarea.style.height;
		
		var editorMainDiv = document.createElement('div');
		editorMainDiv.style.width = width;
		editorMainDiv.className = 'htmlEditorMainDiv';
		
		var editorToolbarDiv = document.createElement('div');
		editorToolbarDiv.style.width = '100%';
		editorToolbarDiv.className = 'htmlEditorToolbarDiv';
		this.initToolbar(editorToolbarDiv);
		
		var editorIFrame = document.createElement('iframe');
		editorIFrame.style.width = '100%';
		editorIFrame.style.height = '100%';
		editorIFrame.setAttribute('id', 'iframe_' + this.textareaID);
		editorIFrame.setAttribute('border', '0');
		editorIFrame.setAttribute('frameBorder', '0');
		editorIFrame.setAttribute('scrolling', 'yes');
		
		var editorDiv = document.createElement('div');
		editorDiv.style.height = height;
		editorDiv.appendChild(editorIFrame);
		
		this.initSmileyDiv();
		
		editorMainDiv.insertBefore(this.smileyDiv, editorMainDiv.firstChild);
		editorMainDiv.insertBefore(editorDiv, editorMainDiv.firstChild);
		editorMainDiv.insertBefore(editorToolbarDiv, editorMainDiv.firstChild);
		
		parentNode.insertBefore(editorMainDiv, this.textarea);
		
		this.editorDiv = editorDiv;
		this.editorMainDiv = editorMainDiv;
		this.iFrame = editorIFrame;
		this.textarea.style.display = 'none';
	}
	
	this.initToolbar = function(container)
	{
		var tbTable = document.createElement('table'),
			tbTR = document.createElement('tr'),
			tbBody = document.createElement('tbody');
		tbBody.appendChild(tbTR);
		tbTable.appendChild(tbBody);
		tbTable.style.width = '100%';
		
		// source switch
		var sourceTD = document.createElement('td'),
			sourceLabel = document.createElement('label'),
			sourceCheckBox = document.createElement('input');
		sourceTD.style.textAlign = 'right';
		sourceTD.style.paddingRight = '5px';
		sourceCheckBox.setAttribute('type', 'checkbox');
		sourceCheckBox.setAttribute('id', 'sourceCheckBox_' + this.textareaID);
		sourceCheckBox.onclick = function() { __htmlEditorSource(this.checked, this.id); }
		sourceLabel.setAttribute('for', 'sourceCheckBox_' + this.textareaID);
		sourceLabel.appendChild(document.createTextNode(lang['source']));
		sourceTD.appendChild(sourceCheckBox);
		sourceTD.appendChild(sourceLabel);
		tbTR.insertBefore(sourceTD, tbTR.firstChild);
		
		// buttons
		for(var i=this.toolbarItems.length-1; i>=0; i--)
		{
			var item = this.toolbarItems[i],
				button = document.createElement('td');
			
			if(item == null)
			{
				button.setAttribute('width', '5px');
			}
			else
			{
				button.setAttribute('width', '1px');
				var buttonImg = document.createElement('img');
				buttonImg.setAttribute('id', 'htmled_' + this.textareaID + '_button_' + i);
				buttonImg.setAttribute('src', this.tbPath + item + '.gif');
				buttonImg.setAttribute('border', '0');
				buttonImg.className = 'htmlEditorToolbarButton';
				
				var buttonA = document.createElement('a');
				buttonA.id = 'btn_' + this.textareaID + '_' + i;
				buttonA.setAttribute('href', 'javascript:__htmlEditors[\''+this.textareaID+'\'].tbCommand(\''+item+'\',\'htmled_' + this.textareaID + '_button_' + i + '\');');
				buttonA.onfocus = function() { __htmlEditorButtonFocus(this.id); }
				buttonA.className = 'htmlEditorToolbarLink';
				buttonA.appendChild(buttonImg);
				
				button.appendChild(buttonA);
			}
			
			tbTR.insertBefore(button, tbTR.firstChild);
		}
		
		// sizes
		var sizeSelect = document.createElement('select'),
			sizeTD = document.createElement('td');
		var c = 0, sIndex = 0;
		for(var i=4; i>=1; i--)
		{
			var size = '' + i;
			if(this.defaultSize == size)
				sIndex = c;
			sizeSelect.options[c++] = new Option(size, size, this.defaultSize == size);
		}
		sizeSelect.id = 'sizeSelect_' + this.textareaID;
		sizeSelect.onchange = function() { __htmlEditorSizeChanged(this.id); }
		sizeSelect.selectedIndex = sIndex;
		sizeTD.setAttribute('width', '1px');
		sizeTD.appendChild(sizeSelect);
		tbTR.insertBefore(sizeTD, tbTR.firstChild);
		
		// fonts
		var fontSelect = document.createElement('select'),
			fontTD = document.createElement('td');
		for(var i=0; i<this.fonts.length; i++)
		{
			if(this.defaultFont==this.fonts[i])
				sIndex = i;
			fontSelect.options[i] = new Option(this.fonts[i], this.fonts[i], this.defaultFont==this.fonts[i]);
		}
		fontSelect.id = 'fontSelect_' + this.textareaID;
		fontSelect.onchange = function() { __htmlEditorFontChanged(this.id); }
		fontSelect.selectedIndex = sIndex;
		fontTD.setAttribute('width', '1px');
		fontTD.appendChild(fontSelect);
		tbTR.insertBefore(fontTD, tbTR.firstChild);
		this.fontSelect = fontSelect;
		this.sizeSelect = sizeSelect;
		
		// => container
		container.appendChild(tbTable);
	}
	
	this.submit = function()
	{
		if(this.mode == 'html')
			this.textarea.value = this.document.body.innerHTML;
		if(this.mode == 'source')
			this.mode = 'html';
		if(this.modeField)
			document.getElementById(this.modeField).value = this.mode;
	}
	
	this.start = function()
	{
		this.document = this.getIFrameDocument();
		this.initialText = this.textarea.value;
		
		if(this.browserIE)
			this.document.write(this.textarea.value);
		else
			this.document.body.innerHTML = this.textarea.value;
		if(this.document.designMode)
			this.document.designMode = 'on';
		this.focus();
		
		window.setTimeout('__htmlEditors[\'' + this.textareaID + '\'].start2()', 100);
	}
	
	this.start2 = function()
	{
		this.focus();
		this.setFont(this.defaultFont);
		this.setSize(this.defaultSize);
		this.focus();
	}
	
	this.fontCtlChanged = function(obj)
	{
		this.setFont(obj.value);
		this.focus();
	}
	
	this.sizeCtlChanged = function(obj)
	{
		this.setSize(obj.value);
		this.focus();
	}
	
	this.execCommand = function(cmd, arg)
	{
		if(!arg)
			arg = '';
		this.document.execCommand(cmd, false, arg);
	}
	
	this.tbCommand = function(cmd, button)
	{
		if(cmd == 'bold')
			this.setBold();
		else if(cmd == 'italic')
			this.setItalic();
		else if(cmd == 'underlined')
			this.setUnderlined();
		else if(cmd == 'strikethrough')
			this.setStrikethrough();
		else if(cmd == 'justifyleft')
			this.justifyLeft();
		else if(cmd == 'justifycenter')
			this.justifyCenter();
		else if(cmd == 'justifyright')
			this.justifyRight();
		else if(cmd == 'undo')
			this.undo();
		else if(cmd == 'redo')
			this.redo();
		else if(cmd == 'smiley')
			this.showSmilies(button);
	}
	
	this.initSmileyDiv = function()
	{
		this.smileyDiv = document.createElement('div');
		this.smileyDiv.setAttribute('id', 'smileyDiv_' + this.textareaID);
		this.smileyDiv.className = 'htmlEditorSmileyDiv';
		this.smileyDiv.style.display = 'none';
		
		for(var i=0; i<this.smileyCount; i++)
		{
			var smileyImg = document.createElement('img');
			smileyImg.setAttribute('id', 'smileyImg_' + this.textareaID + '_' + i);
			smileyImg.src = this.smileyPath + i + '.gif';
			smileyImg.className = 'htmlEditorSmileyImg';
			smileyImg.onclick = function() { __htmlEditorInsertSmiley(this.id); };
			this.smileyDiv.appendChild(smileyImg);
		}
	}
	
	this.insertSmiley = function(i)
	{
		if(this.mode != 'html')
			return;
			
		this.hideSmilies();
		this.insertText('<img src="' + this.smileyPath + i + '.gif" border="0" alt="" />');
		this.setFont(this.fontSelect.value);
		this.setSize(this.sizeSelect.value);
		this.focus();
	}
	
	this.hideSmilies = function(button)
	{
		this.smileyDiv.style.display = 'none';
	}
	
	this.showSmilies = function(button)
	{
		button = EBID(button);
		__htmlEditorCurrentID = this.textareaID;
		document.onclick = function() { __htmlEditorHideSmilies(); };
		
		this.smileyDiv.style.left = getElementMetrics(button, 'x') + 'px';
		this.smileyDiv.style.top = (getElementMetrics(button, 'y')+getElementMetrics(button, 'h')-1) + 'px';
		this.smileyDiv.style.display = '';
	}
	
	this.setBold = function()
	{
		this.execCommand('bold');
	}
	
	this.setItalic = function()
	{
		this.execCommand('italic');
	}
	
	this.setUnderlined = function()
	{
		this.execCommand('underline');
	}
	
	this.setStrikethrough = function()
	{
		this.execCommand('strikethrough');
	}
	
	this.setIndent = function()
	{
		this.execCommand('indent');
	}
	
	this.setOutdent = function()
	{
		this.execCommand('outdent');
	}
	
	this.setFont = function(name)
	{
		this.execCommand('fontname', name);
	}
	
	this.setSize = function(size)
	{
		this.execCommand('fontsize', size);
	}
	
	this.setColor = function(color)
	{
		this.execCommand('fontcolor', color);
	}
	
	this.undo = function()
	{
		this.execCommand('undo');
	}
	
	this.redo = function()
	{
		this.execCommand('redo');
	}
	
	this.justifyLeft = function()
	{
		this.execCommand('justifyleft');
	}
	
	this.justifyCenter = function()
	{
		this.execCommand('justifycenter');
	}
	
	this.justifyRight = function()
	{
		this.execCommand('justifyright');
	}
	
	this.toolbarItems = new Array(null,
									'bold', 'italic', 'underlined', 'strikethrough',
									null,
									'justifyleft', 'justifycenter', 'justifyright',
									null,
									'smiley',
									null,
									'undo', 'redo');
	this.fonts = new Array('Arial', 'Comic Sans MS', 'Courier New', 'Tahoma', 'Times New Roman', 'Verdana');
	this.defaultFont = 'Arial';
	this.defaultSize = '2';
	this.textareaID = textareaID;
	this.textarea = document.getElementById(textareaID);
	this.document = null;
	this.editorDiv = null;
	this.iFrame = null;
	this.form = null;
	this.tbPath = tbPath;
	this.mode = 'html';
	this.modeField = null;
	this.initialText = '';
	this.initialMode = '';
	this.smileyCount = 33;
	this.smileyPath = document.location.href;
	this.smileyPath = this.smileyPath.replace('/admin', '').replace(/\/[^\/]*$/, '') + '/res/smilies/';
	this.smileyDiv = null;
	this.fontSelect = null;
	this.sizeSelect = null;
	__htmlEditors[textareaID] = this;
}

//-->