<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: email.compose.php,v 1.61 2009/02/17 14:03:36 patrick Exp $
 *
 */

include('./serverlib/init.inc.php');
include('./serverlib/safecode.class.php');
include('./serverlib/mailbox.class.php');
if(!class_exists('BMMailBuilder'))
	include('./serverlib/mailbuilder.class.php');
RequestPrivileges(PRIVILEGES_USER);

/**
 * file handler for modules
 */
ModuleFunction('FileHandler',
	array(substr(__FILE__, strlen(dirname(__FILE__))+1),
	isset($_REQUEST['action']) ? $_REQUEST['action'] : ''));

/**
 * shared email code
 */
include('./serverlib/email.top.php');

/**
 * default action = start
 */
if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'compose';

/**
 * compose
 */
if($_REQUEST['action'] == 'compose')
{
	$possibleSenders = $thisUser->GetPossibleSenders();
	$mail = array();
	$reference = '';
	$textMode = $userRow['soforthtml'] == 'yes' ? 'html' : 'text';
	
	// set S/MIME settings
	$mail['smimeSign'] = $thisUser->GetPref('smimeSign');
	$mail['smimeEncrypt'] = $thisUser->GetPref('smimeEncrypt');
	
	// reply, forward or redirect?
	if(isset($_REQUEST['reply'])			// all?
		|| (isset($_REQUEST['forward']) && !is_array($_REQUEST['forward']))
		|| isset($_REQUEST['redirect']))
	{
		$action 	= isset($_REQUEST['reply'])
						? 'reply'
						: (isset($_REQUEST['forward'])
							? 'forward'
							: 'redirect');
		$sourceID	= (int)(isset($_REQUEST['reply'])
							? $_REQUEST['reply']
							: (isset($_REQUEST['forward'])
								? $_REQUEST['forward']
								: $_REQUEST['redirect']));
		$reference = $action . ':' . $sourceID;
		$sourceMail	= $mailbox->GetMail($sourceID);
		
		// get text part
		$textParts = $sourceMail->GetTextParts();
		if(isset($textParts['html'])
			&& ($userRow['soforthtml'] == 'yes' || isset($_REQUEST['htmlView'])))
		{
			$textMode = 'html';
			$text = $textParts['html'];
		}
		else if(isset($textParts['text']))
		{
			$textMode = 'text';
			$text = formatEMailText($textParts['text'], false);
		}
		else if(isset($textParts['html']) && $userRow['soforthtml'] == 'no')
		{
			$textMode = 'text';
			$text = htmlToText($textParts['html']);
		}
		else 
		{
			$textMode = 'text';
			$text = '';
		}
		
		// ...and text
		if(isset($_REQUEST['text']))
		{
			$textMode = 'text';
			$mail['text'] = formatComposeText($_REQUEST['text'], 'text', $action, $sourceMail);
		}
		else 
			$mail['text'] = formatComposeText($text, $textMode, $action, $sourceMail);
				
		// subject
		$mail['subject'] = ($action == 'reply'
								? trim($userRow['re']) . ' '
								: ($action == 'redirect'
									? ''
									: trim($userRow['fwd']) . ' ')) . $sourceMail->GetHeaderValue('subject');
		
		// suggest encryption if source mail is encrypted
		$mail['smimeEncrypt'] = $mail['smimeEncrypt'] || ($sourceMail->smimeStatus & SMIME_DECRYPTED) != 0;
		
		// recipients
		if($action == 'redirect')
		{
			$mail['to'] = $sourceMail->GetHeaderValue('to');
			$mail['cc'] = $sourceMail->GetHeaderValue('cc');
			$mail['bcc'] = $sourceMail->GetHeaderValue('bcc');
			$mail['replyto'] = $sourceMail->GetHeaderValue('reply-to');
			$mail['priority'] = $sourceMail->GetHeaderValue('x-priority') == 5 
				? ITEMPRIO_LOW
				: ($sourceMail->GetHeaderValue('x-priority') == 1
					? ITEMPRIO_HIGH
					: ITEMPRIO_NORMAL);
		}
		else if($action == 'reply')
		{
			if(($replyTo = $sourceMail->GetHeaderValue('reply-to')) && $replyTo != '')
				$mail['to'] = $replyTo;
			else 
				$mail['to'] = $sourceMail->GetHeaderValue('from');
			if(($origTo = ExtractMailAddress($sourceMail->GetHeaderValue('to'))) != ''
				&& BMWorkgroup::GetIDbyMail($origTo) != 0)
				$mail['replyto'] = $origTo;
			
			if(isset($_REQUEST['all']))
			{
				$recpList = array_merge(ExtractMailAddresses($sourceMail->GetHeaderValue('to')),
											ExtractMailAddresses($sourceMail->GetHeaderValue('cc')));
				foreach($recpList as $key=>$val)
					if(strtolower($val) == strtolower(ExtractMailAddress($mail['to'])))
						unset($recpList[$key]);
					else 
						foreach($possibleSenders as $possibleSender)
							if(strtolower(ExtractMailAddress($possibleSender)) == strtolower($val))
							{
								unset($recpList[$key]);
								break;
							}
				$mail['cc'] = implode('; ', $recpList);
			}
		}
		
		// sender
		$recpList = array_merge(ExtractMailAddresses($sourceMail->GetHeaderValue('to')),
									ExtractMailAddresses($sourceMail->GetHeaderValue('cc')));
		$defaultSenderWithName = strchr($thisUser->GetDefaultSender(), '"') !== false;
		foreach($recpList as $val)
		{
			foreach($possibleSenders as $possibleSenderID=>$possibleSender)
				if(strtolower(ExtractMailAddress($possibleSender)) == strtolower($val))
				{
					if((strchr($possibleSender, '"') !== false && $defaultSenderWithName)
						|| (strchr($possibleSender, '"') === false && !$defaultSenderWithName))
					{
						$mail['from'] = $possibleSenderID;
						break;
					}
				}
		}
		
		
		// attachments?
		if($action == 'forward'
				|| $action == 'redirect')
		{
			$attachments = $sourceMail->GetAttachments();
			$parts = $sourceMail->GetPartList();
			$attachmentList = '';
			
			foreach($attachments as $attID=>$attInfo)
			{
				// get temp file
				$tempFileID = RequestTempFile($userRow['id'], time()+8*TIME_ONE_HOUR);
				$tempFileName = TempFileName($tempFileID);
				$tempFP = fopen($tempFileName, 'wb');
				assert('is_resource($tempFP)');
				
				// copy attachment to temp file
				$part = $parts[$attID];
				$attData = &$part['body'];
				$attData->Init();
				while($block = $attData->DecodeBlock(PART_CHUNK_SIZE))
				{
					fwrite($tempFP, $block);
				}
				$attData->Finish();
				
				// add to list
				$attachmentString = sprintf(';%d,%s,%s',
					$tempFileID,
					ereg_replace('[^0-9a-zA-Z\_\. -]', '', $attInfo['filename']),
					ereg_replace('[^0-9a-zA-Z\_\.\/-]', '', $attInfo['mimetype']));
				$attachmentList .= $attachmentString;
			}
			
			if($attachmentList != '')
				$mail['attachments'] = $attachmentList;
		}
	}
	
	// multi forward
	else if(isset($_REQUEST['forward']) && is_array($_REQUEST['forward']))
	{
		$attachmentList = '';
		
		foreach($_REQUEST['forward'] as $forwardID)
		{
			$forwardMail = $mailbox->GetMail((int)$forwardID);
			
			if($forwardMail !== false)
			{
				$messageFP = $forwardMail->GetMessageFP();
				
				// get temp file
				$tempFileID = RequestTempFile($userRow['id'], time()+8*TIME_ONE_HOUR);
				$tempFileName = TempFileName($tempFileID);
				$tempFP = fopen($tempFileName, 'wb');
				assert('is_resource($tempFP)');
				
				// copy attachment to temp file
				while($block = fread($messageFP, 4096))
				{
					fwrite($tempFP, $block);
				}
				fclose($messageFP);
				
				// add to list
				$attachmentString = sprintf(';%d,%d.eml,%s',
					$tempFileID,
					(int)$forwardID,
					'message/rfc822');
				$attachmentList .= $attachmentString;
			}
		}
		
		if($attachmentList != '')
			$mail['attachments'] = $attachmentList;
	}
	
	// to, cc or subject given?
	if(isset($_REQUEST['to']))
		$mail['to'] = $_REQUEST['to'];
	if(isset($_REQUEST['cc']))
		$mail['cc'] = $_REQUEST['cc'];
	if(isset($_REQUEST['subject']))
		$mail['subject'] = $_REQUEST['subject'];
		
	// set edit mode...
	$mail['textMode'] = $textMode;
	
	// sender?
	if(!isset($mail['from']))
		$mail['from'] = $userRow['defaultSender'];
		
	// wait time?
	$waitTime = 0;
	if(($userRow['last_send'] + $groupRow['send_limit']) > time())
		$waitTime = ($userRow['last_send'] + $groupRow['send_limit']) - time();
	
	// safe code?
	if($bm_prefs['mail_send_code'] == 'yes')
	{
		$tpl->assign('codeID', Safecode::RequestCode());
	}
	
	// assign
	$tpl->assign('pageTitle', $lang_user['sendmail']);
	$tpl->assign('useCourier', $userRow['plaintext_courier'] == 'yes');
	$tpl->assign('signatures', $thisUser->GetSignatures());
	$tpl->assign('reference', $reference);
	$tpl->assign('mail', $mail);
	$tpl->assign('possibleSenders', $possibleSenders);
	$tpl->assign('smime', $groupRow['smime'] == 'yes');
	$tpl->assign('pageContent', 'li/email.compose.tpl');
	$tpl->assign('waitTime', $waitTime);
	$tpl->display('li/index.tpl');
}

/**
 * add attachment
 */
else if($_REQUEST['action'] == 'addAttachment')
{
	// compute max size
	$attSize = 0;
	if(strlen(trim($_REQUEST['attList'])) > 3)
	{
		$attachments = explode(';', $_REQUEST['attList']);
		foreach($attachments as $attachment)
			if(strlen(trim($attachment)) > 3)
			{
				list($tempFileID, $fileName, $contentType) = explode(',', $attachment);
				$tempFileID = (int)$tempFileID;
				if(ValidTempFile($userRow['id'], $tempFileID))
					$attSize += filesize(TempFileName($tempFileID));
			}
	}
	
	// space left?
	$attLeft = $groupRow['anlagen'] - $attSize;
	
	// assign
	$tpl->assign('bar', array('value' => $attSize, 'max' => $groupRow['anlagen']));
	$tpl->assign('title', $lang_user['addattach']);
	$tpl->assign('text', $lang_user['addattachtext']);
	$tpl->assign('formAction', 'email.compose.php?action=uploadAttachment&spaceLeft=' . $attLeft . '&sid=' . session_id());
	$tpl->assign('fieldName', 'attachFile');
	$tpl->display('li/dialog.openfile.tpl');
}

/**
 * get attachment
 */
else if($_REQUEST['action'] == 'getAttachment'
		&& isset($_REQUEST['id'])
		&& isset($_REQUEST['type'])
		&& isset($_REQUEST['name'])
		&& ValidTempFile($userRow['id'], (int)$_REQUEST['id']))
{
	$contentDisposition = (in_array(strtolower($_REQUEST['type']), $VIEWABLE_TYPES))
		? 'inline'
		: 'attachment';
	$tempFileName = TempFileName((int)$_REQUEST['id']);
	$tempFP = fopen($tempFileName, 'rb');
	
	if($tempFP)
	{
		// headers
		header(sprintf('Content-Disposition: %s; filename="%s"',
			$contentDisposition,
			addslashes($_REQUEST['name'])));
		header('Content-Type: %s',
			$_REQUEST['type']);
		header(sprintf('Content-Length: %d',
			filesize($tempFileName)));
		
		// output
		readfile($tempFileName);
		exit();
	}
}

/**
 * upload attachment
 */
else if($_REQUEST['action'] == 'uploadAttachment'
		&& isset($_REQUEST['spaceLeft'])
		&& $_REQUEST['spaceLeft'] <= $groupRow['anlagen'])
{
	$tempFileID = RequestTempFile($userRow['id'], time()+8*TIME_ONE_HOUR);
	$tempFileName = TempFileName($tempFileID);
	
	echo '<script language="javascript">' . "\n";
	echo '<!--' . "\n";
	
	// get uploaded file
	$file = getUploadedFile('attachFile', $tempFileName);
	if(!$file)
	{
		ReleaseTempFile($userRow['id'], $tempFileID);
	}
	else 
	{
		if($file['size'] <= $_REQUEST['spaceLeft'])
		{
			$attachmentString = sprintf(';%d,%s,%s',
				$tempFileID,
				ereg_replace('[^0-9a-zA-Z\_\-\. ]', '', $file['name']),
				ereg_replace('[^0-9a-zA-Z\_\-\.\/]', '', $file['type']));
			echo 'parent.document.getElementById(\'attachments\').value += \'' . addslashes($attachmentString) . '\';' . "\n";
			echo 'parent.generateAttachmentList();' . "\n";
		}
		else 
		{
			ReleaseTempFile($userRow['id'], $tempFileID);
			echo 'alert(\'' . addslashes(sprintf($lang_user['toobigattach'], round($groupRow['anlagen']/1024, 2))) . '\');' . "\n";
		}
	}
	
	echo 'parent.hideOverlay();' . "\n";
	echo '//-->' . "\n";
	echo '</script>' . "\n";
}

/**
 * delete attachment
 */
else if($_REQUEST['action'] == 'deleteAttachment'
	&& isset($_REQUEST['id']))
{
	$id = (int)$_REQUEST['id'];
	die(ReleaseTempFile($userRow['id'], $id) ? '1' : '0');	
}

/**
 * send mail
 */
else if($_REQUEST['action'] == 'sendMail')
{
	// wait time?
	if(($userRow['last_send'] + $groupRow['send_limit']) > time() && $_REQUEST['do'] != 'saveDraft')
	{
		$tpl->assign('msg', sprintf($lang_user['waituntil3'], ($userRow['last_send'] + $groupRow['send_limit']) - time()));
		$tpl->assign('pageContent', 'li/error.tpl');
	}
	else 
	{
		// safecode?
		if($bm_prefs['mail_send_code'] == 'yes'
			&& (strlen($code = Safecode::GetCode((int)$_REQUEST['codeID'])) < 4
				|| trim(strtolower($_REQUEST['safecode'])) != strtolower($code)))
		{
			Safecode::ReleaseCode((int)$_REQUEST['codeID']);
			$tpl->assign('msg', $lang_user['invalidcode']);
			$tpl->assign('pageContent', 'li/error.tpl');
		}
		else 
		{
			// release safecode, if used
			if($bm_prefs['mail_send_code'] == 'yes')
				Safecode::ReleaseCode((int)$_REQUEST['codeID']);
			
			// no recipients?
			$recipients = ExtractMailAddresses($_REQUEST['to'] . ' ' . $_REQUEST['cc'] . ' ' . $_REQUEST['bcc']);
			if(count($recipients) > 0 || $_REQUEST['do'] == 'saveDraft')
			{
				// too much recipients?
				if(count($recipients) > $bm_prefs['max_bcc'])
				{
					$tpl->assign('msg', sprintf($lang_user['toomanyrecipients'], $bm_prefs['max_bcc'], count($recipients)));
					$tpl->assign('pageContent', 'li/error.tpl');	
				}
				else 
				{
					//
					// headers
					//
					$to 	= $_REQUEST['to'];
					$cc 	= $_REQUEST['cc'];
					$bcc 	= $_REQUEST['bcc'];
					
					// sender?
					$senderAddresses = $thisUser->GetPossibleSenders();
					if(isset($senderAddresses[$_REQUEST['from']]))
						$from = $senderAddresses[$_REQUEST['from']];
					else 
						$from = $senderAddresses[0];
					
					// prepare header fields
					$to = trim(str_replace(array("\r", "\t", "\n"), '', $to));
					$cc = trim(str_replace(array("\r", "\t", "\n"), '', $cc));
					$bcc = trim(str_replace(array("\r", "\t", "\n"), '', $bcc));
					$subject = trim(str_replace(array("\r", "\t", "\n"), '', $_REQUEST['subject']));
					if(count(ExtractMailAddresses($_REQUEST['replyto'])) > 0)
						$replyTo = trim(str_replace(array("\r", "\t", "\n"), '', $_REQUEST['replyto']));
					else 
						$replyTo = $from;
						
					// build the mail
					$mail = _new('BMMailBuilder');
				
					// s/mime?
					if($groupRow['smime'] == 'yes')
					{
						$mail->_smimeUser = &$thisUser;
						
						// sign?
						if(isset($_REQUEST['smimeSign']))
							$mail->_smimeSign = true;
							
						// encrypt?
						if(isset($_REQUEST['smimeEncrypt']))
							$mail->_smimeEncrypt = true;
					}
					
					// mandatory headers
					$mail->AddHeaderField('X-Sender-IP',	$_SERVER['REMOTE_ADDR']);
					$mail->AddHeaderField('From', 			$from);
					$mail->AddHeaderField('Subject', 		$subject);
					$mail->AddHeaderField('Reply-To', 		$replyTo);
					
					// optional headers
					if($to != '')
						$mail->AddHeaderField('To',	 	$to);
					if($cc != '')
						$mail->AddHeaderField('Cc', 	$cc);
					if($bcc != '')
						$mail->AddHeaderField('Bcc', 	$bcc);
					
					// priority
					if($_REQUEST['priority'] != 0)
					{
						$mail->AddHeaderField('X-Priority', $_REQUEST['priority'] == ITEMPRIO_HIGH
							? 1
							: ($_REQUEST['priority'] == ITEMPRIO_LOW
								? 5
								: 3));
					}
					
					// mail confirmation?
					if(isset($_REQUEST['mailConfirmation']))
						$mail->AddHeaderField('Disposition-Notification-To', $replyTo);
					
					// ref headers
					if(isset($_REQUEST['reference']) && strpos($_REQUEST['reference'], ':') !== false)
					{
						list($type, $id) = explode(':', $_REQUEST['reference']);
						
						$referencedMail = $mailbox->GetMail($id);
						if($referencedMail !== false)
						{
							if($type == 'reply')
								$mail->AddHeaderField('In-Reply-To', $referencedMail->GetHeaderValue('message-id'));
							
							if($type == 'reply' || $type == 'forward')
							{
								$msgReferences = ExtractMessageIDs($referencedMail->GetHeaderValue('references'));
								$msgReferences[] = $referencedMail->GetHeaderValue('message-id');
								
								if(count($msgReferences) > 10)
									$msgReferences = array_slice($msgReferences, count($msgReferences)-10);
								
								$mail->AddHeaderField('References', implode(' ', $msgReferences));
							}
						}
					}
					
					//
					// add text
					//
					$mailText = $_REQUEST['emailText'];
					if($_REQUEST['newTextMode'] == 'html')
					{
						$mailText .= GetSigStr('html');
						ModuleFunction('OnSendMail', array(&$mailText, true));
						
						// html mail
						$mail->AddText('<html>' . $mailText . '</html>',
							'html',
							$currentCharset);
					}
					else
					{
						$mailText .= GetSigStr('text');
						ModuleFunction('OnSendMail', array(&$mailText, false));
						
						// text mail
						$mail->AddText($mailText,
							'plain',
							$currentCharset);
					}
					
					//
					// add attachments
					//
					$attSize = 0;
					$attTempFiles = array();
					if(strlen(trim($_REQUEST['attachments'])) > 3)
					{
						$attachments = explode(';', $_REQUEST['attachments']);
						foreach($attachments as $attachment)
						{
							if(strlen(trim($attachment)) > 3)
							{
								list($tempFileID, $fileName, $contentType) = explode(',', $attachment);
								$tempFileID = (int)$tempFileID;
								if(ValidTempFile($userRow['id'], $tempFileID))
								{
									if(($attSize + filesize(TempFileName($tempFileID))) <= $groupRow['anlagen'])
									{
										// open attachment
										if($tempFileFP = fopen(TempFileName($tempFileID), 'rb'))
										{								
											// add to mail
											$mail->AddAttachment($tempFileFP,
												$contentType,
												$fileName);
											
											// add temp id to delete list
											$attTempFiles[] = array($tempFileID, $tempFileFP);
											$attSize += filesize(TempFileName($tempFileID));
										}
									}
									else 
									{
										// add temp id to delete list
										$attTempFiles[] = array($tempFileID, $tempFileFP);
									}
								}
							}
						}
					}
					
					//
					// add vcard?
					//
					if(isset($_REQUEST['attachVCard']))
					{
						// add to mail
						$mail->AddAttachment($thisUser->BuildVCard(),
							'text/x-vcard',
							ereg_replace('[^0-9a-zA-Z ]', '', $userRow['vorname'] . ' ' . $userRow['nachname']) . '.vcf');
					}
					
					//
					// send!
					//
					if($_REQUEST['do'] == 'saveDraft'
						|| isset($_REQUEST['certMail']))
						$outboxFP = $mail->Build();
					else
						$outboxFP = $mail->Send();
					
					//
					// ok?
					//
					if($outboxFP && is_resource($outboxFP))
					{			
						if($_REQUEST['do'] != 'saveDraft')
						{		
							//
							// update stats
							//
							Add2Stat('send');
							$domains = explode(':', $bm_prefs['domains']);
							$local = false;
							foreach($domains as $domain)
								if(strpos(strtolower($to . $cc . $bcc), '@'.strtolower($domain)) !== false)
									$local = true;
							Add2Stat('send_'.($local ? 'intern' : 'extern'));
							$thisUser->UpdateLastSend(count($recipients));
				
							//
							// add log entry
							//
							PutLog(sprintf('<%s> (%d, IP: %s) sends%s mail from <%s> to <%s> using compose form',
								$userRow['email'],
								$userRow['id'],
								$_SERVER['REMOTE_ADDR'],
								isset($_REQUEST['certMail']) ? ' certified' : '',
								ExtractMailAddress($from),
								implode('>, <', $recipients)),
								PRIO_NOTE,
								__FILE__,
								__LINE__);
								
							//
							// reference
							//
							if(isset($_REQUEST['reference']) && strpos($_REQUEST['reference'], ':') !== false)
							{
								list($type, $id) = explode(':', $_REQUEST['reference']);
								if($type == 'reply')
									$mailbox->FlagMail(FLAG_ANSWERED, true, (int)$id);
								else if($type == 'forward')
									$mailbox->FlagMail(FLAG_FORWARDED, true, (int)$id);
							}
							
							ModuleFunction('AfterSendMail', array($userRow['id'], ExtractMailAddress($from), $recipients));
					
							$tpl->assign('title', $lang_user['sendmail']);
							$tpl->assign('msg', $lang_user['mailsent']);
							$tpl->assign('backLink', 'email.php?sid=' . session_id());
							$tpl->assign('pageContent', 'li/msg.tpl');
						}
						
						//
						// save copy
						//
						$saveTo = $_REQUEST['do'] == 'saveDraft'
							? FOLDER_DRAFTS
							: (int)$_REQUEST['savecopy'];
						$mailObj = _new('BMMail', array(0, false, $outboxFP, false));
						$mailObj->Parse();
						$mailObj->ParseInfo();
						$mailbox->StoreMail($mailObj, $saveTo);
						
						//
						// certified mail?
						//
						if(isset($_REQUEST['certMail']))
						{
							$mailID = $mailbox->_lastInsertId;
							if($mailID)
							{
								$mailbox->SendCertMail($mailID, $mailObj);
							}
						}
						
						//
						// train as NON-spam
						//
						if($userRow['spamfilter'] == 'yes' && $bm_prefs['use_bayes'] == 'yes'
							&& $userRow['unspamme'] == 'yes'
							&& $_REQUEST['do'] != 'saveDraft')
						{
							$mailbox->SetSpamStatus($mailbox->_lastInsertId, false);
						}
						
						//
						// clean up
						//
						$mail->CleanUp();
						foreach($attTempFiles as $attData)
						{
							list($tempFileID, $tempFileFP) = $attData;
							fclose($tempFileFP);
							ReleaseTempFile($userRow['id'], $tempFileID);
						}
						
						//
						// draft folder?
						//
						if($_REQUEST['do'] == 'saveDraft')
						{
							header('Location: email.php?folder=' . FOLDER_DRAFTS . '&sid=' . session_id());
							exit();
						}
					}
					else 
					{
						$tpl->assign('msg', $lang_user['sendfailed']);
						$tpl->assign('pageContent', 'li/error.tpl');
					}
				}
			}
			else 
			{
				$tpl->assign('msg', $lang_user['norecipients']);
				$tpl->assign('pageContent', 'li/error.tpl');			
			}
		}
	}
	
	$tpl->assign('pageTitle', $lang_user['sendmail']);
	$tpl->display('li/index.tpl');
}

/**
 * get signature RPC
 */
else if($_REQUEST['action'] == 'getSignature'
		&& isset($_REQUEST['id'])
		&& isset($_REQUEST['mode']))
{
	$signature = $thisUser->GetSignature((int)$_REQUEST['id']);
	
	if($signature)
		if($_REQUEST['mode'] == 'html')
		{
			if(trim(strip_tags($signature['html'])) != '')
				echo($signature['html']);
			else 
				echo(nl2br(HTMLFormat($signature['text'])));
		}
		else 
		{
			if(trim($signature['text']) != '')
				echo($signature['text']);
			else 
				echo(htmlToText($signature['html']));
		}
	exit();
}

/**
 * check S/MIME params RPC
 */
else if($_REQUEST['action'] == 'checkSMIMEParams'
		&& isset($_REQUEST['sign'])
		&& isset($_REQUEST['encrypt'])
		&& isset($_REQUEST['from'])
		&& isset($_REQUEST['to'])
		&& isset($_REQUEST['cc'])
		&& isset($_REQUEST['bcc']))
{
	$senderAddresses 	= $thisUser->GetPossibleSenders();
	$sign 				= $_REQUEST['sign'] == '1';
	$encrypt			= $_REQUEST['encrypt'] == '1';
	$recipients 		= ExtractMailAddresses($_REQUEST['to'] . ' ' . $_REQUEST['cc'] . ' ' . $_REQUEST['bcc']);
	$sender				= isset($senderAddresses[$_REQUEST['from']])
							? ExtractMailAddress($senderAddresses[$_REQUEST['from']])
							: ExtractMailAddress($senderAddresses[0]);
	
	// check recicpient count
	if(count($recipients) < 1)
	{
		echo($lang_user['smimeerr0']);
		exit();
	}
	
	// check PK
	if($sign)
	{
		$missing = $thisUser->GetRecipientsWithMissingCertificate(array($sender), CERTIFICATE_TYPE_PRIVATE);
		
		if(count($missing) > 0)
		{
			echo($lang_user['smimeerr1']);
			exit();
		}
	}

	// check if certs for recipients exist
	if($encrypt)
	{
		$missing = $thisUser->GetRecipientsWithMissingCertificate($recipients);
		
		if(count($missing) > 0)
		{
			echo($lang_user['smimeerr2'] . "\n\n  - ");
			echo(implode("\n  - ", $missing));
			exit();
		}
	}
	
	// OK
	echo('1');
	exit();
}
?>