<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: email.php,v 1.25 2008/12/09 19:15:34 patrick Exp $
 *
 */

include('./serverlib/init.inc.php');
include('./serverlib/mailbox.class.php');
include('./serverlib/zip.class.php');
RequestPrivileges(PRIVILEGES_USER);

/**
 * file handler for modules
 */
ModuleFunction('FileHandler',
	array(substr(__FILE__, strlen(dirname(__FILE__))+1),
	isset($_REQUEST['action']) ? $_REQUEST['action'] : ''));

/**
 * shared email code
 */
include('./serverlib/email.top.php');

/**
 * default action = start
 */
if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'folder';

/**
 * folder view
 */
if($_REQUEST['action'] == 'folder')
{
	$sortColumns = array('von', 'an', 'betreff', 'recdate', 'size');
	
	// get folder id (default = inbox)
	$folderID = (isset($_REQUEST['folder']) && isset($folderList[(int)$_REQUEST['folder']]))
					? (int)$_REQUEST['folder']
					: FOLDER_INBOX;
					
	/**
	 * folder actions
	 */
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'flagMessage'
								&& isset($_REQUEST['id'])
								&& isset($_REQUEST['flag'])
								&& isset($_REQUEST['value']))
	{
		$mailbox->FlagMail((int)$_REQUEST['flag'],
			$_REQUEST['value']==1 ? true : false,
			(int)$_REQUEST['id']);
	}
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'emptyFolder')
	{
		$mailbox->EmptyFolder($folderID);
	}
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'deleteMail'
								&& isset($_REQUEST['id']))
	{
		$mailbox->DeleteMail((int)$_REQUEST['id']);
	}
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'setViewOptions')
	{
		if(in_array($_REQUEST['group_mode'],
					array('-', 'fetched', 'von', 'beantwortet', 'weitergeleitet', 'attach', 'gelesen', 'flagged')))
			$mailbox->SetGroupMode($folderID, $_REQUEST['group_mode']);
		$mailbox->SetMailsPerPage($folderID, (int)$_REQUEST['perpage']);
	}
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'action')
	{
		//
		// collect IDs
		//
		$mailIDs = array();
		foreach($_POST as $key=>$val)
			if(substr($key, 0, 5) == 'mail_')
				$mailIDs[] = (int)substr($key, 5);
	
		//
		// execute action
		//
		if(count($mailIDs) > 0)
		{
			// delete
			if($_REQUEST['massAction'] == 'delete')
			{
				foreach($mailIDs as $mailID)
					$mailbox->DeleteMail($mailID);
			}
			
			// forward
			else if($_REQUEST['massAction'] == 'forward')
			{
				$url = 'email.compose.php?sid=' . session_id();
				foreach($mailIDs as $mailKey=>$mailID)
					$url .= '&forward[' . $mailKey . ']=' . $mailID;
				header('Location: ' . $url);
				exit();
			}
			
			// download
			else if($_REQUEST['massAction'] == 'download')
			{
				$tempFileID = RequestTempFile($userRow['id'], time()+TIME_ONE_HOUR);
				$tempFileName = TempFileName($tempFileID);
				
				// create ZIP file
				$fp = fopen($tempFileName, 'wb+');
				$zip = _new('BMZIP', array($fp));
				foreach($mailIDs as $mailID)
				{
					if($mailbox->MailExists($mailID))
					{
						$zip->AddFile(BMMail::GetMessageFilename($mailID), $mailID . '.eml');
					}
				}
				$size = $zip->Finish();
				
				// headers
				header('Pragma: public');
				header('Content-Disposition: attachment; filename="mails.zip"');
				header('Content-Type: application/zip');
				header(sprintf('Content-Length: %d',
					$size));
				
				// send
				while(!feof($fp))
				{
					$block = fread($fp, 4096);
					echo $block;
				}
				
				// clean up
				fclose($fp);
				ReleaseTempFile($userRow['id'], $tempFileID);
				exit();
			}
			
			// markread
			else if($_REQUEST['massAction'] == 'markread')
			{
				foreach($mailIDs as $mailID)
					$mailbox->FlagMail(FLAG_UNREAD,
						false,
						$mailID);
			}
			
			// markunread
			else if($_REQUEST['massAction'] == 'markunread')
			{
				foreach($mailIDs as $mailID)
					$mailbox->FlagMail(FLAG_UNREAD,
						true,
						$mailID);
			}
			
			// mark
			else if($_REQUEST['massAction'] == 'mark')
			{
				foreach($mailIDs as $mailID)
					$mailbox->FlagMail(FLAG_FLAGGED,
						true,
						$mailID);
			}
			
			// unmark
			else if($_REQUEST['massAction'] == 'unmark')
			{
				foreach($mailIDs as $mailID)
					$mailbox->FlagMail(FLAG_FLAGGED,
						false,
						$mailID);
			}
			
			// mark as spam
			else if($_REQUEST['massAction'] == 'markspam')
			{
				foreach($mailIDs as $mailID)
					$mailbox->SetSpamStatus($mailID, true);
			}
			
			// mark as nonspam
			else if($_REQUEST['massAction'] == 'marknonspam')
			{
				foreach($mailIDs as $mailID)
					$mailbox->SetSpamStatus($mailID, false);
			}
			
			// move to group
			else if(substr($_REQUEST['massAction'], 0, 7) == 'moveto_')
			{
				$destFolderID = (int)substr($_REQUEST['massAction'], 7);
				$mailbox->MoveMail($mailIDs, $destFolderID);
			}
		}
	}
	
	// get page info
	$mailsPerPage = $mailbox->GetMailsPerPage($folderID);
	$pageNo = (isset($_REQUEST['page']))
					? (int)$_REQUEST['page']
					: 1;
	$mailCount = $mailbox->GetMailCount($folderID);
	$pageCount = max(1, ceil($mailCount / max(1, $mailsPerPage)));
	$pageNo = min($pageCount, max(1, $pageNo));
	$groupMode = $mailbox->GetGroupMode($folderID);
	
	// get sort info
	$sortColumn = (isset($_REQUEST['sort']) && in_array($_REQUEST['sort'], $sortColumns))
					? $_REQUEST['sort']
					: 'fetched';
	$sortOrder = (isset($_REQUEST['order']) && in_array($_REQUEST['order'], array('asc', 'desc')))
					? $_REQUEST['order']
					: 'desc';
	
	// get mail list
	$mailList = $mailbox->GetMailList($folderID,
										$pageNo,
										$mailsPerPage,
										$sortColumn,
										$sortOrder,
										$groupMode);
										
	// groups
	if($groupMode != '-')
		$mailList = $mailbox->GroupMailList($mailList, $groupMode);
	
	// update last notify date
	if($folderID == FOLDER_INBOX)
		$mailbox->UpdateLastNotifyDate();
		
	// page output
	$tpl->assign('pageTitle', $folderList[$folderID]['title']);
	$tpl->assign('enablePreview', $userRow['preview'] == 'yes');
	$tpl->assign('refreshInterval', max(15, $userRow['in_refresh']));
	$tpl->assign('perPage', $mailsPerPage);
	$tpl->assign('groupMode', $groupMode);
	$tpl->assign('pageNo', $pageNo);
	$tpl->assign('pageCount', $pageCount);
	$tpl->assign('folderID', $folderID);
	$tpl->assign('folderString', sprintf('folder=%d&sort=%s&order=%s&page=%d', 
											$folderID, $sortColumn, $sortOrder, $pageNo));
	$tpl->assign('mailList', $mailList);
	$tpl->assign('sortColumn', $sortColumn);
	$tpl->assign('sortOrder', $sortOrder);
	$tpl->assign('sortOrderInv', $sortOrder == 'asc' ? 'desc' : 'asc');
	$tpl->assign('folderInfo', $folderList[$folderID]);
	$tpl->assign('pageContent', 'li/email.folder.tpl');
	$tpl->display('li/index.tpl');
}

/**
 * rpc flag
 */
else if($_REQUEST['action'] == 'flagMessage'
		&& isset($_REQUEST['id'])
		&& isset($_REQUEST['flag'])
		&& isset($_REQUEST['value']))
{
	$newFlags = $mailbox->FlagMail((int)$_REQUEST['flag'],
		$_REQUEST['value']==1 ? true : false,
		(int)$_REQUEST['id']);
	die($newFlags & $_REQUEST['flag'] ? '1' : '0');
}

/**
 * rpc recent mail count
 */
else if($_REQUEST['action'] == 'getRecentMailCount')
{
	die($mailbox->GetRecentMailCount(isset($_REQUEST['folder'])
		? (int)$_REQUEST['folder']
		: FOLDER_ROOT));
}
?>