<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: email.read.php,v 1.40 2009/02/16 17:16:50 patrick Exp $
 *
 */

include('./serverlib/init.inc.php');
include('./serverlib/mailbox.class.php');
include('./serverlib/vcard.class.php');
RequestPrivileges(PRIVILEGES_USER);

/**
 * file handler for modules
 */
ModuleFunction('FileHandler',
	array(substr(__FILE__, strlen(dirname(__FILE__))+1),
	isset($_REQUEST['action']) ? $_REQUEST['action'] : ''));

/**
 * shared email code
 */
include('./serverlib/email.top.php');

/**
 * default action = start
 */
if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'read';
	
/**
 * read mail
 */
if($_REQUEST['action'] == 'read'
	&& isset($_REQUEST['id']))
{	
	$mail = $mailbox->GetMail((int)$_REQUEST['id']);
	
	if($mail !== false)
	{
		// unread?
		$confirmationTo = 0;
		if(($mail->flags & FLAG_UNREAD) != 0 && !isset($_REQUEST['preview']))
		{
			// confirmation?
			$dispositionNotificationTo = $mail->GetHeaderValue('disposition-notification-to');
			if($dispositionNotificationTo)
				$confirmationTo = ExtractMailAddress($dispositionNotificationTo);
			if($confirmationTo == '')
				$confirmationTo = 0;
			
			// mark as read
			$mailbox->FlagMail(FLAG_UNREAD, false, (int)$_REQUEST['id']);
		}
		
		// get text part
		$textParts = $mail->GetTextParts();
		if(isset($textParts['html'])
			&& ($userRow['soforthtml'] == 'yes' || isset($_REQUEST['htmlView'])
				|| $mail->IsTrusted()))
		{
			$textMode = 'html';
			$text = $textParts['html'];
		}
		else if(isset($textParts['text']))
		{
			$textMode = 'text';
			$text = formatEMailText($textParts['text']);
		}
		else if(isset($textParts['html']) && $userRow['soforthtml'] == 'no')
		{
			$textMode = 'text';
			$text = htmlToText($textParts['html']);
		}
		else 
		{
			$textMode = 'text';
			$text = '';
		}
		
		// get attachments
		$attachments = $mail->GetAttachments();
		
		// vcards?
		$vcards = array();
		foreach($attachments as $key=>$info)
		{
			if(in_array(strtolower($info['mimetype']),
						array('text/directory',
								'text/x-vcard',
								'application/vcard',
								'text/anytext',
								'text/plain',
								'application/x-versit',
								'text/x-versit',
								'text/x-vcalendar'))
				&& stristr($info['filename'], '.vcf') !== false)
			{
				$tempID = RequestTempFile($userRow['id'], time()+TIME_ONE_MINUTE);
				$cardFP = fopen(TempFileName($tempID), 'w+');
				if($mail->AttachmentToFP($key, $cardFP))
				{		
					$reader = _new('VCardReader', array($cardFP));
					$cardData = $reader->Parse();
					$vcards[$key] = $cardData;
				}
				fclose($cardFP);
				ReleaseTempFile($userRow['id'], $tempID);
			}
		}
		if(count($vcards) > 0)
			$tpl->assign('vcards', $vcards);
		
		// prev & next mail
		list($prevID, $nextID) = $mailbox->GetPrevNextMail($mail->_row['folder'], (int)$_REQUEST['id']);
		if($prevID != -1)
			$tpl->assign('prevID', $prevID);
		if($nextID != -1)
			$tpl->assign('nextID', $nextID);
			
		$tpl->assign('pageTitle', $mail->GetHeaderValue('subject'));
		$tpl->assign('smimeCertificateHash', $mail->smimeCertificateHash);
		$tpl->assign('smimeStatus', $mail->smimeStatus);
		$tpl->assign('folderID', $mail->_row['folder']);
		$tpl->assign('folderInfo', $folderList[$mail->_row['folder']]);
		$tpl->assign('flags', $mail->flags);
		$tpl->assign('infection', $mail->infection);
		$tpl->assign('trained', $mail->trained || $bm_prefs['use_bayes'] == 'no' || $userRow['spamfilter'] == 'no' || $mail->_row['folder'] == FOLDER_OUTBOX || $mail->IsTrusted());
		$tpl->assign('subject', $mail->GetHeaderValue('subject'));
		$tpl->assign('fromAddresses', ParseMailList($mail->GetHeaderValue('from')));
		$tpl->assign('toAddresses', ParseMailList($mail->GetHeaderValue('to')));
		$tpl->assign('ccAddresses', ParseMailList($mail->GetHeaderValue('cc')));
		$tpl->assign('replyToAddresses', ParseMailList($mail->GetHeaderValue('reply-to')));
		$tpl->assign('date', $mail->date);
		$tpl->assign('priority', (int)$mail->priority);
		$tpl->assign('text', $text);
		$tpl->assign('textMode', $textMode);
		$tpl->assign('mailID', (int)$_REQUEST['id']);
		$tpl->assign('attachments', $attachments);
		$tpl->assign('noExternal', $textMode == 'html' && !$mail->IsTrusted() && formatEMailHTMLText($textParts['html'], true) != formatEMailHTMLText($textParts['html'], false));
		$tpl->assign('htmlAvailable', isset($textParts['html']) && $textMode != 'html');
		$tpl->assign('confirmationTo', $confirmationTo);
		$tpl->assign('conversationView', $userRow['conversation_view'] == 'yes');
		
		if(isset($_REQUEST['preview']))
		{
			$tpl->assign('preview', true);
			$tpl->assign('pageContent', 'li/email.read.tpl');
			$tpl->display('li/email.preview.tpl');
		}
		else if(isset($_REQUEST['print']))
		{
			if($textMode == 'html')
				$tpl->assign('text', formatEMailHTMLText(isset($textParts['html']) ? $textParts['html'] : '', isset($_REQUEST['enableExternal']) || $mail->IsTrusted(), $attachments, (int)$_REQUEST['id']));
			$tpl->display('li/email.print.tpl');
		}
		else 
		{
			$tpl->assign('pageContent', 'li/email.read.tpl');
			$tpl->display('li/index.tpl');
		}
	}
}

/**
 * html mail
 */
else if($_REQUEST['action'] == 'inlineHTML'
		&& isset($_REQUEST['mode']) && in_array($_REQUEST['mode'], array('html', 'text')))
{
	$mail = $mailbox->GetMail((int)$_REQUEST['id']);
	
	if($mail !== false)
	{
		$textParts = $mail->GetTextParts();
		$attachments = $mail->GetAttachments();
		
		if($_REQUEST['mode'] == 'html')
			$text = '<base target="_blank" /><font face="arial" size="2">' . formatEMailHTMLText(isset($textParts['html']) ? $textParts['html'] : '', isset($_REQUEST['enableExternal']) || $mail->IsTrusted(), $attachments, (int)$_REQUEST['id']) . '</font>';
		else 
			$text = '<base target="_blank" /><font face="' . ($userRow['plaintext_courier']=='yes' ? 'courier' : 'arial') . '" size="2">' . formatEMailText(isset($textParts['text']) ? $textParts['text'] : (isset($textParts['html']) ? htmlToText($textParts['html']) : '')) . '</font>';

		echo($text);
		
		echo <<<EOD
	<script language="javascript">
	<!--
		var h = parseInt(document.body.scrollHeight);
		parent.document.getElementById('textArea').style.height = (h > 200 ? h : 200) + 'px';
	//-->
	</script>
EOD;
	}
}

/**
 * show thread
 */
else if($_REQUEST['action'] == 'showThread'
		&& isset($_REQUEST['id']))
{
	$mail = $mailbox->GetMail((int)$_REQUEST['id']);
	
	if($mail !== false)
	{	
		$thread = $mail->GetThread();
		$tpl->assign('thread', $thread);
		$tpl->assign('mailID', (int)$_REQUEST['id']);
		$tpl->display('li/email.read.thread.tpl');
	}
}

/**
 * move mail
 */
if($_REQUEST['action'] == 'move'
	&& isset($_REQUEST['id']))
{	
	$mail = $mailbox->GetMail((int)$_REQUEST['id']);
	
	if($mail !== false)
	{
		if(isset($_REQUEST['dest']))
		{
			$mailbox->MoveMail((int)$_REQUEST['id'], (int)$_REQUEST['dest']);
	
			echo '<script language="javascript">' . "\n";
			echo '<!--' . "\n";
			echo 'parent.document.location.reload();' . "\n";
			echo 'parent.hideOverlay();' . "\n";
			echo '//-->' . "\n";
			echo '</script>' . "\n";
		}
		else
		{
			$tpl->assign('mailID', (int)$_REQUEST['id']);
			$tpl->display('li/email.read.move.tpl');
		}
	}
}

/**
 * download e-mail
 */
else if($_REQUEST['action'] == 'download'
		&& isset($_REQUEST['id']))
{
	$mail = $mailbox->GetMail((int)$_REQUEST['id']);
	
	if($mail !== false)
	{
		// open message
		$messageFP = $mail->GetMessageFP(false);
		if($messageFP)
		{
			// get size
			$messageSize = $mail->GetMessageSize(false);
			
			// headers
			header(sprintf('Content-Disposition: attachment; filename="%d.eml"',
				(int)$_REQUEST['id']));
			header('Content-Type: message/rfc822');
			header(sprintf('Content-Length: %d',
				$messageSize));
		
			// send it
			while(!feof($messageFP))
				echo(fread($messageFP, 4096));
				
			// close & exit
			fclose($messageFP);
			exit();
		}
	}
}

/**
 * download an attachment
 */
else if($_REQUEST['action'] == 'downloadAttachment'
		&& isset($_REQUEST['attachment'])
		&& isset($_REQUEST['id']))
{	
	$mail = $mailbox->GetMail((int)$_REQUEST['id']);
	
	if($mail !== false)
	{
		$parts = $mail->GetPartList();
		if(isset($parts[$_REQUEST['attachment']]))
		{
			$part = $parts[$_REQUEST['attachment']];
			
			header('Content-Type: ' . $part['content-type']);
			header(sprintf('Content-Disposition: %s; filename="%s"',
						isset($_REQUEST['view']) ? 'inline' : 'attachment',
						addslashes($part['filename'])));
						
			$attData = &$part['body'];
			$attData->Init();
			while($block = $attData->DecodeBlock(PART_CHUNK_SIZE))
			{
				echo $block;
			}
			$attData->Finish();
		}
	}
}

/**
 * import a VCF attachment
 */
else if($_REQUEST['action'] == 'importVCF'
		&& isset($_REQUEST['attachment'])
		&& isset($_REQUEST['id']))
{	
	$mail = $mailbox->GetMail((int)$_REQUEST['id']);
	
	if($mail !== false)
	{
		$tempID = RequestTempFile($userRow['id'], time()+TIME_ONE_HOUR);
		$tempName = TempFileName($tempID);
		$cardFP = fopen($tempName, 'w+');
		
		if($mail->AttachmentToFP($_REQUEST['attachment'], $cardFP))
		{
			header('Location: organizer.addressbook.php?sid=' . session_id() . '&action=addContact&importFile=' . $tempID);
			fclose($cardFP);
		}
		else 
		{
			fclose($cardFP);
			ReleaseTempFile($userRow['id'], $tempID);
		}
	}
}

/**
 * send confirmation
 */
else if($_REQUEST['action'] == 'sendConfirmation'
		&& isset($_REQUEST['id']))
{
	$mail = $mailbox->GetMail((int)$_REQUEST['id']);
	
	if($mail !== false)
	{
		$to = ExtractMailAddress($mail->GetHeaderValue('disposition-notification-to'));
		
		if($to != '')
		{
			$subject = $lang_user['read'] . ': ' . $mail->GetHeaderValue('subject');
			$vars = array(
				'subject'	=> $mail->GetHeaderValue('subject'),
				'date'		=> date($userRow['datumsformat'])
			);
			if(SystemMail($thisUser->GetDefaultSender(), $to, $subject, 'receipt_text', $vars))
				die('1');
		}
	}
	
	die('0');
}

/**
 * set spam status
 */
else if($_REQUEST['action'] == 'setSpamStatus'
		&& isset($_REQUEST['id'])
		&& isset($_REQUEST['spam']))
{
	$mailbox->SetSpamStatus((int)$_REQUEST['id'], $_REQUEST['spam']=='true');
	die('1');
}

/**
 * show source
 */
else if($_REQUEST['action'] == 'showSource'
		&& isset($_REQUEST['id']))
{
	$mail = $mailbox->GetMail((int)$_REQUEST['id']);
	
	if($mail !== false)
	{
		// open message
		$messageFP = $mail->GetMessageFP(false);
		if($messageFP)
		{
			// get size
			$messageSize = $mail->GetMessageSize(false);
			$messageHeader = $messageBody = '';
			
			// read header + body
			$passedHeaders = false;
			while(!feof($messageFP))
			{
				$line = rtrim(fgets2($messageFP));
				
				if(!$passedHeaders)
				{
					if($line == '')
					{
						$passedHeaders = true;
						
						// skip body for messages > 64 KB
						if($messageSize > 64*1024)
						{
							$messageBody = $lang_user['bodyskipped'];
							break;
						}
					}
					else
					{
						$messageHeader .= $line . "\n";
					}
				}
				else 
				{
					$messageBody .= $line . "\n";
				}
			}
		
			// close
			fclose($messageFP);
			
			// format header
			$messageHeader = '<font color="blue">'
								. preg_replace('/^([^\t][^\:]*)\:/m', '<font color="green">$1:</font>', HTMLFormat($messageHeader))
							. '</font>';
			
			// format body
			$messageBody = HTMLFormat(wordwrap($messageBody, 72, "\n"));
			
			// tabs!
			$messageHeader = str_replace("\t", '&nbsp;&nbsp;&nbsp;&nbsp;', $messageHeader);
			$messageBody = str_replace("\t", '&nbsp;&nbsp;&nbsp;&nbsp;', $messageBody);
			
			// source
			$messageSource = nl2br($messageHeader) . '<br /><br />' . nl2br($messageBody);
			
			// display
			$tpl->assign('source', $messageSource);
			$tpl->display('li/email.read.source.tpl');
		}
	}
}
?>