<?php
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: clientapi.php,v 1.11 2008/03/29 13:43:11 patrick Exp $
 *
 */

define('INTERFACE_MODE', true);
include('../serverlib/init.inc.php');

$exportedClasses = array(
	'BMToolInterface'	=> array(
		'fileName'				=> '../serverlib/toolinterface.class.php',
		'constructorParams'		=> array(),
		'requiredPrivileges'	=> 0
	)
);

$response = array();

if(!isset($_REQUEST['class'])
	|| !isset($exportedClasses[$_REQUEST['class']]))
{
	$response['status'] = 'INVALID_CLASS';
}
else
{
	$classInfo = $exportedClasses[$_REQUEST['class']];
	
	// load class
	if(!class_exists($_REQUEST['class']))
		include($classInfo['fileName']);
	
	// check privileges
	if(!RequestPrivileges($classInfo['requiredPrivileges'] | PRIVILEGES_CLIENTAPI, true))
	{
		// return access error
		$response['status'] = 'ACCESS_DENIED';
	}
	else 
	{
		// instantiate
		$response['class'] = $_REQUEST['class'];
		if(isset($_REQUEST['method']))
			$response['method'] = $_REQUEST['method'];
		$instance = _new($_REQUEST['class'], $classInfo['constructorParams']);
		
		// function
		if(!isset($_REQUEST['method']) || !method_exists($instance, $_REQUEST['method']))
		{
			$response['status'] = 'INVALID_METHOD';
		}
		else if(isset($_REQUEST['method']) && method_exists($instance, $_REQUEST['method'])) 
		{
			$response['status'] = 'OK';
			$params = isset($_REQUEST['params']) && is_array($_REQUEST['params']) ? $_REQUEST['params'] : array();
			$response['result'] = call_user_func_array(array(&$instance, $_REQUEST['method']), $params);
		}
	}
}

NormalArray2XML($response, 'response');
?>