<?php
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: ipn.php,v 1.7 2008/07/01 10:52:15 patrick Exp $
 *
 */

define('INTERFACE_MODE', true);
include('../serverlib/init.inc.php');

PutLog(sprintf('IPN: <%s> Called',
		$_SERVER['REMOTE_ADDR']),
	PRIO_DEBUG,
	__FILE__,
	__LINE__);

//
// check input
//
if(!isset($_POST['item_name']) || !isset($_POST['item_number']) || !isset($_POST['payment_status'])
	|| !isset($_POST['mc_gross']) || !isset($_POST['mc_currency']) || !isset($_POST['txn_id'])
	|| !isset($_POST['receiver_email']) || !isset($_POST['payer_email']))
{
	PutLog(sprintf('IPN: <%s> Missing input variables',
			$_SERVER['REMOTE_ADDR']),
		PRIO_DEBUG,
		__FILE__,
		__LINE__);
	die('Error: One or more missing input variables.');
}

//
// read the post from PayPal system and add 'cmd'
//
$req = 'cmd=_notify-validate';
foreach($_POST as $key=>$value)
	$req .= sprintf('&%s=%s', $key, urlencode($value));
$header  = 'POST /cgi-bin/webscr HTTP/1.0' . "\r\n";
$header .= 'Content-Type: application/x-www-form-urlencoded' . "\r\n";
$header .= 'Content-Length: ' . strlen($req) . "\r\n\r\n";

//
// open connection
//
$fp = fsockopen('www.paypal.com', 80, $errNo, $errStr, SOCKET_TIMEOUT);

//
// import vars
//
$paypal_mail 		= $bm_prefs['sms_paypal_mail'];
$item_name 			= $_POST['item_name'];
$item_number 		= $_POST['item_number'];
$payment_status 	= $_POST['payment_status'];
$payment_amount 	= $_POST['mc_gross'];
$payment_currency 	= $_POST['mc_currency'];
$txn_id 			= $_POST['txn_id'];
$receiver_email 	= $_POST['receiver_email'];
$payer_email 		= $_POST['payer_email'];

//
// submit request
//
if(!$fp)
{
	// log
	PutLog(sprintf('PayPal payment (%d): Could not connect to www.paypal.com:80 (%d, %s)',
		$item_number,
		$errNo,
		$errStr),
		PRIO_ERROR,
		__FILE__,
		__LINE__);
}
else
{
	fputs($fp, $header . $req);
	PutLog(sprintf('IPN: <%s> Request posted',
			$_SERVER['REMOTE_ADDR']),
		PRIO_DEBUG,
		__FILE__,
		__LINE__);
	
	while(!feof($fp))
	{
		$res = fgets2($fp);
		if(trim($res) == 'VERIFIED')
		{	
			if(trim($payment_status) == 'Completed')
			{
				// check that this txn_id has not been previously processed
				$res = $db->Query('SELECT id FROM {pre}payments WHERE txn_id=?',
					$txn_id);
				if($res->RowCount() == 0)
				{
					// check that the receiver_email is the paypal mail address
					if(trim(strtolower($receiver_email)) == trim(strtolower($paypal_mail)))
					{
							// set txn_id
							$db->Query('UPDATE {pre}payments SET txn_id=? WHERE id=?',
								$txn_id,
								$item_number);
						
							// process payment
							$res2 = $db->Query('SELECT * FROM {pre}payments WHERE id=?',
								$item_number);
							while($row = $res2->FetchArray(MYSQL_ASSOC))
							{
								if($row['typ'] == 'credits')
								{
									// check amount
									if((float)$payment_amount == (float)$row['amount']
										&& $row['items'] > 0)
									{
										// ok => charge
										$user = _new('BMUser', array($row['user']));
										$user->Debit($row['items']);
										unset($user);
										
										// log
										PutLog(sprintf('PayPal payment (%d): Accepted (credits: %d, user: %d, txn_id: %s)',
											$item_number,
											$row['items'],
											$row['user'],
											$txn_id));
									}
									else 
									{
										// wrong => log
										PutLog(sprintf('PayPal payment (%d): Wrong payment amount (%.02f != %.02f)',
											$item_number,
											(float)$payment_amount,
											(float)$row['amount']),
											PRIO_WARNING,
											__FILE__,
											__LINE__);
									}
								}
								
								// module handler
								ModuleFunction('HandlePayment', array($row));
								PutLog(sprintf('IPN: <%s> Plugin handlers called',
										$_SERVER['REMOTE_ADDR']),
									PRIO_DEBUG,
									__FILE__,
									__LINE__);
							}
							$res2->Free();
					}
					else
					{
						// log
						PutLog(sprintf('PayPal payment (%d): Payment receiver is not <%s>',
							$item_number,
							$receiver_email),
							PRIO_WARNING,
							__FILE__,
							__LINE__);
					}
				}
				else
				{
					// log
					PutLog(sprintf('PayPal payment (%d): txn_id has already been processed (%s)',
						$item_number,
						$txn_id),
						PRIO_WARNING,
						__FILE__,
						__LINE__);
					$res->Free();
				}
			}
			else 
			{
				PutLog(sprintf('IPN: <%s> Payment not completed',
						$_SERVER['REMOTE_ADDR']),
					PRIO_DEBUG,
					__FILE__,
					__LINE__);
			}
		}
		else if(trim($res) == 'INVALID')
		{
			// log
			PutLog(sprintf('PayPal payment (%d): Got INVALID while trying to validate payment (%s)',
				$item_number,
				trim($txn_id) != '' ? $txn_id : 'n/a'),
				PRIO_WARNING,
				__FILE__,
				__LINE__);
		}
	}
	fclose($fp);
	
	PutLog(sprintf('IPN: <%s> Request answer processed',
			$_SERVER['REMOTE_ADDR']),
		PRIO_DEBUG,
		__FILE__,
		__LINE__);
}
?>