<?php
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: su_callback.php,v 1.1 2008/11/20 13:57:31 patrick Exp $
 *
 */

define('INTERFACE_MODE', true);
include('../serverlib/init.inc.php');

PutLog('SU-Callback: Called',
	PRIO_DEBUG,
	__FILE__,
	__LINE__);

//
// check input vars
//
if(!isset($_POST['hash']))
{
	PutLog('SU-Callback: Missing input variables',
		PRIO_DEBUG,
		__FILE__,
		__LINE__);
	die('Error: One or more missing input variables.');
}
		
//
// build origin check hash
//
$vars = array(
	'transaction', 'user_id', 'project_id', 'sender_holder',
	'sender_account_number', 'sender_bank_code', 'sender_bank_name',
	'sender_bank_bic', 'sender_iban', 'sender_country_id',
	'recipient_holder', 'recipient_account_number', 'recipient_bank_code',
	'recipient_bank_name', 'recipient_bank_bic', 'recipient_iban',
	'recipient_country_id', 'international_transaction', 'amount',
	'currency_id', 'reason_1', 'reason_2', 'security_criteria',
	'user_variable_0', 'user_variable_1', 'user_variable_2', 'user_variable_3',
	'user_variable_4', 'user_variable_5', 'created'
);
$values = array();
foreach($vars as $var)
{
	if(!isset($_POST[$var]))
		PutLog(sprintf('SU-Callback: Undefined SU variable: %s', $var),
			PRIO_DEBUG,
			__FILE__,
			__LINE__);
	$values[] = $_POST[$var];
}
$values[] = $bm_prefs['sms_su_prjpass'];
$hash = md5(implode('|', $values));

//
// log
//
PutLog(sprintf('SU-Callback: SU hashes: given=%s, calculated=%s',
	$_POST['hash'],
	$hash),
	PRIO_DEBUG,
	__FILE__,
	__LINE__);
		
//
// check hash
//
if($_POST['hash'] != $hash)
{
	PutLog('SU-Callback: sofortueberweisung.de hash comparison failed (wrong project password?)',
		PRIO_WARNING,
		__FILE__,
		__LINE__);
	die('Error: Invalid hash');
}
		
//
// check account + project numbers
//
if($_POST['user_id'] != $bm_prefs['sms_su_kdnr']
	|| $_POST['project_id'] != $bm_prefs['sms_su_prjnr'])
{
	PutLog('SU-Callback: User ID / project ID transmitted by sofortueberweisung.de does not match our records',
		PRIO_WARNING,
		__FILE__,
		__LINE__);
	die('Error: Invalid user id / project id');
}
		
//
// process payment
//
$res2 = $db->Query('SELECT * FROM {pre}payments WHERE id=?',
	$_POST['user_variable_0']);
while($row = $res2->FetchArray(MYSQL_ASSOC))
{
	if($row['typ'] == 'credits')
	{
		// check amount
		if((float)$_POST['amount'] == (float)$row['amount']
			&& $row['items'] > 0)
		{
			// ok => charge
			$user = _new('BMUser', array($row['user']));
			$user->Debit($row['items']);
			unset($user);
			
			// log
			PutLog(sprintf('SU payment (%d): Accepted (credits: %d, user: %d)',
				$_POST['user_variable_0'],
				$row['items'],
				$row['user']));
		}
		else 
		{
			// wrong => log
			PutLog(sprintf('SU payment (%d): Wrong payment amount (%.02f != %.02f)',
				$_POST['user_variable_0'],
				(float)$_POST['amount'],
				(float)$row['amount']),
				PRIO_WARNING,
				__FILE__,
				__LINE__);
			die('Error: Wrong payment amount');
		}
	}
	
	// module handler
	ModuleFunction('HandlePayment', array($row));
	PutLog('SU-Callback: Plugin handlers called',
		PRIO_DEBUG,
		__FILE__,
		__LINE__);
	die('OK');
}
$res2->Free();

//
// order not found
//
PutLog(sprintf('SU payment (%d): Payment not found',
	$_POST['user_variable_0']),
	PRIO_WARNING,
	__FILE__,
	__LINE__);
die('Error: Payment not found');
?>