<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: organizer.addressbook.php,v 1.55 2008/12/09 19:15:34 patrick Exp $
 *
 */

include('./serverlib/init.inc.php');
include('./serverlib/todo.class.php');
include('./serverlib/vcard.class.php');
include('./serverlib/addressbook.class.php');
include('./serverlib/csv.class.php');
RequestPrivileges(PRIVILEGES_USER);

/**
 * file handler for modules
 */
ModuleFunction('FileHandler',
	array(substr(__FILE__, strlen(dirname(__FILE__))+1),
	isset($_REQUEST['action']) ? $_REQUEST['action'] : ''));

/**
 * default action = start
 */
if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'start';
$tpl->assign('activeTab', 'organizer');
$tpl->assign('pageTitle', $lang_user['addressbook']);

/**
 * addressbook interface
 */
$book = _new('BMAddressbook', array($userRow['id']));

/**
 * page menu
 */
$todo = _new('BMTodo', array($userRow['id']));
$tpl->assign('tasks', $todo->GetTodoList('faellig', 'asc', 5));
$tpl->assign('pageMenuFile', 'li/organizer.sidebar.tpl');

/**
 * addressbook fields
 */
$bookFields = array(
	'vorname'			=> $lang_user['firstname'],
	'nachname'			=> $lang_user['surname'],
	'anrede'			=> $lang_user['salutation'],
	'position'			=> $lang_user['position'],
	'firma'				=> $lang_user['company'],
	'strassenr'			=> $lang_user['streetnr'],
	'plz'				=> $lang_user['zip'],
	'ort'				=> $lang_user['city'],
	'land'				=> $lang_user['country'],
	'email'				=> $lang_user['email'],
	'tel'				=> $lang_user['phone'],
	'handy'				=> $lang_user['mobile'],
	'fax'				=> $lang_user['fax'],
	'work_strassenr'	=> $lang_user['work'] . ' ' . $lang_user['streetnr'],
	'work_plz'			=> $lang_user['work'] . ' ' . $lang_user['zip'],
	'work_ort'			=> $lang_user['work'] . ' ' . $lang_user['city'],
	'work_land'			=> $lang_user['work'] . ' ' . $lang_user['country'],
	'work_email'		=> $lang_user['work'] . ' ' . $lang_user['email'],
	'work_tel'			=> $lang_user['work'] . ' ' . $lang_user['phone'],
	'work_handy'		=> $lang_user['work'] . ' ' . $lang_user['mobile'],
	'work_fax'			=> $lang_user['work'] . ' ' . $lang_user['fax'],
	'web'				=> $lang_user['web'],
	'kommentar'			=> $lang_user['comment'],
	'geburtsdatum'		=> $lang_user['birthday']
);

/**
 * csv assoc
 */
$bookFieldsAssoc = array(
	'firstname'							=> 'vorname',
	'prename'							=> 'vorname',
	'vorname'							=> 'vorname',
	
	'lastname'							=> 'nachname',
	'nachname'							=> 'nachname',
	'surname'							=> 'nachname',
	'name'								=> 'nachname',
	
	'salutation'						=> 'anrede',
	'anrede'							=> 'anrede',
	'titel'								=> 'anrede',
	
	'position'							=> 'position',
	
	'company'							=> 'firma',
	'business'							=> 'firma',
	'firma'								=> 'firma',
	'unternehmen'						=> 'firma',
	
	'street'							=> 'strassenr',
	'streetno'							=> 'strassenr',
	'streetnr'							=> 'strassenr',
	'strasse'							=> 'strassenr',
	'strassenr'							=> 'strassenr',
	'strae privat'						=> 'strassenr',
	
	'zip'								=> 'plz',
	'postcode'							=> 'plz',
	'plz'								=> 'plz',
	'postleitzahl privat'				=> 'plz',
	
	'city'								=> 'ort',
	'town'								=> 'ort',
	'ort'								=> 'ort',
	'ort privat'						=> 'ort',
	
	'country'							=> 'land',
	'nation'							=> 'land',
	'nationality'						=> 'land',
	'land'								=> 'land',
	'land/region privat'				=> 'land',
	
	'email'								=> 'email',
	'mail'								=> 'email',
	'e-mail'							=> 'email',
	'e-mail-address'					=> 'email',
	'e-mail-adresse'					=> 'email',
	'mail-address'						=> 'email',
	'mailaddress'						=> 'email',
	
	'phone'								=> 'tel',
	'telephone'							=> 'tel',
	'telefon'							=> 'tel',
	'telefon privat'					=> 'tel',
	
	'mobile'							=> 'handy',
	'cellphone'							=> 'handy',
	'cell'								=> 'handy',
	'mobilephone'						=> 'handy',
	'mobil'								=> 'handy',
	'handy'								=> 'handy',
	'mobiltelefon'						=> 'handy',
	
	'fax'								=> 'fax',
	'facsimile'							=> 'fax',
	'fax privat'						=> 'fax',
	
	'workstreet'						=> 'work_strassenr',
	'strae geschftlich'				=> 'work_strassenr',
	'workzip'							=> 'work_plz',
	'postleitzahl geschftlich'			=> 'work_plz',
	'workcity'							=> 'work_ort',
	'ort geschftlich'					=> 'work_ort',
	'workcountry'						=> 'work_land',
	'land/region geschftlich'			=> 'work_land',
	'workemail'							=> 'work_email',
	'workphone'							=> 'work_tel',
	'telefon geschftlich'				=> 'work_tel',
	'workmobile'						=> 'work_handy',
	'workfax'							=> 'work_fax',
	'fax geschftlich'					=> 'work_fax',
	
	'homepage'							=> 'web',
	'web'								=> 'web',
	'www'								=> 'web',
	'url'								=> 'web',
	
	'comment'							=> 'kommentar',
	'kommentar'							=> 'kommentar',
	'note'								=> 'kommentar',
	'notes'								=> 'kommentar',
	
	'birthday'							=> 'geburtsdatum',
	'birthdate'							=> 'geburtsdatum',
	'geburtstag'						=> 'geburtsdatum',
	'geburtsdatum'						=> 'geburtsdatum'
);

/**
 * start page
 */
if($_REQUEST['action'] == 'start')
{
	$sortColumns = array('vorname', 'nachname', 'firma', 'email', 'gruppe');
	
	// group id
	$currentGroup = -1;
	if(isset($_REQUEST['group']) && (substr($_REQUEST['group'], 0, 3) == 'wg_' || (int)$_REQUEST['group'] > 0))
		$currentGroup = $_REQUEST['group'];
	$tpl->assign('currentGroup', $currentGroup);
	
	// get sort info
	$sortColumn = (isset($_REQUEST['sort']) && in_array($_REQUEST['sort'], $sortColumns))
					? $_REQUEST['sort']
					: 'nachname';
	$sortOrder = (isset($_REQUEST['order']) && in_array($_REQUEST['order'], array('asc', 'desc')))
					? $_REQUEST['order']
					: 'asc';
					
	// get addresses & groups
	$addressList = $book->GetAddressBook(isset($_REQUEST['letter']) ? $_REQUEST['letter'] : '*',
						$currentGroup,
						$sortColumn,
						$sortOrder);
	$groupList = $book->GetGroupList();
	
	// get page info
	$entriesPerPage = (int)$bm_prefs['ordner_proseite'];
	$pageNo = (isset($_REQUEST['page']))
					? (int)$_REQUEST['page']
					: 1;
	$addressCount = count($addressList);
	$pageCount = max(1, ceil($addressCount / max(1, $entriesPerPage)));
	$pageNo = min($pageCount, max(1, $pageNo));
					
	// extract page
	$addressList = array_slice_preserve_keys($addressList, ($pageNo-1) * $entriesPerPage, $entriesPerPage);
	
	// page output
	$tpl->assign('alpha', array(
		'A'		=> 'A',		'B'		=> 'B',		'C'		=> 'C',		'D'		=> 'D',		'E'		=> 'E',
		'F'		=> 'F',		'G'		=> 'G',		'H'		=> 'H',		'I'		=> 'I',		'J'		=> 'J',
		'K'		=> 'K',		'L'		=> 'L',		'M'		=> 'M',		'N'		=> 'N',		'O'		=> 'O',
		'P'		=> 'P',		'Q'		=> 'Q',		'R'		=> 'R',		'S'		=> 'S',		'T'		=> 'T',
		'U'		=> 'U',		'V'		=> 'V',		'W'		=> 'W',		'X'		=> 'X',		'Y'		=> 'Y',
		'Z'		=> 'Z',		'9'		=> '0-9'));
	$tpl->assign('pageNo', $pageNo);
	$tpl->assign('pageCount', $pageCount);
	$tpl->assign('addressList', $addressList);
	$tpl->assign('groupList', $groupList);
	$tpl->assign('sortColumn', $sortColumn);
	$tpl->assign('sortOrder', $sortOrder);
	$tpl->assign('sortOrderInv', $sortOrder == 'asc' ? 'desc' : 'asc');	
	$tpl->assign('pageContent', 'li/organizer.addressbook.tpl');
	$tpl->assign('displayLetter', urlencode(isset($_REQUEST['letter']) ? $_REQUEST['letter'] : '*'));
	$tpl->display('li/index.tpl');
}

/**
 * add contact
 */
else if($_REQUEST['action'] == 'addContact')
{
	if(isset($_REQUEST['importFile'])
		&& ValidTempFile($userRow['id'], (int)$_REQUEST['importFile']))
	{
		$tempID = (int)$_REQUEST['importFile'];
		$tempName = TempFileName($tempID);
		
		$jsCode  = '<script language="javascript">' . "\n";
		$jsCode .= '<!--' . "\n";
		
		// parse card
		$vcardReader = _new('VCardReader', array($vcardFP = fopen($tempName, 'r')));
		$cardData = $vcardReader->Parse();		
		fclose($vcardFP);
		
		// output fill-in code
		foreach($cardData as $key=>$val)
		{
			if($key != 'geburtsdatum' && $key != 'anrede')
			{
				$jsCode .= sprintf('document.getElementById(\'%s\').value = \'%s\';' . "\n",
					$key,
					addslashes(str_replace(array("\r", "\n"), '', $val)));
			}
		}
		
		$jsCode .= '//-->' . "\n";
		$jsCode .= '</script>' . "\n";
		
		ReleaseTempFile($userRow['id'], $tempID);
		$tpl->assign('jsCode', $jsCode);
	}
	
	$tpl->assign('pageTitle', $lang_user['addcontact']);
	$tpl->assign('pageContent', 'li/organizer.addressbook.edit.tpl');
	$tpl->assign('groups', $book->GetGroupList());	
	$tpl->display('li/index.tpl');
}

/**
 * create contact
 */
else if($_REQUEST['action'] == 'createContact'
		&& isset($_REQUEST['vorname']) && isset($_REQUEST['nachname']))
{
	// process groups
	$groups = array();
	foreach($_POST as $key=>$val)
		if(substr($key, 0, 6) == 'group_')
			$groups[] = (int)substr($key, 6);
	
	// picture
	$pictureFile = false;
	$pictureMime = false;
	if(isset($_REQUEST['pictureFile']) && isset($_REQUEST['pictureMime']) && is_numeric($_REQUEST['pictureFile']) 
		&& $_REQUEST['pictureFile'] > 0	&& ValidTempFile($userRow['id'], (int)$_REQUEST['pictureFile']))
	{
		$pictureFile = TempFileName((int)$_REQUEST['pictureFile']);
		$pictureMime = $_REQUEST['pictureMime'];
	}
			
	// add contact
	$contactID = $book->AddContact($_REQUEST['firma'],
		$_REQUEST['vorname'],
		$_REQUEST['nachname'],
		$_REQUEST['strassenr'],
		$_REQUEST['plz'],
		$_REQUEST['ort'],
		$_REQUEST['land'],
		$_REQUEST['tel'],
		$_REQUEST['fax'],
		$_REQUEST['handy'],
		$_REQUEST['email'],
		$_REQUEST['work_strassenr'],
		$_REQUEST['work_plz'],
		$_REQUEST['work_ort'],
		$_REQUEST['work_land'],
		$_REQUEST['work_tel'],
		$_REQUEST['work_fax'],
		$_REQUEST['work_handy'],
		$_REQUEST['work_email'],
		$_REQUEST['anrede'],
		$_REQUEST['position'],
		$_REQUEST['web'],
		$_REQUEST['kommentar'],
		SmartyDateTime('geburtsdatum_'),
		$_REQUEST['default'] == 'work' ? ADDRESS_WORK : ADDRESS_PRIVATE,
		$groups,
		$pictureFile,
		$pictureMime);
		
	// release temp file
	if($pictureFile !== false)
		ReleaseTempFile($userRow['id'], $_REQUEST['pictureFile']);
	
	// submit action?
	if(isset($_REQUEST['submitAction']) && $_REQUEST['submitAction'] == 'selfComplete')
	{
		// self complete page
		header('Location: organizer.addressbook.php?action=selfComplete&id=' . (int)$contactID . '&sid=' . session_id());
	}
	else
	{
		// back to list
		header('Location: organizer.addressbook.php?sid=' . session_id());
	}
}

/**
 * edit contact
 */
else if($_REQUEST['action'] == 'editContact'
		&& isset($_REQUEST['id']))
{
	$contact = $book->GetContact((int)$_REQUEST['id']);
	if($contact !== false)
	{
		$groupList = $book->GetGroupList((int)$_REQUEST['id']);
		$tpl->assign('pageTitle', $lang_user['editcontact']);
		$tpl->assign('pageContent', 'li/organizer.addressbook.edit.tpl');
		$tpl->assign('groups', $groupList);
		$tpl->assign('contact', $contact);
		$tpl->display('li/index.tpl');
	}
}

/**
 * save contact
 */
else if($_REQUEST['action'] == 'saveContact'
		&& isset($_REQUEST['id']) && isset($_REQUEST['vorname']) && isset($_REQUEST['nachname']))
{
	// process groups
	$groups = array();
	foreach($_POST as $key=>$val)
		if(substr($key, 0, 6) == 'group_')
			$groups[] = (int)substr($key, 6);
			
	// change contact
	$book->Change((int)$_REQUEST['id'],
		$_REQUEST['firma'],
		$_REQUEST['vorname'],
		$_REQUEST['nachname'],
		$_REQUEST['strassenr'],
		$_REQUEST['plz'],
		$_REQUEST['ort'],
		$_REQUEST['land'],
		$_REQUEST['tel'],
		$_REQUEST['fax'],
		$_REQUEST['handy'],
		$_REQUEST['email'],
		$_REQUEST['work_strassenr'],
		$_REQUEST['work_plz'],
		$_REQUEST['work_ort'],
		$_REQUEST['work_land'],
		$_REQUEST['work_tel'],
		$_REQUEST['work_fax'],
		$_REQUEST['work_handy'],
		$_REQUEST['work_email'],
		$_REQUEST['anrede'],
		$_REQUEST['position'],
		$_REQUEST['web'],
		$_REQUEST['kommentar'],
		SmartyDateTime('geburtsdatum_'),
		$_REQUEST['default'] == 'work' ? ADDRESS_WORK : ADDRESS_PRIVATE,
		$groups);
	
	// submit action?
	if(isset($_REQUEST['submitAction']) && $_REQUEST['submitAction'] == 'selfComplete')
	{
		// self complete page
		header('Location: organizer.addressbook.php?action=selfComplete&id=' . (int)$_REQUEST['id'] . '&sid=' . session_id());
	}
	
	// send mail?
	else if(isset($_REQUEST['submitAction']) && $_REQUEST['submitAction'] == 'sendMail')
	{
		// compose
		$email = urlencode($_REQUEST['default'] == 'work'
			? $_REQUEST['work_email']
			: $_REQUEST['email']);
		header('Location: email.compose.php?to=' . $email . '&sid=' . session_id());
	}
	
	// vcf?
	else if(isset($_REQUEST['submitAction']) && $_REQUEST['submitAction'] == 'exportVCF')
	{
		// send VCF
		$vcfData = $book->ExportContact((int)$_REQUEST['id']);
		
		// headers
		header('Pragma: public');
		header(sprintf('Content-Disposition: attachment; filename="%s %s.vcf"',
			$_REQUEST['vorname'],
			$_REQUEST['nachname']));
		header('Content-Type: text/x-vcard; charset=' . $currentCharset);
		header(sprintf('Content-Length: %d',
			strlen($vcfData)));
		
		// send it
		echo $vcfData;
		exit();
	}
	
	// create conversation folder
	else if(isset($_REQUEST['submitAction']) && $_REQUEST['submitAction'] == 'intelliFolder')
	{
		if(!class_exists('BMMailbox'))
			include('./serverlib/mailbox.class.php');
		
		$mailbox = _new('BMMailbox', array($userRow['id'], $userRow['email'], $thisUser));
		
		$folderTitle = $_REQUEST['vorname'] . ' ' . $_REQUEST['nachname'];
		$folderID = $mailbox->AddFolder($folderTitle,
			-1, true, -1, true, true);
		$mailbox->UpdateFolder($folderID, $folderTitle,
			-1, true, -1, BMLINK_OR);
		
		if(($value = ExtractMailAddress($_REQUEST['email'])) != '')
		{
			$conditionID = $mailbox->AddCondition($folderID);
			$mailbox->UpdateCondition($conditionID, $folderID, MAILFIELD_TO, BMOP_CONTAINS, $value);
			$conditionID = $mailbox->AddCondition($folderID);
			$mailbox->UpdateCondition($conditionID, $folderID, MAILFIELD_FROM, BMOP_CONTAINS, $value);
		}
		if(($value = ExtractMailAddress($_REQUEST['work_email'])) != '')
		{
			$conditionID = $mailbox->AddCondition($folderID);
			$mailbox->UpdateCondition($conditionID, $folderID, MAILFIELD_TO, BMOP_CONTAINS, $value);
			$conditionID = $mailbox->AddCondition($folderID);
			$mailbox->UpdateCondition($conditionID, $folderID, MAILFIELD_FROM, BMOP_CONTAINS, $value);
		}
		
		header('Location: email.folders.php?action=editFolder&id=' . $folderID . '&sid=' . session_id());
	}
	
	// default
	else
	{
		// back to list
		header('Location: organizer.addressbook.php?sid=' . session_id());
	}
}

/**
 * send self complete link
 */
else if($_REQUEST['action'] == 'sendSelfComplete'
		&& isset($_REQUEST['id'])
		&& isset($_REQUEST['destMail']))
{
	$tpl->assign('pageTitle', $lang_user['complete']);
	
	$result = $book->SendSelfCompleteInvitation((int)$_REQUEST['id'], $_REQUEST['destMail'] == 'private'
				? ADDRESS_PRIVATE
				: ADDRESS_WORK);
	if(!$result)
	{
		$tpl->assign('msg', $lang_user['complete_error']);
		$tpl->assign('pageContent', 'li/error.tpl');
	}
	else 
	{
		$tpl->assign('title', $lang_user['complete']);
		$tpl->assign('msg', $lang_user['complete_ok']);
		$tpl->assign('pageContent', 'li/msg.tpl');
	}
	
	$tpl->assign('backLink', 'organizer.addressbook.php?action=editContact&id=' . (int)$_REQUEST['id'] . '&sid=' . session_id());
	$tpl->display('li/index.tpl');
}

/**
 * self complete
 */
else if($_REQUEST['action'] == 'selfComplete'
		&& isset($_REQUEST['id']))
{
	$tpl->assign('pageTitle', $lang_user['complete']);
	
	$contact = $book->GetContact((int)$_REQUEST['id']);
	if($contact !== false)
	{
		$workMail = trim($contact['work_email']);
		$privateMail = trim($contact['email']);
		
		if(strpos($workMail, '@') === false && strpos($privateMail, '@') === false)
		{
			$tpl->assign('msg', $lang_user['complete_noemail']);
			$tpl->assign('backLink', 'organizer.addressbook.php?action=editContact&id=' . (int)$_REQUEST['id'] . '&sid=' . session_id());
			$tpl->assign('pageContent', 'li/error.tpl');
		}
		else if(trim($contact['invitationCode']) != ''
			&& !isset($_REQUEST['anyhow']))
		{
			$tpl->assign('msg', $lang_user['complete_invited']);
			$tpl->assign('backLink', 'organizer.addressbook.php?action=editContact&id=' . (int)$_REQUEST['id'] . '&sid=' . session_id());
			$tpl->assign('otherButton', array(
				'caption' 	=> $lang_user['send_anyhow'],
				'href'		=> 'organizer.addressbook.php?action=selfComplete&id=' . (int)$_REQUEST['id'] . '&sid=' . session_id() . '&anyhow=true'
			));
			$tpl->assign('pageContent', 'li/error.tpl');	
		}
		else 
		{
			$tpl->assign('workMail', strpos($workMail, '@') !== false ? $workMail : false);
			$tpl->assign('privateMail', strpos($privateMail, '@') !== false ? $privateMail : false);
			$tpl->assign('id', (int)$_REQUEST['id']);
			$tpl->assign('pageContent', 'li/organizer.addressbook.selfcomplete.tpl');
		}
		
		$tpl->display('li/index.tpl');
	}
}

/**
 * picture
 */
else if($_REQUEST['action'] == 'addressbookPicture'
		&& isset($_REQUEST['id']))
{
	if($_REQUEST['id'] == -1
		&& isset($_REQUEST['tempID'])
		&& isset($_REQUEST['contentType']))
	{
		if(ValidTempFile($userRow['id'], $_REQUEST['tempID']))
		{
			$tempName = TempFileName($_REQUEST['tempID']);
			header('Content-Type: ' . $_REQUEST['contentType']);
			header('Content-Length: ' . filesize($tempName));
			readfile($tempName);
		}
	}
	else 
	{
		$contact = $book->GetContact((int)$_REQUEST['id']);
		if($contact !== false && $contact['picture'] != '')
		{
			$picture = @unserialize($contact['picture']);
			if(is_array($picture))
			{
				header('Content-Type: ' . $picture['mimeType']);
				header('Content-Length: ' . strlen($picture['data']));
				echo $picture['data'];
			}
		}
	}
}

/**
 * vcf import dialog
 */
else if($_REQUEST['action'] == 'vcfImportDialog')
{
	$tpl->assign('title', $lang_user['importvcf']);
	$tpl->assign('text', $lang_user['importvcftext']);
	$tpl->assign('formAction', 'organizer.addressbook.php?action=vcfImportDialogSubmit&sid=' . session_id());
	$tpl->assign('fieldName', 'vcfFile');
	$tpl->display('li/dialog.openfile.tpl');
}

/**
 * vcf import dialog submit
 */
else if($_REQUEST['action'] == 'vcfImportDialogSubmit')
{
	$tempID = RequestTempFile($userRow['id'], time()+TIME_ONE_HOUR);
	$tempName = TempFileName($tempID);
	$vcfFile = getUploadedFile('vcfFile', $tempName);
	
	echo '<script language="javascript">' . "\n";
	echo '<!--' . "\n";
	
	// parse card, if any
	if($vcfFile)
	{
		// parse card
		$vcardReader = _new('VCardReader', array($vcardFP = fopen($tempName, 'r')));
		$cardData = $vcardReader->Parse();		
		fclose($vcardFP);
		
		// output fill-in code
		foreach($cardData as $key=>$val)
		{
			if($key != 'geburtsdatum' && $key != 'anrede')
			{
				printf('parent.document.getElementById(\'%s\').value = \'%s\';' . "\n",
					$key,
					addslashes(str_replace(array("\r", "\n"), '', $val)));
			}
		}
	}
	
	echo 'parent.hideOverlay();' . "\n";
	echo '//-->' . "\n";
	echo '</script>' . "\n";
	
	ReleaseTempFile($userRow['id'], $tempID);
}

/**
 * delete a contact
 */
else if($_REQUEST['action'] == 'deleteContact'
		&& isset($_REQUEST['id']))
{
	$book->Delete((int)$_REQUEST['id']);
	header('Location: organizer.addressbook.php?sid=' . session_id());	
}

/**
 * contact action
 */
else if($_REQUEST['action'] == 'action')
{
	if($_REQUEST['do'] == 'delete')
	{
		foreach($_POST as $key=>$val)
			if(substr($key, 0, 5) == 'addr_')
			{
				$id = substr($key, 5);
				$book->Delete((int)$id);
			}
	}
	else if($_REQUEST['do'] == 'sendmail')
	{
		$to = array();
		
		foreach($_POST as $key=>$val)
			if(substr($key, 0, 5) == 'addr_')
			{
				$id = substr($key, 5);
				$contact = $book->GetContact($id);
				$email = $contact['default_address'] == ADDRESS_WORK
					? $contact['work_email']
					: $contact['email'];
					
				if(trim($email) != '')
					array_push($to, sprintf('"%s, %s" <%s>',
						$contact['nachname'],
						$contact['vorname'],
						$email));
			}
		
		$toList = urlencode(implode(', ', $to));
		header('Location: email.compose.php?sid=' . session_id() . '&to=' . $toList);
		exit();
	}
	else if($_REQUEST['do'] == 'export')
	{
		// collect IDs
		$contactIDs = array();
		foreach($_POST as $key=>$val)
			if(substr($key, 0, 5) == 'addr_')
			{
				$id = substr($key, 5);
				$contactIDs[] = (int)$id;
			}
		
		// export
		header('Pragma: public');
		header('Content-Type: text/csv');
		header('Content-Disposition: attachment; filename="export.csv"');
		$book->ExportContacts($contactIDs);
		exit();
	}
	else if(substr($_REQUEST['do'], 0, 11) == 'addtogroup_')
	{
		$groupID = (int)substr($_REQUEST['do'], 11);
		
		// add to groups
		$contactIDs = array();
		foreach($_POST as $key=>$val)
			if(substr($key, 0, 5) == 'addr_')
			{
				$id = (int)substr($key, 5);
				$book->ContactGroup($id, $groupID);
			}
	}
	header('Location: organizer.addressbook.php?sid=' . session_id());
}

/**
 * group action
 */
else if($_REQUEST['action'] == 'groupAction')
{
	// add group
	if(isset($_REQUEST['add']))
	{
		if(!$book->GroupExists($_REQUEST['title']))
		{
			$book->GroupAdd($_REQUEST['title']);
			header('Location: organizer.addressbook.php?sid=' . session_id()); 
		}
		else 
		{
			// already exists
			$tpl->assign('msg', $lang_user['groupexists']);
			$tpl->assign('pageContent', 'li/error.tpl');
			$tpl->display('li/index.tpl');
		}
	}
	
	// delete
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'delete')
	{
		foreach($_POST as $key=>$val)
		{
			if(substr($key, 0, 6) == 'group_')
			{
				$id = substr($key, 6);
				$book->DeleteGroup((int)$id);
			}
		}
		header('Location: organizer.addressbook.php?sid=' . session_id());
	}
	
	// export as CSV
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'export')
	{
		// collect IDs
		$groupIDs = array();
		foreach($_POST as $key=>$val)
			if(substr($key, 0, 6) == 'group_')
			{
				$id = substr($key, 6);
				$groupIDs[] = (int)$id;
			}
		
		// export
		header('Pragma: public');
		header('Content-Type: text/csv');
		header('Content-Disposition: attachment; filename="export.csv"');
		$book->ExportGroupContacts($groupIDs);
		exit();
	}
	
	// mail
	else if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'sendmail')
	{
		// collect IDs
		$groupIDs = array();
		foreach($_POST as $key=>$val)
			if(substr($key, 0, 6) == 'group_')
			{
				$id = substr($key, 6);
				$groupIDs[] = (int)$id;
			}
		
		// collect addresses
		$addresses = $book->GetGroupContactMails($groupIDs);
		$to = array();
		foreach($addresses as $contact)
		{
			$email = $contact['default_address'] == ADDRESS_WORK
				? $contact['work_email']
				: $contact['email'];
				
			if(trim($email) != '')
				array_push($to, sprintf('"%s, %s" <%s>',
					$contact['nachname'],
					$contact['vorname'],
					$email));
		}
		
		// redirect
		$toList = urlencode(implode(', ', $to));
		header('Location: email.compose.php?sid=' . session_id() . '&to=' . $toList);
		exit();
	}
}

/**
 * delete single group
 */
else if($_REQUEST['action'] == 'deleteGroup'
		&& isset($_REQUEST['id']))
{
	$book->DeleteGroup((int)$_REQUEST['id']);
	header('Location: organizer.addressbook.php?sid=' . session_id());
}

/**
 * edit group
 */
else if($_REQUEST['action'] == 'editGroup'
		&& isset($_REQUEST['id']))
{
	$group = $book->GetGroup((int)$_REQUEST['id']);
	if($group !== false)
	{
		$tpl->assign('group', $group);
		$tpl->assign('pageContent', 'li/organizer.addressbook.editgroup.tpl');
		$tpl->display('li/index.tpl');
	}
}

/**
 * save group
 */
else if($_REQUEST['action'] == 'saveGroup'
		&& isset($_REQUEST['id'])
		&& isset($_REQUEST['title']))
{
	$group = $book->GetGroup((int)$_REQUEST['id']);
	
	if($group['title'] != $_REQUEST['title'] && $book->GroupExists($_REQUEST['title']))
	{
		// already exists
		$tpl->assign('msg', $lang_user['groupexists']);
		$tpl->assign('pageContent', 'li/error.tpl');
		$tpl->display('li/index.tpl');
	}
	else 
	{
		$book->ChangeGroup((int)$_REQUEST['id'], $_REQUEST['title']);
		header('Location: organizer.addressbook.php?sid=' . session_id());
	}
}

/**
 * user picture dialog
 */
else if($_REQUEST['action'] == 'userPictureDialog'
		&& isset($_REQUEST['id']))
{
	$tpl->assign('title', $lang_user['userpicture']);
	$tpl->assign('text', $lang_user['userpicturetext']);
	$tpl->assign('formAction', 'organizer.addressbook.php?action=userPictureDialogSubmit&id=' . (int)$_REQUEST['id'] . '&sid=' . session_id());
	$tpl->assign('fieldName', 'pictureFile');
	$tpl->display('li/dialog.openfile.tpl');
}

/**
 * user picture dialog submit
 */
else if($_REQUEST['action'] == 'userPictureDialogSubmit'
		&& isset($_REQUEST['id']))
{
	$tempID = RequestTempFile($userRow['id'], time()+TIME_ONE_HOUR);
	$tempName = TempFileName($tempID);
	$uploadFile = getUploadedFile('pictureFile', $tempName);
		
	echo '<script language="javascript">' . "\n";
	echo '<!--' . "\n";
	
	if($uploadFile && in_array(strtolower($uploadFile['type']), array('image/png', 'image/jpg', 'image/pjpeg', 'image/jpeg', 'image/gif'))
		&& $uploadFile['size'] <= $bm_prefs['max_userpicture_size'])
	{
		if($_REQUEST['id'] == -1)
		{
			$pictureURL = 'organizer.addressbook.php?action=addressbookPicture&id=-1&contentType=' . urlencode($uploadFile['type']) . '&tempID=' . $tempID . '&sid=' . session_id();
			echo 'parent.document.getElementById(\'pictureFile\').value = ' . $tempID . ';' . "\n";
			echo 'parent.document.getElementById(\'pictureMime\').value = \'' . addslashes($uploadFile['type']) . '\';' . "\n";
		}
		else 
		{
			if($book->ChangePicture((int)$_REQUEST['id'], $tempName, $uploadFile['type']))
				$pictureURL = 'organizer.addressbook.php?action=addressbookPicture&id=' . (int)$_REQUEST['id'] . '&t=' . time() . '&sid=' . session_id();
		}
		
		if(isset($pictureURL))
			echo 'parent.document.getElementById(\'pictureDiv\').style.backgroundImage = \'url(' . $pictureURL . ')\';' . "\n";
	}
	else 
	{
		ReleaseTempFile($userRow['id'], $tempID);
		echo 'alert(\'' . addslashes(sprintf($lang_user['invalidpicture'], round($bm_prefs['max_userpicture_size']/1024, 2))) . '\');' . "\n";
	}
	
	echo 'parent.hideOverlay();' . "\n";
	echo '//-->' . "\n";
	echo '</script>' . "\n";
}

/**
 * whole addressbook export
 */
else if($_REQUEST['action'] == 'exportAddressbook'
		&& isset($_REQUEST['lineBreakChar'])
		&& isset($_REQUEST['sepChar'])
		&& isset($_REQUEST['quoteChar']))
{
	// line break char
	if($_REQUEST['lineBreakChar'] == 'lf')
		$lineBreakChar = "\n";
	else if($_REQUEST['lineBreakChar'] == 'cr')
		$lineBreakChar =  "\r";
	else 
		$lineBreakChar = "\r\n";
	
	// seperator char
	if($_REQUEST['sepChar'] == 'semicolon')
		$sepChar = ';';
	else if($_REQUEST['sepChar'] == 'comma')
		$sepChar = ',';
	else
		$sepChar = "\t";
	
	// quote char
	if($_REQUEST['quoteChar'] == 'single')
		$quoteChar = '\'';
	else
		$quoteChar = '"';
	
	// export
	header('Pragma: public');
	header('Content-Type: text/csv');
	header('Content-Disposition: attachment; filename="export.csv"');
	$book->ExportAddressbook($lineBreakChar, $quoteChar, $sepChar);
	exit();
}

/**
 * import dialog
 */
else if($_REQUEST['action'] == 'importDialog'
		&& isset($_REQUEST['type']))
{
	$tpl->assign('title', $lang_user['import']);
	$tpl->assign('text', $lang_user['addrimporttext']);
	$tpl->assign('formAction', 'organizer.addressbook.php?action=importDialogSubmit&type=' . $_REQUEST['type'] . '&sid=' . session_id());
	$tpl->assign('fieldName', 'importFile');
	$tpl->display('li/dialog.openfile.tpl');	
}

/**
 * import dialog submit
 */
else if($_REQUEST['action'] == 'importDialogSubmit'
		&& isset($_REQUEST['type']))
{
	$tempID = RequestTempFile($userRow['id'], time() + TIME_ONE_HOUR);
	$tempName = TempFileName($tempID);
	$uploadFile = getUploadedFile('importFile', $tempName);
	
	echo '<script language="javascript">' . "\n";
	echo '<!--' . "\n";
	
	if($uploadFile &&
		(($_REQUEST['type'] == 'csv' && in_array(strtolower($uploadFile['type']), array('text/plain', 'text/csv', 'text/comma-separated-values', 'application/vnd.ms-excel')))
			|| ($_REQUEST['type'] == 'vcfzip' && in_array(strtolower($uploadFile['type']), array('application/zip')))))
	{
		echo 'parent.document.location.href = \'organizer.addressbook.php?action=importFile&type=' . addslashes($_REQUEST['type']) . '&sid=' . session_id() . '&tempID=' . $tempID . '\';';
	}
	else 
	{
		ReleaseTempFile($userRow['id'], $tempID);
		echo 'alert(\'' . addslashes($lang_user['invalidformat']) . '\');' . "\n";
	}
	
	echo 'parent.hideOverlay();' . "\n";
	echo '//-->' . "\n";
	echo '</script>' . "\n";
}

/**
 * file import
 */
else if($_REQUEST['action'] == 'importFile'
		&& isset($_REQUEST['type'])
		&& isset($_REQUEST['tempID'])
		&& ValidTempFile($userRow['id'], (int)$_REQUEST['tempID']))
{
	$tpl->assign('pageTitle', $lang_user['import']);
	
	$tempID = (int)$_REQUEST['tempID'];
	$tempName = TempFileName($tempID);
	
	if($_REQUEST['type'] == 'csv')
	{
		// csv
		$fp = @fopen($tempName, 'r');
		if($fp)
		{
			$csvReader = _new('CSVReader', array($fp));
			$fields = $csvReader->Fields();
			$autoDetect = array();
			$groupList = $book->GetGroupList();
			
			foreach($fields as $field)
				if(isset($bookFieldsAssoc[strtolower($field)]))
					$autoDetect[$field] = $bookFieldsAssoc[strtolower($field)];
			
			$tpl->assign('datasetCount', max(count($csvReader->_data)-1, 0));
			$tpl->assign('fileFields', $fields);
			$tpl->assign('bookFields', $bookFields);
			$tpl->assign('autoDetect', $autoDetect);
			$tpl->assign('groups', $groupList);
			$tpl->assign('tempID', $tempID);
			$tpl->assign('pageContent', 'li/organizer.addressbook.importcsv.tpl');
			$tpl->display('li/index.tpl');
			
			fclose($fp);
		}
	}
}

/**
 * csv import
 */
else if($_REQUEST['action'] == 'importCSV'
		&& isset($_REQUEST['tempID'])
		&& isset($_REQUEST['fields'])
		&& is_array($_REQUEST['fields'])
		&& ValidTempFile($userRow['id'], (int)$_REQUEST['tempID']))
{
	$tempID = (int)$_REQUEST['tempID'];
	$tempName = TempFileName($tempID);
	$importedDatasets = 0;
	$fieldsAssoc = $_REQUEST['fields'];
	$ignoreExisting = $_REQUEST['existing'] != 'update';
	
	// process groups
	$groups = array();
	foreach($_POST as $key=>$val)
		if(substr($key, 0, 6) == 'group_')
			$groups[] = (int)substr($key, 6);
	
	$fp = @fopen($tempName, 'r');
	if($fp)
	{
		$csvReader = _new('CSVReader', array($fp));
		$fields = $csvReader->Fields();
		
		while($row = $csvReader->FetchRow())
		{
			// prepare row
			$addressRow = array();
			foreach($fieldsAssoc as $fileField=>$bookField)
				if(isset($bookFields[$bookField]) && isset($row[$fileField]))
					$addressRow[$bookField] = $row[$fileField];
			
			// complete missing fields
			foreach($bookFields as $bookField=>$langTitle)
				if(!isset($addressRow[$bookField]))
					$addressRow[$bookField] = '';
			
			// get ID of existing row, if available
			$existingID = $ignoreExisting ? 0 : $book->FindAddress($addressRow['vorname'], $addressRow['nachname']);
			
			// add/update dataset
			if($existingID == 0)
			{
				// add
				$book->AddContact($addressRow['firma'],
								$addressRow['vorname'],
								$addressRow['nachname'],
								$addressRow['strassenr'],
								$addressRow['plz'],
								$addressRow['ort'],
								$addressRow['land'],
								$addressRow['tel'],
								$addressRow['fax'],
								$addressRow['handy'],
								$addressRow['email'],
								$addressRow['work_strassenr'],
								$addressRow['work_plz'],
								$addressRow['work_ort'],
								$addressRow['work_land'],
								$addressRow['work_tel'],
								$addressRow['work_fax'],
								$addressRow['work_handy'],
								$addressRow['work_email'],
								$addressRow['anrede'],
								$addressRow['position'],
								$addressRow['web'],
								$addressRow['kommentar'],
								max(@strtotime($addressRow['geburtsdatum']), 0),
								ADDRESS_PRIVATE,
								$groups);
			}
			else 
			{
				// update
				$book->Change($existingID,
								$addressRow['firma'],
								$addressRow['vorname'],
								$addressRow['nachname'],
								$addressRow['strassenr'],
								$addressRow['plz'],
								$addressRow['ort'],
								$addressRow['land'],
								$addressRow['tel'],
								$addressRow['fax'],
								$addressRow['handy'],
								$addressRow['email'],
								$addressRow['work_strassenr'],
								$addressRow['work_plz'],
								$addressRow['work_ort'],
								$addressRow['work_land'],
								$addressRow['work_tel'],
								$addressRow['work_fax'],
								$addressRow['work_handy'],
								$addressRow['work_email'],
								$addressRow['anrede'],
								$addressRow['position'],
								$addressRow['web'],
								$addressRow['kommentar'],
								max(@strtotime($addressRow['geburtsdatum']), 0),
								ADDRESS_PRIVATE,
								false);
			}
			
			// inc
			$importedDatasets++;
		}
		
		fclose($fp);
	}
	
	// show result
	$tpl->assign('pageTitle', $lang_user['import']);
	$tpl->assign('title', $lang_user['import']);
	$tpl->assign('msg', sprintf($lang_user['importdone'], $importedDatasets));
	$tpl->assign('backLink', 'organizer.addressbook.php?sid=' . session_id());
	$tpl->assign('pageContent', 'li/msg.tpl');
	$tpl->display('li/index.tpl');
	
	// release temp file
	ReleaseTempFile($userRow['id'], $tempID);
}

/**
 * address popup
 */
else if($_REQUEST['action'] == 'addressPopup')
{
	$mode = isset($_REQUEST['mode']) ? $_REQUEST['mode'] : 'email';
	
	$addresses = array();
	
	// addressbook
	$addressBook = $book->GetAddressBook('*', -1, 'nachname', 'desc');
	foreach($addressBook as $id=>$entry)
	{
		$addresses[] = array('name' 			=> $entry['nachname'] . ', ' . $entry['vorname'],
								'email1' 		=> $entry['default_address'] == ADDRESS_WORK ? $entry['work_email'] : $entry['email'],
								'email2'		=> $entry['default_address'] == ADDRESS_WORK ? $entry['email'] : $entry['work_email'],
								'handy' 		=> $entry['handy'],
								'type'			=> '');
	}
	
	// given addresses
	$givenAddresses = array();
	if($mode != 'handy')
	{
		$givenAddresses['to'] = isset($_REQUEST['to']) 
									? ParseMailList($_REQUEST['to'])
									: array();
		$givenAddresses['cc'] = isset($_REQUEST['cc']) 
									? ParseMailList($_REQUEST['cc'])
									: array();
		$givenAddresses['bcc'] = isset($_REQUEST['bcc']) 
									? ParseMailList($_REQUEST['bcc'])
									: array();
		foreach($givenAddresses as $type=>$addressList)
			foreach($addressList as $address)
				$addresses[] = array('name'			=> $address['name'],
										'email1'	=> $address['mail'],
										'type'		=> $type);
	}
	
	$tpl->assign('mode', $mode);
	$tpl->assign('addresses', $addresses);	
	$tpl->display('li/organizer.addressbook.popup.tpl');
}

/**
 * attendee popup
 */
else if($_REQUEST['action'] == 'attendeePopup')
{
	$addresses = array();
	
	// addressbook
	$addressBook = $book->GetAddressBook('*', -1, 'nachname', 'asc');
	foreach($addressBook as $id=>$entry)
	{
		$addresses[] = array('firstname' 		=> $entry['vorname'],
								'lastname'		=> $entry['nachname'],
								'type'			=> '',
								'id'			=> $entry['id']);
	}
	
	// given addresses
	$attendees = array();
	if(trim($_REQUEST['attendeeList']) != '')
	{
		$attendeeList = explode(';', $_REQUEST['attendeeList']);
		foreach($attendeeList as $attendeeItem)
		{
			if(trim($attendeeItem) != '')
			{
				list($attendeeID, $attendeeLastName, $attendeeFirstName) = explode(',', $attendeeItem);
				$addresses[] = array('firstname' 		=> $attendeeFirstName,
										'lastname'		=> $attendeeLastName,
										'type'			=> 'att',
										'id'			=> $attendeeID);
			}
		}
	}
	
	$tpl->assign('addresses', $addresses);	
	$tpl->display('li/organizer.addressbook.popup.attendees.tpl');
}

/**
 * number popup
 */
else if($_REQUEST['action'] == 'numberPopup')
{
	$addresses = array();
	
	// addressbook
	$addressBook = $book->GetAddressBook('*', -1, 'nachname', 'asc');
	foreach($addressBook as $id=>$entry)
	{
		if(trim($entry['handy']) != '' || trim($entry['work_handy']) != '')
			$addresses[] = array('firstname' 		=> $entry['vorname'],
									'lastname'		=> $entry['nachname'],
									'handy'			=> $entry['handy'],
									'work_handy'	=> $entry['work_handy'],
									'id'			=> $entry['id']);
	}
	
	$tpl->assign('addresses', $addresses);	
	$tpl->display('li/organizer.addressbook.popup.numbers.tpl');
}

/**
 * address lookup RPC
 */
else if($_REQUEST['action'] == 'lookupAddresses'
		&& isset($_REQUEST['text']))
{
	$text = trim($_REQUEST['text']);
	if($text !=  '')
	{
		$addresses = $book->Lookup($text);
		echo implode(';', $addresses);
	}
}
?>
