<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: organizer.todo.php,v 1.8 2008/12/09 19:15:34 patrick Exp $
 *
 */

include('./serverlib/init.inc.php');
include('./serverlib/todo.class.php');
RequestPrivileges(PRIVILEGES_USER);

/**
 * file handler for modules
 */
ModuleFunction('FileHandler',
	array(substr(__FILE__, strlen(dirname(__FILE__))+1),
	isset($_REQUEST['action']) ? $_REQUEST['action'] : ''));

/**
 * default action = start
 */
if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'start';
$tpl->assign('activeTab', 'organizer');
$tpl->assign('pageTitle', $lang_user['todolist']);

/**
 * todo interface
 */
$todo = _new('BMTodo', array($userRow['id']));

/**
 * page menu
 */
$tpl->assign('tasks', $todo->GetTodoList('faellig', 'asc', 5));
$tpl->assign('pageMenuFile', 'li/organizer.sidebar.tpl');

/**
 * start page
 */
if($_REQUEST['action'] == 'start')
{
	$sortColumns = array('beginn', 'faellig', 'erledigt', 'akt_status', 'titel', 'priority');
	
	// get sort info
	$sortColumn = (isset($_REQUEST['sort']) && in_array($_REQUEST['sort'], $sortColumns))
					? $_REQUEST['sort']
					: 'faellig';
	$sortOrder = (isset($_REQUEST['order']) && in_array($_REQUEST['order'], array('asc', 'desc')))
					? $_REQUEST['order']
					: 'asc';
	
	// note list
	$todoList = $todo->GetTodoList($sortColumn, $sortOrder);
		
	// page output
	$tpl->assign('todoList', $todoList);
	$tpl->assign('sortColumn', $sortColumn);
	$tpl->assign('sortOrder', $sortOrder);
	$tpl->assign('sortOrderInv', $sortOrder == 'asc' ? 'desc' : 'asc');	
	$tpl->assign('pageContent', 'li/organizer.todo.tpl');
	$tpl->display('li/index.tpl');
}

/**
 * set task status for sidebar RPC
 */
else if($_REQUEST['action'] == 'setTaskDone'
		&& isset($_REQUEST['id'])
		&& isset($_REQUEST['done']))
{
	die($todo->SetStatus((int)$_REQUEST['id'], $_REQUEST['done'] == 'true' ? TASKS_DONE : TASKS_PROCESSING));
}

/**
 * action
 */
else if($_REQUEST['action'] == 'action'
		&& isset($_REQUEST['do']))
{
	if($_REQUEST['do'] == 'delete')
	{
		foreach($_POST as $key=>$val)
		{
			if(substr($key, 0, 5) == 'task_')
			{
				$id = substr($key, 5);
				$todo->Delete($id);
			}
		}
	}
	else if($_REQUEST['do'] == 'markasdone')
	{
		foreach($_POST as $key=>$val)
		{
			if(substr($key, 0, 5) == 'task_')
			{
				$id = substr($key, 5);
				$todo->SetStatus($id, TASKS_DONE);
			}
		}
	}
	header('Location: organizer.todo.php?sid=' . session_id());
}

/**
 * delete task
 */
else if($_REQUEST['action'] == 'deleteTask'
		&& isset($_REQUEST['id']))
{
	$todo->Delete((int)$_REQUEST['id']);
	header('Location: organizer.todo.php?sid=' . session_id());
}

/**
 * add task
 */
else if($_REQUEST['action'] == 'addTask')
{
	$tpl->assign('pageTitle', $lang_user['addtask']);
	$tpl->assign('pageContent', 'li/organizer.todo.edit.tpl');
	$tpl->display('li/index.tpl');
}

/**
 * create task
 */
else if($_REQUEST['action'] == 'createTask'
		&& isset($_REQUEST['beginnDay'])
		&& isset($_REQUEST['faelligDay'])
		&& isset($_REQUEST['erledigt'])
		&& isset($_REQUEST['comments'])
		&& isset($_REQUEST['titel'])
		&& isset($_REQUEST['priority']))
{
	$todo->Add(SmartyDateTime('beginn'),
				SmartyDateTime('faellig'),
				(int)$_REQUEST['akt_status'],
				$_REQUEST['titel'],
				(int)$_REQUEST['priority'],
				(int)$_REQUEST['erledigt'],
				$_REQUEST['comments']);
	header('Location: organizer.todo.php?sid=' . session_id());
}

/**
 * edit task
 */
else if($_REQUEST['action'] == 'editTask'
		&& isset($_REQUEST['id']))
{
	$taskInfo = $todo->GetTask((int)$_REQUEST['id']);
	if($taskInfo !== false)
	{
		$tpl->assign('pageTitle', $lang_user['edittask']);
		$tpl->assign('pageContent', 'li/organizer.todo.edit.tpl');
		$tpl->assign('task', $taskInfo);
		$tpl->display('li/index.tpl');
	}
}

/**
 * save task
 */
else if($_REQUEST['action'] == 'saveTask'
		&& isset($_REQUEST['id'])
		&& isset($_REQUEST['beginnDay'])
		&& isset($_REQUEST['faelligDay'])
		&& isset($_REQUEST['erledigt'])
		&& isset($_REQUEST['comments'])
		&& isset($_REQUEST['titel'])
		&& isset($_REQUEST['priority']))
{
	$todo->Change((int)$_REQUEST['id'],
				SmartyDateTime('beginn'),
				SmartyDateTime('faellig'),
				(int)$_REQUEST['akt_status'],
				$_REQUEST['titel'],
				(int)$_REQUEST['priority'],
				(int)$_REQUEST['erledigt'],
				$_REQUEST['comments']);
	header('Location: organizer.todo.php?sid=' . session_id());	
}
?>