<?php 
/*
 * b1gMail7
 * (c) 2002-2006 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: widget.base.php,v 1.11 2009/02/18 13:40:20 patrick Exp $
 *
 */

/**
 * constants for all base widgets
 *
 */
define('BASEWIDGET_ITEMCOUNT',		25);

/**
 * web search widget
 *
 */
class BMPlugin_Widget_Websearch extends BMPlugin 
{
	function BMPlugin_Widget_Websearch()
	{
		global $lang_user;
		
		$this->type				= BMPLUGIN_WIDGET;
		$this->name				= 'Web search widget';
		$this->author			= 'B1G Software';
		$this->widgetTemplate	= 'widget.search.tpl';
		$this->widgetTitle		= $lang_user['websearch'];
	}
	
	function isWidgetSuitable($for)
	{
		return($for == BMWIDGET_START
				|| $for == BMWIDGET_ORGANIZER);
	}
	
	function renderWidget()
	{
		return(true);
	}
}

/**
 * mail space widget
 * 
 */
class BMPlugin_Widget_Mailspace extends BMPlugin
{
	function BMPlugin_Widget_Mailspace()
	{
		global $lang_user;
		
		$this->type				= BMPLUGIN_WIDGET;
		$this->name				= 'Mail space widget';
		$this->author			= 'B1G Software';
		$this->widgetTemplate	= 'widget.mailspace.tpl';
		$this->widgetTitle		= $lang_user['space'] . ' (' . $lang_user['email'] . ')';
	}
	
	function isWidgetSuitable($for)
	{
		return($for == BMWIDGET_START);
	}
	
	function renderWidget()
	{
		global $groupRow, $userRow, $tpl;
		$tpl->assign('bmwidget_mailspace_spaceUsed', $userRow['mailspace_used']);
		$tpl->assign('bmwidget_mailspace_spaceLimit', $groupRow['storage']);
		return(true);
	}
}

/**
 * webdisk space widget
 * 
 */
class BMPlugin_Widget_Webdiskspace extends BMPlugin
{
	function BMPlugin_Widget_Webdiskspace()
	{
		global $lang_user;
		
		$this->type				= BMPLUGIN_WIDGET;
		$this->name				= 'Webdisk space widget';
		$this->author			= 'B1G Software';
		$this->widgetTemplate	= 'widget.webdiskspace.tpl';
		$this->widgetTitle		= $lang_user['space'] . ' (' . $lang_user['webdisk'] . ')';
	}
	
	function isWidgetSuitable($for)
	{
		return($for == BMWIDGET_START);
	}
	
	function renderWidget()
	{
		global $tpl, $thisUser;
		
		if(!class_exists('BMWebdisk'))
			include(B1GMAIL_DIR . 'serverlib/webdisk.class.php');
			
		$webdisk 	= _new('BMWebdisk', array($thisUser->_id));
		$spaceLimit = $webdisk->GetSpaceLimit();
		$usedSpace 	= $webdisk->GetUsedSpace();
		
		$tpl->assign('bmwidget_webdiskspace_spaceUsed', $usedSpace);
		$tpl->assign('bmwidget_webdiskspace_spaceLimit', $spaceLimit);
		return(true);
	}
}

/**
 * webdisk space widget
 * 
 */
class BMPlugin_Widget_Tasks extends BMPlugin
{
	function BMPlugin_Widget_Tasks()
	{
		global $lang_user;
		
		$this->type				= BMPLUGIN_WIDGET;
		$this->name				= 'Task list widget';
		$this->author			= 'B1G Software';
		$this->widgetTemplate	= 'widget.tasks.tpl';
		$this->widgetTitle		= $lang_user['tasks'];
	}
	
	function isWidgetSuitable($for)
	{
		return($for == BMWIDGET_START
				|| $for == BMWIDGET_ORGANIZER);
	}
	
	function renderWidget()
	{
		global $tpl, $thisUser;
		
		if(!class_exists('BMTodo'))
			include(B1GMAIL_DIR . 'serverlib/todo.class.php');
			
		$todoList 	= _new('BMTodo', array($thisUser->_id));
		
		$tpl->assign('bmwidget_tasks_items', $todoList->GetTodoList('faellig', 'DESC', BASEWIDGET_ITEMCOUNT));
		return(true);
	}
}

/**
 * welcome widget
 *
 */
class BMPlugin_Widget_Welcome extends BMPlugin 
{
	function BMPlugin_Widget_Welcome()
	{
		global $lang_user;
		
		$this->type				= BMPLUGIN_WIDGET;
		$this->name				= 'Welcome widget';
		$this->author			= 'B1G Software';
		$this->widgetTemplate	= 'widget.welcome.tpl';
		$this->widgetTitle		= $lang_user['welcome'];
	}
	
	function isWidgetSuitable($for)
	{
		return($for == BMWIDGET_START);
	}
	
	function renderWidget()
	{
		global $lang_user, $userRow, $tpl, $bm_prefs, $thisUser;
		
		if(!class_exists('BMMailbox'))
			include(B1GMAIL_DIR . 'serverlib/mailbox.class.php');
		if(!class_exists('BMTodo'))
			include(B1GMAIL_DIR . 'serverlib/todo.class.php');
		if(!class_exists('BMCalendar'))
			include(B1GMAIL_DIR . 'serverlib/calendar.class.php');
			
		// count mails
		$mailbox = _new('BMMailbox', array($thisUser->_id, $userRow['email'], $thisUser));
		$mailCount = $mailbox->GetMailCount(-1, true);
		
		// count tasks
		$todo = _new('BMTodo', array($thisUser->_id));
		$taskCount = $todo->GetUndoneTaskCount();
		
		// count dates
		$calendar = _new('BMCalendar', array($thisUser->_id));
		$dateCount = count($calendar->GetDatesForDay((int)date('d'), (int)date('m'), (int)date('Y')));
		
		$tpl->assign('bmwidget_welcome_welcomeText', sprintf($lang_user['welcometext'],
			htmlentities($bm_prefs['titel']),
			htmlentities($userRow['vorname'] . ' ' . $userRow['nachname'])));
		$tpl->assign('bmwidget_welcome_mails', sprintf($lang_user['newmailtext'],
			$mailCount));
		$tpl->assign('bmwidget_welcome_dates', sprintf($lang_user['datetext'],
			$dateCount));
		$tpl->assign('bmwidget_welcome_tasks', sprintf($lang_user['tasktext'],
			$taskCount));
		
		return(true);
	}
}

/**
 * webdisk drop target widget
 *
 */
class BMPlugin_Widget_WebdiskDND extends BMPlugin 
{
	function BMPlugin_Widget_WebdiskDND()
	{
		global $lang_user;
		
		$this->type				= BMPLUGIN_WIDGET;
		$this->name				= 'Webdisk drag and drop widget';
		$this->author			= 'B1G Software';
		$this->widgetTemplate	= 'widget.webdiskdnd.tpl';
		$this->widgetTitle		= $lang_user['webdisk'] . ' ' . $lang_user['dnd_upload'];
	}
	
	function isWidgetSuitable($for)
	{
		return($for == BMWIDGET_START);
	}
	
	function renderWidget()
	{
		global $tpl;
		$tpl->assign('bmwidget_webdiskdnd_userAgent',		$_SERVER['HTTP_USER_AGENT']);
		$tpl->assign('bmwidget_webdiskdnd_dndKey',			isset($_COOKIE['sessionSecret_' . session_id()]) ? $_COOKIE['sessionSecret_' . session_id()] : '');
		return(true);
	}
}

/**
 * calendar widget
 *
 */
class BMPlugin_Widget_Calendar extends BMPlugin 
{
	function BMPlugin_Widget_Calendar()
	{
		global $lang_user;
		
		$this->type				= BMPLUGIN_WIDGET;
		$this->name				= 'Calendar widget';
		$this->author			= 'B1G Software';
		$this->widgetTemplate	= 'widget.calendar.tpl';
		$this->widgetTitle		= $lang_user['calendar'];
	}
	
	function isWidgetSuitable($for)
	{
		return($for == BMWIDGET_START
				|| $for == BMWIDGET_ORGANIZER);
	}
	
	function renderWidget()
	{
		global $tpl, $thisUser;
		
		if(!class_exists('BMCalendar'))
			include(B1GMAIL_DIR . 'serverlib/calendar.class.php');
			
		$calendar	= _new('BMCalendar', array($thisUser->_id));
		
		$tpl->assign('bmwidget_calendar_html', $calendar->GenerateMiniCalendar());
		return(true);
	}
}

/**
 * notes widget
 *
 */
class BMPlugin_Widget_Notes extends BMPlugin 
{
	function BMPlugin_Widget_Notes()
	{
		global $lang_user;
		
		$this->type				= BMPLUGIN_WIDGET;
		$this->name				= 'Notes widget';
		$this->author			= 'B1G Software';
		$this->widgetTemplate	= 'widget.notes.tpl';
		$this->widgetTitle		= $lang_user['notes'];
	}
	
	function isWidgetSuitable($for)
	{
		return($for == BMWIDGET_START
				|| $for == BMWIDGET_ORGANIZER);
	}
	
	function renderWidget()
	{
		global $tpl, $thisUser;
		
		if(!class_exists('BMNotes'))
			include(B1GMAIL_DIR . 'serverlib/notes.class.php');
			
		$notesList 	= _new('BMNotes', array($thisUser->_id));
		
		$tpl->assign('bmwidget_notes_items', $notesList->GetNoteList('date', 'DESC', BASEWIDGET_ITEMCOUNT));
		return(true);
	}
}

/**
 * e-mail widget
 *
 */
class BMPlugin_Widget_EMail extends BMPlugin
{
	function BMPlugin_Widget_EMail()
	{
		global $lang_user;
		
		$this->type				= BMPLUGIN_WIDGET;
		$this->name				= 'EMail widget';
		$this->author			= 'B1G Software';
		$this->widgetTemplate	= 'widget.email.tpl';
		$this->widgetTitle		= $lang_user['email'];
	}
	
	function isWidgetSuitable($for)
	{
		return($for == BMWIDGET_START);
	}
	
	function renderWidget()
	{
		global $tpl, $thisUser, $userRow;
		
		if(!class_exists('BMMailbox'))
			include(B1GMAIL_DIR . 'serverlib/mailbox.class.php');
			
		$mailbox = _new('BMMailbox', array($thisUser->_id, $userRow['email'], $thisUser));
		$folderList = $mailbox->GetFolderList(true);
		$emailItems = array();
		
		foreach($folderList as $folderID=>$folder)
		{
			$emailItems[$folderID] = array(
					'link'			=> 'email.php?folder=' . $folderID . '&sid=' . session_id(),
					'text'			=> $folder['title'],
					'icon'			=> $folder['type'],
					'unreadMails'	=> $folder['unread'],
					'flaggedMails'	=> $mailbox->GetMailCount($folderID, false, true)
			);
		}

		$tpl->assign('bmwidget_email_items', $emailItems);
		return(true);
	}
}

/**
 * quick links widget
 *
 */
class BMPlugin_Widget_Quicklinks extends BMPlugin
{
	function BMPlugin_Widget_Quicklinks()
	{
		global $lang_user;
		
		$this->type				= BMPLUGIN_WIDGET;
		$this->name				= 'Quick links widget';
		$this->author			= 'B1G Software';
		$this->widgetTemplate	= 'widget.quicklinks.tpl';
		$this->widgetTitle		= $lang_user['quicklinks'];
	}
	
	function isWidgetSuitable($for)
	{
		return($for == BMWIDGET_START
				|| $for == BMWIDGET_ORGANIZER);
	}
	
	function renderWidget()
	{
		return(true);
	}
}

/**
 * register widgets
 */
$plugins->registerPlugin('BMPlugin_Widget_Websearch');
$plugins->registerPlugin('BMPlugin_Widget_Mailspace');
$plugins->registerPlugin('BMPlugin_Widget_Webdiskspace');
$plugins->registerPlugin('BMPlugin_Widget_Tasks');
$plugins->registerPlugin('BMPlugin_Widget_Welcome');
$plugins->registerPlugin('BMPlugin_Widget_WebdiskDND');
$plugins->registerPlugin('BMPlugin_Widget_Calendar');
$plugins->registerPlugin('BMPlugin_Widget_Notes');
$plugins->registerPlugin('BMPlugin_Widget_EMail');
$plugins->registerPlugin('BMPlugin_Widget_Quicklinks');
?>