<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: admin.inc.php,v 1.38 2008/05/20 22:38:41 patrick Exp $
 *
 */

define('ADMIN_MODE', true);
include('../serverlib/init.inc.php');

// tables
$fieldTypeTable = array(
	FIELD_CHECKBOX					=> $lang_admin['checkbox'],
	FIELD_DROPDOWN					=> $lang_admin['dropdown'],
	FIELD_RADIO						=> $lang_admin['radio'],
	FIELD_TEXT						=> $lang_admin['text']
);
$pluginTypeTable = array(
	BMPLUGIN_DEFAULT				=> $lang_admin['module'],
	BMPLUGIN_FILTER					=> $lang_admin['filter'],
	BMPLUGIN_WIDGET					=> $lang_admin['widget']
);
$statusTable = array(
	'yes'							=> $lang_admin['locked'],
	'no'							=> $lang_admin['active'],
	'locked'						=> $lang_admin['notactivated'],
	'delete'						=> $lang_admin['deleted']
);
$statusImgTable = array(
	'yes'							=> 'locked',
	'no'							=> 'active',
	'locked'						=> 'notactivated',
	'delete'						=> 'deleted'
);
$aliasTypeTable = array(
	ALIAS_RECIPIENT					=> $lang_admin['receive'],
	ALIAS_SENDER					=> $lang_admin['send'],
	ALIAS_SENDER|ALIAS_RECIPIENT	=> $lang_admin['send'] . ', ' . $lang_admin['receive'],
	ALIAS_SENDER|ALIAS_PENDING		=> $lang_admin['notconfirmed']
);
$ruleActionTable = array(
	RECVRULE_ACTION_ISRECIPIENT		=> $lang_admin['isrecipient'],
	RECVRULE_ACTION_SETRECIPIENT	=> $lang_admin['setrecipient'],
	RECVRULE_ACTION_ADDRECIPIENT	=> $lang_admin['addrecipient'],
	RECVRULE_ACTION_DELETE			=> $lang_admin['delete'],
	RECVRULE_ACTION_BOUNCE			=> $lang_admin['bounce'],
	RECVRULE_ACTION_MARKSPAM		=> $lang_admin['markspam'],
	RECVRULE_ACTION_MARKINFECTED	=> $lang_admin['markinfected'],
	RECVRULE_ACTION_SETINFECTION	=> $lang_admin['setinfection'],
	RECVRULE_ACTION_MARKREAD		=> $lang_admin['markread']
);
$ruleTypeTable = array(
	RECVRULE_TYPE_INACTIVE			=> $lang_admin['inactive'],
	RECVRULE_TYPE_RECEIVERULE		=> $lang_admin['receiverule'],
	RECVRULE_TYPE_CUSTOMRULE		=> $lang_admin['custom']
);
$faqRequirementTable = array(
	'responder'						=> $lang_admin['autoresponder'],
	'forward'						=> $lang_admin['forward'],
	'mail2sms'						=> $lang_admin['mail2sms'],
	'pop3'							=> $lang_admin['pop3'],
	'imap'							=> $lang_admin['imap'],
	'webdav'						=> $lang_admin['webdav'],
	'httpmail'						=> $lang_admin['httpmail'],
	'wap'							=> $lang_admin['mobileaccess'],
	'checker'						=> $lang_admin['mailchecker'],
	'webdisk'						=> $lang_admin['webdisk'],
	'share'							=> $lang_admin['wdshare']
);
$lockedTypeTable = array(
	'start'							=> $lang_admin['startswith'],
	'mitte'							=> $lang_admin['contains'],
	'ende'							=> $lang_admin['endswith'],
	'gleich'						=> $lang_admin['isequal']
);
$backupTables = array(
	'prefs'		=> array('prefs', 'ads', 'codes', 'extensions', 'faq', 'gruppen',
							'locked', 'mods', 'payments', 'profilfelder', 'recvrules', 'smsgateways',
							'smstypen', 'staaten', 'texts', 'workgroups', 'workgroups_member',
							'groupoptions'),
	'stats'		=> array('stats'),
	'users'		=> array('users', 'aliase', 'autoresponder', 'filter', 'filter_actions', 'filter_conditions',
							'folder_conditions', 'folders', 'pop3', 'signaturen', 'smsend', 'userprefs'),
	'organizer'	=> array('adressen', 'adressen_gruppen', 'adressen_gruppen_member', 'dates', 'dates_attendees',
							'dates_groups', 'notes', 'tasks'),
	'mails'		=> array('mails', 'certmails'),
	'webdisk'	=> array('diskfiles', 'diskfolders', 'diskprops')
);

// files and folders that should have write permissions
$writeableFiles = array(
	'admin/templates/cache/',
	'languages/',
	'logs/',
	'plugins/',
	'plugins/templates/',
	'plugins/templates/images/',
	'temp/',
	'temp/session/',
	'temp/cache/',
	'templates/' . $bm_prefs['template'] . '/cache/'
);

// htaccess files that should exist
$htaccessFiles = array(
	'data/.htaccess',
	'logs/.htaccess',
	'temp/.htaccess'
);

/**
 * set file permissions through FTP
 *
 * @param array $files Files (or string with single file)
 * @param bool $writeable Make file writeable?
 * @return bool
 */
function SetFTPPermissions($files, $writeable)
{
	global $bm_prefs;
	
	// init
	$result = false;
	if(!is_array($files))
		$files = array($files);
	
	// open connection
	$sock = @fsockopen($bm_prefs['ftp_host'], $bm_prefs['ftp_port'], $errNo, $errStr, SOCKET_TIMEOUT);
	if($sock && substr(fgets2($sock), 0, 3) == '220')
	{
		// login
		if(fwrite($sock, sprintf('USER %s' . "\r\n", $bm_prefs['ftp_user']))
			&& substr($response = fgets2($sock), 0, 3) == '331'
			&& fwrite($sock, sprintf('PASS %s' . "\r\n", $bm_prefs['ftp_pass']))
			&& substr($response = fgets2($sock), 0, 3) == '230')
		{
			// cd to b1gMail path
			if(fwrite($sock, sprintf('CWD %s' . "\r\n", $bm_prefs['ftp_dir']))
				&& substr($response = fgets2($sock), 0, 3) == '250')
			{
				// chmod!
				foreach($files as $file)
					if(fwrite($sock, sprintf('SITE CHMOD %04d %s' . "\r\n",
						$writeable ? 777 : $bm_prefs['ftp_permissions'], $file))
						&& substr($response = fgets2($sock), 0, 3) == '200')
					{
						$result = true;
					}
			}
			else
			{
				// log
				PutLog(sprintf('Failed to change working directory to <%s> at FTP server <%s:%d>',
					$bm_prefs['ftp_dir'],
					$bm_prefs['ftp_host'],
					$bm_prefs['ftp_port']),
					PRIO_WARNING,
					__FILE__,
					__LINE__);
			}
		}
		else 
		{
			// log
			PutLog(sprintf('FTP server <%s:%d> rejected username or password',
				$bm_prefs['ftp_host'],
				$bm_prefs['ftp_port']),
				PRIO_WARNING,
				__FILE__,
				__LINE__);
		}
		
		// logout
		fwrite($sock, 'QUIT' . "\r\n")
			&& fgets2($sock);
		fclose($sock);
	}
	else 
	{
		// log
		PutLog(sprintf('FTP connection to <%s:%d> failed (%d, %s)',
			$bm_prefs['ftp_host'],
			$bm_prefs['ftp_port'],
			$errNo,
			$errStr),
			PRIO_WARNING,
			__FILE__,
			__LINE__);
	}
	
	// return
	return($result);
}

/**
 * get stat data
 *
 * @param mixed $types Stat type(s)
 * @param int $time Stat time
 * @return array
 */
function GetStatData($types, $time)
{
	global $db;
	
	// load class, if needed
	if(!class_exists('BMCalendar'))
		include(B1GMAIL_DIR . 'serverlib/calendar.class.php');
	
	// types?
	if(!is_array($types))
		$types = array($types);
	$typeList = '\'' . implode('\',\'', $types) . '\'';
	
	// pepare result array
	$result = $nullArray = array();
	foreach($types as $type)
		$nullArray[$type] = 0;
	for($i=1; $i<=BMCalendar::GetDaysInMonth(date('m', $time), date('Y', $time)); $i++)
		$result[(int)$i] = $nullArray;
	
	// fetch stats from DB
	$res = $db->Query('SELECT typ,d,anzahl FROM {pre}stats WHERE typ IN ('.$typeList.') AND m=? AND y=? ORDER BY d ASC',
		date('m', $time),
		date('Y', $time));
	while($row = $res->FetchArray(MYSQL_ASSOC))
	{
		$result[(int)$row['d']][$row['typ']] = in_array($row['typ'], array('wd_down', 'wd_up'))
												? round($row['anzahl']/1024, 2)
												: $row['anzahl'];
	}
	$res->Free();
	
	return($result);
}

/**
 * get categorized space usage
 *
 * @return array
 */
function GetCategorizedSpaceUsage()
{
	global $backupTables, $db, $mysql;
	
	// get table sizes
	$tableSizes = array();
	$res = $db->Query('SHOW TABLE STATUS');
	while($row = $res->FetchArray(MYSQL_ASSOC))
		if(substr($row['Name'], 0, strlen($mysql['prefix'])) == $mysql['prefix'])
			$tableSizes[substr($row['Name'], strlen($mysql['prefix']))] = $row['Data_length'] - $row['Data_free'];
	$res->Free();
	
	// estimate sizes
	$sizes = array();
	foreach($backupTables as $key=>$tables)
		foreach($tables as $table)
			if(isset($sizes[$key]))
				$sizes[$key] += $tableSizes[$table];
			else 
				$sizes[$key] = $tableSizes[$table];
	
	// data size for mails + webdisk
	$res = $db->Query('SELECT SUM(size) FROM {pre}mails');
	list($emailSize) = $res->FetchArray(MYSQL_NUM);
	$res->Free();
	$res = $db->Query('SELECT SUM(size) FROM {pre}diskfiles');
	list($diskSize) = $res->FetchArray(MYSQL_NUM);
	$res->Free();
	$sizes['mails'] += $emailSize;
	$sizes['webdisk'] += $diskSize;
	
	// return
	return($sizes);
}

/**
 * get categorizes space usage
 *
 * @return array
 */
function GetGroupSpaceUsage()
{
	global $db, $mysql;
	
	$sizes = array();
	
	// get groups
	$res = $db->Query('SELECT id,titel FROM {pre}gruppen ORDER BY titel ASC');
	while($row = $res->FetchArray(MYSQL_ASSOC))
	{
		// get sizes
		$res2 = $db->Query('SELECT SUM(mailspace_used),SUM(diskspace_used),COUNT(*) FROM {pre}users WHERE gruppe=?',
			$row['id']);
		list($mailSpace, $diskSpace, $userCount) = $res2->FetchArray(MYSQL_NUM);
		$res2->Free();
		$sizes[$row['id']] = array(
			'title'	=> $row['titel'],
			'users'	=> $userCount,
			'size'	=> $mailSpace+$diskSpace
		);
	}
	$res->Free();
	
	// return
	return($sizes);
}
?>