<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: template.class.php,v 1.57 2008/10/24 08:51:27 patrick Exp $
 *
 */

/**
 * smarty
 */
include(B1GMAIL_DIR . 'serverlib/3rdparty/smarty/Smarty.class.php');

/**
 * template class (extends smarty)
 */
class Template extends Smarty 
{
	/**
	 * constructor
	 *
	 * @return Template
	 */
	function Template()
	{
		global $bm_prefs, $lang_user, $lang_info;
		
		// template & cache directories
		if(ADMIN_MODE)
		{
			$this->template_dir	= B1GMAIL_DIR . 'admin/templates/';
			$this->compile_dir	= B1GMAIL_DIR . 'admin/templates/cache/';
			$this->assign('tpldir', './templates/');
		}
		else 
		{
			$this->template_dir = B1GMAIL_DIR . 'templates/' . $bm_prefs['template'] . '/';
			$this->compile_dir 	= B1GMAIL_DIR . 'templates/' . $bm_prefs['template'] . '/cache/';
			$this->assign('tpldir', B1GMAIL_REL . 'templates/' . $bm_prefs['template'] . '/');
		}
		
		// variables
		$this->assign('service_title', 			htmlentities($bm_prefs['titel']));
		$this->assign('charset', 				$lang_info['charset']);
		$this->assign('selfurl', 				$bm_prefs['selfurl']);
		$this->assign('_tpldir', 				'templates/' . $bm_prefs['template'] . '/');
		
		// post vars?
		if(isset($_POST['transPostVars']))
		{
			$_safePost = array();
			foreach($_POST as $key=>$val)
				$_safePost[$key] = htmlentities($val);
			$this->assign('_safePost', $_safePost);
		}
		
		// functions
		$this->register_function('banner', 			'TemplateBanner');
		$this->register_function('lng', 			'TemplateLang');
		$this->register_function('comment', 		'TemplateComment');
		$this->register_function('date', 			'TemplateDate');
		$this->register_function('size', 			'TemplateSize');
		$this->register_function('text', 			'TemplateText');
		$this->register_function('progressBar',		'TemplateProgressBar');
		$this->register_function('miniCalendar',	'TemplateMiniCalendar');
		$this->register_function('fileSelector',	'TemplateFileSelector');
		$this->register_function('pageNav',			'TemplatePageNav');
		$this->register_function('addressList',		'TemplateAddressList');
		$this->register_function('storeTime',		'TemplateStoreTime');
		$this->register_function('pluginMenus',		'TemplatePluginMenus');
		$this->register_function('halfHourToTime',	'TemplateHalfHourToTime');
		$this->register_function('implode',			'TemplateImplode');
		$this->register_function('mobileNr',		'TemplateMobileNr');
	
		// module handler
		ModuleFunction('OnCreateTemplate', array(&$this));
	}
	
	function display($resource_name, $cache_id = null, $compile_id = null)
	{
		global $thisUser, $userRow, $groupRow, $lang_user, $plugins;
		
		// tabs
		if(isset($userRow) && isset($groupRow))
		{
			$pageTabs = array(
				'start' => array(
					'icon'		=> 'start',
					'link'		=> 'start.php?sid='
				),
				'email' => array(
					'icon'		=> 'email',
					'link'		=> 'email.php?sid=',
					'text'		=> $lang_user['email']
				)
			);
			
			if($thisUser->SMSEnabled())
			{
				$pageTabs['sms'] = array(
					'icon'		=> 'sms',
					'link'		=> 'sms.php?sid=',
					'text'		=> $lang_user['sms']
				);
			}
			
			$pageTabs = array_merge($pageTabs, array(
				'organizer' => array(
					'icon'		=> 'organizer',
					'link'		=> 'organizer.php?sid=',
					'text'		=> $lang_user['organizer']
				)));
			
			if($groupRow['webdisk'] > 0)
			{
				$pageTabs = array_merge($pageTabs, array(
					'webdisk' => array(
						'icon'		=> 'webdisk',
						'link'		=> 'webdisk.php?sid=',
						'text'		=> $lang_user['webdisk']
					)));
			}
			
			$moduleResult = $plugins->callFunction('getUserPages', false, true, array(true));
			foreach($moduleResult as $userPages)
				$pageTabs = array_merge($pageTabs, $userPages);
				
			$pageTabs = array_merge($pageTabs, array(
				'prefs' => array(
					'icon'		=> 'prefs',
					'link'		=> 'prefs.php?sid=',
					'text'		=> $lang_user['prefs']
				)));
			$this->assign('pageTabs', $pageTabs);
		}
		
		// pugin pages (not logged in)
		else 
		{
			$menu = array();
			$moduleResult = $plugins->callFunction('getUserPages', false, true, array(false));
			foreach($moduleResult as $userPages)
				$menu = array_merge($menu, $userPages);
			$this->assign('pluginUserPages', $menu);
		}
		
		Smarty::display($resource_name, $cache_id, $compile_id);
	}
}

/**
 * functions registered with smarty
 */
function TemplateBanner($params, &$smarty)
{
	global $db, $groupRow;
	
	if(isset($groupRow) && is_array($groupRow) && $groupRow['ads'] == 'no')
		return('');
		
	if(isset($params['category']) && (($category = trim($params['category'])) != ''))
		$res = $db->Query('SELECT id,code FROM {pre}ads WHERE paused=? AND category=? ORDER BY (views/weight) ASC LIMIT 1',
			'no',
			$category);
	else
		$res = $db->Query('SELECT id,code FROM {pre}ads WHERE paused=? ORDER BY (views/weight) ASC LIMIT 1',
			'no');
	if($res->RowCount() == 1)
	{
		list($bannerID, $bannerCode) = $res->FetchArray(MYSQL_NUM);
		$res->Free();
		
		$db->Query('UPDATE {pre}ads SET views=views+1 WHERE id=?',
			$bannerID);
		
		return($bannerCode);
	}
	
	return('');
}
function TemplateImplode($params, &$smarty)
{
	return(implode($params['glue'], $params['pieces']));
}
function TemplateLang($params, &$smarty)
{
	global $lang_user, $lang_client, $lang_admin;
	
	$phrase = $params['p'];
	
	if(ADMIN_MODE && isset($lang_admin[$phrase]))
		return($lang_admin[$phrase]);
		
	if(!ADMIN_MODE && isset($lang_user[$phrase]))
		return($lang_user[$phrase]);
	
	return('#UNKNOWN_PHRASE(' . $phrase . ')#');
}
function TemplateHalfHourToTime($params, &$smarty)
{
	$value = $params['value'];
	
	if(isset($params['dateStart']))
	{
		return(mktime(
			$value%2==0 ? $value/2 : ($value-1)/2,
			$value%2==0 ? 0 : 30,
			0,
			date('m', $params['dateStart']),
			date('d', $parmas['dateStart']),
			date('Y', $params['dateStart'])
		));
	}
	
	if($value%2==0)
		return(sprintf('%d:%02d', $value/2, 0));
	else 
		return(sprintf('%d:%02d', ($value-1)/2, 30));
}
function TemplateComment($params, &$smarty)
{
	if(!DEBUG)
		return('');
	return('<!-- ' . $params['text'] . ' -->');
}
function TemplateDate($params, &$smarty)
{
	global $userRow, $bm_prefs, $lang_user;
	
	if(isset($params['nozero']) && $params['timestamp']==0)
		return('-');
	
	if(isset($userRow))
		$format = $userRow['datumsformat'];
	else 	
		$format = $bm_prefs['datumsformat'];
	$ts = $params['timestamp'];
	
	if($ts == -1)
		return($lang_user['unknown']);
		
	$diff = $ts < time() ? time() - $ts : 0;
	if(isset($params['elapsed']))
		if($diff >= TIME_ONE_MINUTE && $diff < TIME_ONE_HOUR)
			$elapsed = sprintf($lang_user['elapsed_minutes'], round($diff/TIME_ONE_MINUTE, 0));
		else if($diff >= TIME_ONE_HOUR && $diff < TIME_ONE_DAY)
			$elapsed = sprintf($lang_user['elapsed_hours'], round($diff/TIME_ONE_HOUR, 0));
		else if($diff >= TIME_ONE_DAY)
			$elapsed = sprintf($lang_user['elapsed_days'], round($diff/TIME_ONE_DAY, 0));
	else 
		$elapsed = '';
		
	if(isset($params['dayonly']))
	{
		return(date('d.m.Y', $ts) . $elapsed);
	}
	else if(!isset($params['nice']))
	{
		return(date($format, $ts) . $elapsed);
	}
	else 
	{
		$today = mktime(0, 0, 0, date('m'), date('d'), date('Y'));
		
		if($ts >= $today && $ts <= $today+TIME_ONE_DAY)
			return(sprintf('%s, %s', $lang_user['today'], date('H:i:s', $ts)) . $elapsed);
		else if($ts >= $today-86400 && $ts < $today)
			return(sprintf('%s, %s', $lang_user['yesterday'], date('H:i:s', $ts)) . $elapsed);
		else 
			return(date($format, $ts) . $elapsed);
	}
}
function TemplateSize($params, &$smarty)
{
	global $lang_user;
	
	$size = $params['bytes'];
	
	if($size == -1)
		return('<i>' . $lang_user['unlimited'] . '</i>');
	
	if($size < 1024)
		return((int)$size . ' B');
	else if($size < 1024*1024)
		return(sprintf('%.2f KB', round($size/1024, 2)));
	else if($size < 1024*1024*1024)
		return(sprintf('%.2f MB', round($size/1024/1024, 2)));
	else
		return(sprintf('%.2f GB', round($size/1024/1024/1024, 2)));
}
function cutHTML($str, $length, $add = '')
{
	// no &#;-entities -> use substr
	if(!preg_match('/\&#([x0-9]*);/', $str))
		return(strlen($str) > $length ? substr($str, 0, $length-strlen($add)) . $add : $str);
	
	// otherwise use the complicated way
	$tooLong = false;
	$result = array();
	for($i=0; $i<strlen($str); $i++)
	{
		$match = false;
		if(strlen($str)-$i > 3
			&& preg_match('/^\&#([x0-9]*);/', substr($str, $i), $match))
		{
			$result[] = $match[0];
			$i += strlen($match[0])-1;
		}
		else 
			$result[] = $str[$i];
		
		if(count($result) >= $length)
		{
			$tooLong = true;
			break;
		}
	}
	
	if($tooLong)
		return(implode('', array_slice($result, 0, $length-strlen($add))) . $add);
	else 
		return(implode('', $result));
}
function TemplateText($params, &$smarty)
{
	$text = $params['value'];
		
	if(isset($params['escape']))
		$text = addslashes($text);
		
	if(isset($params['cut']))
		$text = cutHTML($text, $params['cut'], '...');
	
	if($text == '' && !isset($params['allowEmpty']))
		return(' - ');
		
	if(isset($params['noentities']))
	{
		return($text);
	}
	else
	{
		$text = HTMLFormat($text);
		return($text);
	}
}
function TemplateAddressList($params, &$smarty)
{
	$list = '';
	
	foreach($params['list'] as $addressItem)
	{
		if(isset($params['simple']))
			$list .= '; ' . trim(HTMLFormat($addressItem['name']) . ' ' . (trim($addressItem['name']) != '' ? '&lt;' . HTMLFormat($addressItem['mail']) . '&gt;'
						: HTMLFormat($addressItem['mail'])));		
		else
			$list .= sprintf(' <a class="mailAddressLink" href="javascript:void(0);" onclick="currentEMail=\'%s\';showAddressMenu(event);">%s</a>',
				addslashes($addressItem['mail']),
				trim(HTMLFormat($addressItem['name']) . ' ' . (trim($addressItem['name']) != '' ? '&lt;' . HTMLFormat($addressItem['mail']) . '&gt;'
				: HTMLFormat($addressItem['mail']))));
	}
	
	if(isset($params['simple']))
		$list = substr($list, 2);
	
	return(trim($list));
}
function TemplateProgressBar($params, &$smarty)
{
	$value = $params['value'];
	$max = $params['max'];
	$width = $params['width'];
	$name = isset($params['name']) ? $params['name'] : mt_rand(0, 1000);
	
	if($max == 0)
		$valueWidth = 0;
	else
		$valueWidth = $width/$max * $value;
	
	return(sprintf('<table width="%d" cellspacing="1" cellpadding="0" class="progressBar">'
				.		'<tr>'
				.			'<td width="%d" class="progressBarValue" id="pb_%s_value"><img src="%simages/pixel.gif" border="0" alt="" width="1" height="1" /></td>'
				.			'<td width="%d" class="progressBarFree" id="pb_%s_free"><img src="%simages/pixel.gif" border="0" alt="" width="1" height="1" /></td>'
				.		'</tr>'
				.	'</table>',
				$width,
				$valueWidth, $name,
				$smarty->_tpl_vars['tpldir'],
				$width-$valueWidth, $name,
				$smarty->_tpl_vars['tpldir']));
}
function TemplateMiniCalendar($params, &$smarty)
{
	global $userRow;
	if(!isset($userRow))
		return('Not logged in');
	if(!class_exists('BMCalendar'))
		include(B1GMAIL_DIR . 'serverlib/calendar.class.php');
	return(BMCalendar::GenerateMiniCalendar(-1, -1, $userRow['id']));
}
function TemplateFileSelector($params, &$smarty)
{
	global $lang_user, $groupRow;
	
	$name = $params['name'];
	$size = isset($params['size']) ? (int)$params['size'] : 30;
	
	return(sprintf('<table width="100%%" cellspacing="1" cellpadding="0">'
				.		'<tr>'
				.			'<td width="10"><select onchange="changeFileSelectorSource(this, \'%s\')">'
				.								'<option value="local">%s</option>'
				. ((isset($groupRow) && is_array($groupRow) && $groupRow['webdisk'] > 0) ?
												'<option value="webdisk">%s</option>' : '<!-- %s -->')
				.							'</select></td>'
				.			'<td width="5">&nbsp;</td>'
				.			'<td><div id="fileSelector_local_%s" style="display:;"><input type="file" id="localFile_%s" name="localFile_%s" size="%d" style="width: 100%%;" /></div>'
				.				'<div id="fileSelector_webdisk_%s" style="display:none;"><input type="hidden" name="webdiskFile_%s_id" id="webdiskFile_%s_id" value="" /><input type="text" id="webdiskFile_%s" name="webdiskFile_%s" size="%d" readonly="readonly" /> <input onclick="webdiskDialog(\'%s\', \'open\', \'webdiskFile_%s\')" type="button" value="..." /></div></td>'
				.		'</tr>'
				.	'</table>',	
				$name,
				$lang_user['localfile'],
				$lang_user['webdiskfile'],
				$name,
				$name,
				$name,
				$size,
				$name,
				$name,
				$name,
				$name,
				$name,
				$size,
				session_id(),
				$name));
}
function TemplatePluginMenus($params, &$smarty)
{
	if(BMPluginInterface::isAppropriate())
		return(BMPluginInterface::getMenu());
}
function TemplatePageNav($params, &$smarty)
{
	$tpl_on = $params['on'];
	$tpl_off = $params['off'];
	$aktuelle_seite = $params['page'];
	$anzahl_seiten = $params['pages'];
	$ret = '';

	$seiten = array($aktuelle_seite-3,
		$aktuelle_seite-2,
		$aktuelle_seite-1,
		$aktuelle_seite,
		$aktuelle_seite+1,
		$aktuelle_seite+2,
		$aktuelle_seite+3);

	if($aktuelle_seite > 1)
	{
		$ret .= str_replace('.t', '&lt;&lt;', str_replace('.s', ($aktuelle_seite-1), $tpl_off));
	}

	while(list($key,$val) = each($seiten))
	{
		if($val >= 1 && $val <= $anzahl_seiten)
		{
			if($aktuelle_seite == $val)
			{
				$ret .= str_replace(array('.s', '.t'), $val, $tpl_on);
			}
			else
			{
				$ret .= str_replace(array('.s', '.t'), $val, $tpl_off);
			}
		}
	}

	if($aktuelle_seite < $anzahl_seiten)
	{
		$ret .= str_replace('.t', '&gt;&gt;', str_replace('.s', ($aktuelle_seite+1), $tpl_off));
	}

	return($ret);
}
function TemplateStoreTime($params, &$smarty)
{
	global $lang_user;
	
	$time = $params['value'];
	
	if($time == 86400)
		return('1 ' . $lang_user['days']);
	else if($time == 172800)
		return('2 ' . $lang_user['days']);
	else if($time == 432000)
		return('5 ' . $lang_user['days']);
	else if($time == 604800)
		return('7 ' . $lang_user['days']);
	else if($time == 1209600)
		return('2 ' . $lang_user['weeks']);
	else if($time == 2419200)
		return('4 ' . $lang_user['weeks']);
	else if($time == 4828400)
		return('2 ' . $lang_user['months']);
	else 
		return('-');
}
function TemplateMobileNr($params, &$smarty)
{
	global $groupRow;
	
	$value = isset($params['value']) ? $params['value'] : '';
	$name = $params['name'];
	$size = isset($params['size']) ? $params['size'] : '100%';
	
	if(trim($groupRow['sms_pre']) != '')
	{
		$preOptions = '';
		$haveValue = false;
		$entries = explode(':', $groupRow['sms_pre']);
		foreach($entries as $entry)
		{
			if(trim($entry) != '')
			{
				if(substr($value, 0, strlen($entry)) == $entry && !$haveValue)
				{
					$preOptions .= sprintf('<option value="%s" selected="selected">%s</option>',
						$entry,
						$entry);
					$value = substr($value, strlen($entry));
					$haveValue = true;
				}
				else
				{
					$preOptions .= sprintf('<option value="%s">%s</option>',
						$entry,
						$entry);
				}
			}
		}
		
		return(sprintf('<table width="%s" cellspacing="0" cellpadding="0">'
					.		'<tr>'
					.			'<td width="1" nowrap="nowrap"><nobr>(<select name="%s_pre" id="%s_pre">%s</select>)&nbsp;</nobr></td>'
					.			'<td><input type="text" name="%s_no" id="%s_no" style="width:100%%;" value="%s" /></td>'
					.		'</tr>'
					.	'</table>',
			$size,
			$name, $name,
			$preOptions,
			$name, $name,
			$value));
	}
	else 
	{
		return(sprintf('<input type="text" name="%s" id="%s" style="width:%s;" value="%s" />',
			$name,
			$name,
			$size,
			HTMLFormat($value)));
	}
}
?>