<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: common.inc.php,v 1.15 2008/02/04 15:00:04 patrick Exp $
 *
 */

// error reporting
error_reporting(E_ALL);

// files and folders that should have write permissions
$writeableFiles = array(
	'serverlib/config.inc.php',
	'serverlib/version.inc.php',
	'admin/templates/cache/',
	'languages/',
	'logs/',
	'plugins/',
	'plugins/templates/',
	'plugins/templates/images/',
	'temp/',
	'temp/session/',
	'temp/cache/',
	'templates/default/cache/',
	'data/'
);

/**
 * setup page header
 *
 */
function pageHeader($update = false)
{
	global $lang_setup, $lang, $step;
	
	?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>b1gMail - <?php echo($lang_setup['setup']); ?></title>
	<link type="text/css" href="res/style.css" rel="stylesheet" />
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
	<!--[if lt IE 7]>
	<script defer type="text/javascript" src="../clientlib/pngfix.js"></script>
	<![endif]-->
</head>
<body>
<center>

	<br />
	<img src="res/shade_top.png" border="0" alt="" />
	<table cellspacing="0" cellpadding="0" bgcolor="#FFFFFF">
		<tr>
			<td id="leftshade"></td>
			<td id="main">
				<div id="header">&nbsp;</div>
				<div id="gradient"><i><?php echo($update ? $lang_setup['update'] : $lang_setup['setup']); ?></i>&nbsp;&nbsp;</div>

				<form action="<?php echo($update ? 'update' : 'index'); ?>.php" method="get"><?php if($step != STEP_SELECT_LANGUAGE) { ?><input type="hidden" name="lng" value="<?php echo($lang); ?>" /><?php } ?><div id="content">
	<?php 
}

/**
 * setup page footer
 *
 */
function pageFooter($update = false)
{
	global $lang_setup, $nextStep, $step;
	
	if(isset($nextStep))
	{
		?>
		<hr size="1" color="#DDDDDD" noshade="noshade" width="100%" />
		<div align="right">
			<?php if($nextStep != -1) { ?><input type="hidden" name="step" value="<?php echo($nextStep); ?>" /><?php } ?>
			<input<?php if((!$update && ($step == STEP_WELCOME || $step == STEP_UPDATE_UPDATE)) || ($update && $step == STEP_UPDATE)) echo ' disabled="disabled"';?> id="next_button" type="submit" value=" <?php echo($lang_setup['next']); ?> &raquo; " />
		</div>
		<?php 
	}
	?>
				</div></form>
			</td>
			<td id="rightshade"></td>
		</tr>

	</table>
	<img src="res/shade_bottom.png" border="0" alt="" />

</center>
</body>
</html>
	<?php 
}

/**
 * read setup language file
 *
 */
function ReadLanguage()
{
	global $lang, $lang_setup, $step;
	
	// language?
	if(!isset($_GET['lng']) && !isset($_POST['lng']))
	{
		// try auto detection
		$acceptLanguages = explode(';', str_replace(array(' ', ','), ';', strtolower($_SERVER['HTTP_ACCEPT_LANGUAGE'])));
		$lang = 'english';
		foreach($acceptLanguages as $acceptLanguage)
			if($acceptLanguage == 'de')
			{
				$lang = 'deutsch';
				break;
			}
			else if($acceptLanguage == 'en')
			{
				$lang = 'english';
				break;
			}
	}
	else 
		$lang = isset($_GET['lng']) ? $_GET['lng'] : $_POST['lng'];
	
	// load language
	$lang_setup = array();
	$lang = ereg_replace('[^a-z]', '', $lang);
	$langFile = './' . $lang . '.lang.php';
	if(!file_exists($langFile))
	{
		$step = STEP_SELECT_LANGUAGE;
		$lang = 'deutsch';
		$langFile = './' . $lang . '.lang.php';
	}
	include($langFile);
}

/**
 * check mysql login
 *
 * @param string $host
 * @param string $user
 * @param string $pass
 * @param string $db
 * @return bool
 */
function CheckMySQLLogin($host, $user, $pass, $db)
{
	$result = false;
	
	$connection = @mysql_connect($host, $user, $pass);
	if($connection)
	{
		if(@mysql_select_db($db, $connection))
			$result = $connection;
	}
	
	return($result);
}

/**
 * check pop3 login
 *
 * @param string $host
 * @param string $user
 * @param string $pass
 * @return bool
 */
function CheckPOP3Login($host, $user, $pass)
{
	$result = false;
	
	$sock = @fsockopen($host, 110);
	if($sock)
	{
		if(($response = @fgets($sock, 255))
			&& substr($response, 0, 3) == '+OK')
		{
			@fwrite($sock, 'USER ' . $user . "\r\n");
			
			if(($response = @fgets($sock, 255))
				&& substr($response, 0, 3) == '+OK')
			{
				@fwrite($sock, 'PASS ' . $pass . "\r\n");
				
				if(($response = @fgets($sock, 255))
					&& substr($response, 0, 3) == '+OK')
				{
					$result = true;
				}
			}
		}
		
		@fwrite($sock, 'QUIT' . "\r\n");
		@fclose($sock);
	}
	
	return($result);
}

/**
 * password generator
 *
 * @return string
 */
function GeneratePW()
{
	$result = '';
	$chars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.,;-_&';
	for($i=0; $i<8; $i++)
		$result .= substr($chars, mt_rand(0, strlen($chars)-1), 1);
	return($result);
}


/**
 * synchronize DB structure against an DB structure array
 *
 * @param resource $connection
 * @param array $databaseStructure (New/correct) DB structure
 * @param bool $return Return queries?
 * @return array
 */
function SyncDBStruct($connection, $databaseStructure, $return = true)
{
	// queries to execute
	$syncQueries = array();
	
	// get tables
	$defaultTables = array();
	$res = mysql_query('SHOW TABLES', $connection);
	while($row = mysql_fetch_array($res, MYSQL_NUM))
		$myTables[] = $row[0];
	mysql_free_result($res);
		
	// compare tables
	foreach($databaseStructure as $tableName=>$tableInfo)
	{
		$tableFields = $tableInfo['fields'];
		$tableIndexes = $tableInfo['indexes'];
		
		//
		// table exists => compare fields and indexes
		//
		if(in_array($tableName, $myTables))
		{
			// get my fields
			$myFields = array();
			$res = mysql_query('SHOW FIELDS FROM ' . $tableName, $connection);
			while($row = mysql_fetch_array($res, MYSQL_ASSOC))
			{
				if($row['Null'] == '') $row['Null'] = 'NO';
				$myFields[$row['Field']] = array($row['Field'], $row['Type'], $row['Null'], $row['Key'], $row['Default'], $row['Extra']);
			}
			mysql_free_result($res);
			
			// get my indexes
			$myIndexes = array();
			$res = mysql_query('SHOW INDEX FROM ' . $tableName, $connection);
			while($row = mysql_fetch_array($res, MYSQL_ASSOC))
				if(isset($myIndexes[$row['Key_name']]))
					$myIndexes[$row['Key_name']][] = $row['Column_name'];
				else 
					$myIndexes[$row['Key_name']] = array($row['Column_name']);
			mysql_free_result($res);
			
			// compare fields
			foreach($tableFields as $field)
			{
				$op = false;
				
				if(!isset($myFields[$field[0]]))
				{
					$op = 'ADD';
				}
				else
				{
					$myField = $myFields[$field[0]];
					if($myField[1] != $field[1]
						|| $myField[2] != $field[2]
						|| ($myField[4] != $field[4] && !(($myField[4]==0 && $field[4]=='') || ($myField[4]=='' && $field[4]==0)))
						|| $myField[5] != $field[5])
					{
						$op = 'MODIFY';
					}
				}
				
				if($op !== false)
				{
					$syncQueries[] = sprintf('ALTER TABLE %s %s `%s` %s%s%s%s',
						$tableName,
						$op,
						$field[0],
						$field[1],
						$field[2] == 'NO' ? ' NOT NULL' : '',
						$field[4] == 'NULL' ? ' DEFAULT NULL' : ($field[4] != ''
							? (is_numeric($field[4]) 
									? ' DEFAULT ' . $field[4]
									: ' DEFAULT \'' . mysql_escape_string($field[4]) . '\'')
							: ''),
						$field[5] != '' ? ' ' . $field[5] : '');
				}
			}
			
			// compare indexes
			foreach($tableIndexes as $indexName=>$indexFields)
			{
				// keys
				if($indexName != 'PRIMARY')
				{
					$op = false;
					
					if(!isset($myIndexes[$indexName]))
					{
						$op = true;
					}
					else if($myIndexes[$indexName] != $indexFields)
					{
						$op = true;
						$syncQueries[] = sprintf('ALTER TABLE %s DROP KEY `%s`',
							$tableName,
							$indexName);
					}
					
					if($op)
					{
						$syncQueries[] = sprintf('ALTER TABLE %s ADD KEY `%s`(%s)',
							$tableName,
							$indexName,
							'`' . implode('`,`', $indexFields) . '`');
					}
				}
				
				// primary keys
				else 
				{
					if(!isset($myIndexes[$indexName]))
					{
						// add
						$syncQueries[] = sprintf('ALTER TABLE %s ADD PRIMARY KEY(%s)',
							$tableName,
							'`' . implode('`,`', $indexFields) . '`');
					}
					else if($myIndexes[$indexName] != $indexFields)
					{
						// drop, add
						$syncQueries[] = sprintf('ALTER TABLE %s DROP PRIMARY KEY, ADD PRIMARY KEY(%s)',
							$tableName,
							'`' . implode('`,`', $indexFields) . '`');
					}
				}
			}
		}
		
		//
		// table does not exist => create
		//
		else 
		{
			$stmt = sprintf('CREATE TABLE %s(' . "\n",
				$tableName);
			
			// fields
			foreach($tableFields as $field)
			{
				$stmt .= sprintf(' `%s` %s%s%s%s,' . "\n",
					$field[0],
					$field[1],
					$field[2] == 'NO' ? ' NOT NULL' : '',
					$field[4] == 'NULL' ? ' DEFAULT NULL' : ($field[4] != ''
						? (is_numeric($field[4]) 
								? ' DEFAULT ' . $field[4]
								: ' DEFAULT \'' . mysql_escape_string($field[4]) . '\'')
						: ''),
					$field[5] != '' ? ' ' . $field[5] : '');
			}
			
			// indexes
			foreach($tableIndexes as $indexName=>$indexFields)
			{
				if($indexName == 'PRIMARY')
					$stmt .= sprintf(' PRIMARY KEY (%s),' . "\n",
						'`' . implode('`,`', $indexFields) . '`');
				else 
					$stmt .= sprintf(' KEY `%s`(%s),' . "\n",
						$indexName,
						'`' . implode('`,`', $indexFields) . '`');
			}
			
			$stmt = substr($stmt, 0, -2) . "\n" . ')';
				
			$syncQueries[] = $stmt;
		}
	}
	
	// return
	if($return)
		return($syncQueries);
	
	// execute queries
	$result = array();
	foreach($syncQueries as $query)
		if(mysql_query($query, $connection))
			$result[$query] = true;
		else 
			$result[$query] = false;
			
	// return
	return($result);
}

/**
 * create datbase structure
 *
 * @param resource $connection
 * @param array $databaseStructure
 * @return array
 */
function CreateDatabaseStructure($connection, $databaseStructure)
{
	// queries to execute
	$syncQueries = array();
		
	// create tables
	foreach($databaseStructure as $tableName=>$tableInfo)
	{
		$tableFields = $tableInfo['fields'];
		$tableIndexes = $tableInfo['indexes'];
		
		$stmt = sprintf('CREATE TABLE %s(' . "\n",
			$tableName);
		
		// fields
		foreach($tableFields as $field)
		{
			$stmt .= sprintf(' `%s` %s%s%s%s,' . "\n",
				$field[0],
				$field[1],
				$field[2] == 'NO' ? ' NOT NULL' : '',
				$field[4] == 'NULL' ? ' DEFAULT NULL' : ($field[4] != ''
					? (is_numeric($field[4]) 
							? ' DEFAULT ' . $field[4]
							: ' DEFAULT \'' . mysql_escape_string($field[4]) . '\'')
					: ''),
				$field[5] != '' ? ' ' . $field[5] : '');
		}
		
		// indexes
		foreach($tableIndexes as $indexName=>$indexFields)
		{
			if($indexName == 'PRIMARY')
				$stmt .= sprintf(' PRIMARY KEY (%s),' . "\n",
					'`' . implode('`,`', $indexFields) . '`');
			else 
				$stmt .= sprintf(' KEY `%s`(%s),' . "\n",
					$indexName,
					'`' . implode('`,`', $indexFields) . '`');
		}
		
		$stmt = substr($stmt, 0, -2) . "\n" . ')';
			
		$syncQueries[] = $stmt;
	}
	
	// execute queries
	$result = array();
	foreach($syncQueries as $query)
		if(mysql_query($query, $connection))
			$result[$query] = true;
		else 
			$result[$query] = mysql_error($connection);
			
	// return
	return($result);
}
?>