<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: index.php,v 1.39 2009/02/18 12:38:59 patrick Exp $
 *
 */

// init
include('./common.inc.php');

//  operations per call
define('CALL_OPS',					50);

// message flags (needed while updating)
define('FLAG_UNREAD',				1);
define('FLAG_ANSWERED',				2);
define('FLAG_FORWARDED',			4);
define('FLAG_DELETED',				8);
define('FLAG_FLAGGED',				16);
define('FLAG_SEEN',					32);
define('FLAG_ATTACHMENT',			64);
define('FLAG_INFECTED',				128);
define('FLAG_SPAM',					256);
define('FLAG_CERTMAIL',				512);

// folders (needed while updating)
define('FOLDER_INBOX',				0);
define('FOLDER_OUTBOX',				-2);
define('FOLDER_DRAFTS',				-3);
define('FOLDER_SPAM',				-4);
define('FOLDER_TRASH',				-5);
define('FOLDER_ROOT',				-128);

// filter stuff (needed while updating)
define('BMOP_EQUAL',				1);
define('BMOP_NOTEQUAL',				2);
define('BMOP_CONTAINS',				3);
define('BMOP_NOTCONTAINS',			4);
define('BMOP_STARTSWITH',			5);
define('BMOP_ENDSWITH',				6);
define('MAILFIELD_SUBJECT',			1);
define('MAILFIELD_FROM',			2);
define('MAILFIELD_TO',				3);
define('MAILFIELD_CC',				4);
define('MAILFIELD_BCC',				5);
define('MAILFIELD_READ',			6);
define('MAILFIELD_ANSWERED',		7);
define('MAILFIELD_FORWARDED',		8);
define('MAILFIELD_PRIORITY',		9);
define('MAILFIELD_ATTACHMENT',		10);
define('MAILFIELD_FLAGGED',			11);
define('MAILFIELD_FOLDER',			12);
define('MAILFIELD_ATTACHLIST',		13);
define('FILTER_ACTION_MOVETO',		1);	
define('FILTER_ACTION_BLOCK',		2);
define('FILTER_ACTION_DELETE',		3);
define('FILTER_ACTION_MARKREAD',	4);
define('FILTER_ACTION_MARKSPAM',	5);
define('FILTER_ACTION_MARK',		6);
define('FILTER_ACTION_STOP',		7);

// calendar stuff (needed while updating)
define('CLNDR_WHOLE_DAY',					1);
define('CLNDR_REMIND_EMAIL',				2);
define('CLNDR_REMIND_SMS',					4);
define('CLNDR_REPEATING_UNTIL_ENDLESS',		1);
define('CLNDR_REPEATING_UNTIL_COUNT',		2);
define('CLNDR_REPEATING_UNTIL_DATE',		4);
define('CLNDR_REPEATING_DAILY',				8);
define('CLNDR_REPEATING_WEEKLY',			16);
define('CLNDR_REPEATING_MONTHLY_MDAY',		32);
define('CLNDR_REPEATING_MONTHLY_WDAY',		64);

// steps
define('STEP_SELECT_LANGUAGE',		0);
define('STEP_WELCOME',				1);
define('STEP_SYSTEMCHECK',			3);
define('STEP_INSTALLTYPE',			4);

// fresh install
define('STEP_SERIAL',				5);
define('STEP_MYSQL',				6);
define('STEP_CHECK_MYSQL',			7);
define('STEP_CHECK_EMAIL',			8);
define('STEP_INSTALL',				9);

// update
define('STEP_UPDATE_MYSQL',			105);
define('STEP_UPDATE_CHECK_MYSQL',	106);
define('STEP_UPDATE_UPDATE',		107);
define('STEP_UPDATE_STEP',			108);
define('STEP_UPDATE_DONE',			109);

// step?
if(!isset($_REQUEST['step']))
	$step = STEP_SELECT_LANGUAGE;
else 
	$step = (int)$_REQUEST['step'];
	
// read language file
ReadLanguage();

// install type
if($step == STEP_INSTALLTYPE && isset($_REQUEST['type']))
	$step = $_REQUEST['type'] == 'fresh' ? STEP_SERIAL : STEP_UPDATE_MYSQL;

// header
if($step != STEP_UPDATE_STEP)
	pageHeader();

/**
 * select language
 */
if($step == STEP_SELECT_LANGUAGE)
{
	$nextStep = STEP_WELCOME;
	?>
	<h1><?php echo($lang_setup['selectlanguage']); ?></h1>
	
	<?php echo($lang_setup['selectlanguage_text']); ?>
	
	<blockquote>
		<input type="radio" id="lang_deutsch" name="lng" value="deutsch"<?php if($lang=='deutsch') echo ' checked="checked"'; ?> />
			<label for="lang_deutsch">Deutsch</label>
		<br />
		<input type="radio" id="lang_english" name="lng" value="english"<?php if($lang=='english') echo ' checked="checked"'; ?> />
			<label for="lang_english">English</label>
	</blockquote>
	<?php 
}

/**
 * welcome / license
 */
else if($step == STEP_WELCOME)
{
	$nextStep = STEP_SYSTEMCHECK;
	?>
	<h1><?php echo($lang_setup['welcome']); ?></h1>
	
	<?php echo($lang_setup['welcome_text']); ?>
	
	<br /><br />
	<?php echo($lang_setup['license_text']); ?>
	
	<br /><br />
	<textarea id="license" readonly="readonly"><?php echo($lang_setup['license']); ?></textarea>
	
	<blockquote>
		<input type="radio" id="license_accept" name="license" value="1" onclick="document.getElementById('next_button').disabled=false;" />
			<label for="license_accept"><?php echo($lang_setup['license_accept']); ?></label>
		<br />
		<input type="radio" id="license_deny" name="license" value="0" onclick="document.getElementById('next_button').disabled=true;" />
			<label for="license_deny"><?php echo($lang_setup['license_deny']); ?></label>
	</blockquote>
	<?php 
}

/**
 * system check
 */
else if($step == STEP_SYSTEMCHECK)
{
	$nextStep = STEP_INSTALLTYPE;
	?>
	<h1><?php echo($lang_setup['syscheck']); ?></h1>
	
	<?php echo($lang_setup['syscheck_text']); ?>
	
	<br /><br />
	<table class="list">
		<tr>
			<th width="180">&nbsp;</th>
			<th><?php echo($lang_setup['required']); ?></th>
			<th><?php echo($lang_setup['available']); ?></th>
			<th width="60">&nbsp;</th>
		</tr>
		<tr>
			<th><?php echo($lang_setup['phpversion']); ?></th>
			<td>4.2.2</td>
			<td><?php echo(phpversion()); ?></td>
			<td><img src="../admin/templates/images/<?php if((int)str_replace('.', '', phpversion()) >= 422) echo 'ok'; else { echo 'error'; $nextStep = STEP_SYSTEMCHECK; } ?>.png" border="0" alt="" width="16" height="16" /></td>
		</tr>
		<tr>
			<th><?php echo($lang_setup['mysqlext']); ?></th>
			<td><?php echo($lang_setup['yes']); ?></td>
			<td><?php echo(function_exists('mysql_connect') ? $lang_setup['yes'] : $lang_setup['no']); ?></td>
			<td><img src="../admin/templates/images/<?php if(function_exists('mysql_connect')) echo 'ok'; else { echo 'error'; $nextStep = STEP_SYSTEMCHECK; } ?>.png" border="0" alt="" width="16" height="16" /></td>
		</tr>
		<?php
		foreach($writeableFiles as $file)
		{
			?>
		<tr>
			<th><?php echo($file); ?></th>
			<td><?php echo($lang_setup['writeable']); ?></td>
			<td><?php echo(is_writeable('../' . $file) ? $lang_setup['writeable'] : $lang_setup['notwriteable']); ?></td>
			<td><img src="../admin/templates/images/<?php if(is_writeable('../' . $file)) echo 'ok'; else { echo 'error'; $nextStep = STEP_SYSTEMCHECK; } ?>.png" border="0" alt="" width="16" height="16" /></td>
		</tr>
			<?php 
		}
		?>
	</table>
	
	<br />
	<?php echo($nextStep == STEP_INSTALLTYPE ? $lang_setup['checkok_text'] : $lang_setup['checkfail_text']);?>
	<?php 
}

/**
 * install type
 */
else if($step == STEP_INSTALLTYPE)
{
	$nextStep = STEP_INSTALLTYPE;
	?>
	<h1><?php echo($lang_setup['installtype']); ?></h1>
	
	<?php echo($lang_setup['installtype_text']); ?>

	<blockquote>
		<table>
			<tr>
				<td width="20" valign="top">
					<input id="fresh_install" type="radio" name="type" value="fresh" checked="checked" />
				</td>
				<td>
					<label for="fresh_install"><?php echo($lang_setup['freshinstall']); ?></label><br />
					<?php echo($lang_setup['freshinstall_text']); ?><br /><br />
				</td>
			</tr>
			<tr>
				<td width="20" valign="top">
					<input id="update_v6" type="radio" name="type" value="update" />
				</td>
				<td>
					<label for="update_v6"><?php echo($lang_setup['updatev6']); ?></label><br />
					<?php echo($lang_setup['updatev6_text']); ?>
				</td>
			</tr>
		</table>
	</blockquote>
	<?php
}

//
//
//				FRESH INSTALL
//
//

/**
 * serial number
 */
else if($step == STEP_SERIAL)
{
	$nextStep = STEP_MYSQL;
	?>
	<h1><?php echo($lang_setup['licensing']); ?></h1>
	
	<?php echo($lang_setup['licensing_text']); ?>
	
	<blockquote>
		<label for="license_nr"><?php echo($lang_setup['license_nr']); ?></label><br />
			<input id="license_nr" type="text" readonly="readonly" disabled="disabled" value="[#]GYSN_LICNR[#]" size="32" />
		<br /><br />
		<label for="serial_1"><?php echo($lang_setup['serial']); ?></label><br />
			<input id="serial_1" type="text" name="serial_1" size="5" maxlength="4" />
				-
			<input id="serial_2" type="text" name="serial_2" size="5" maxlength="4" />
				-
			<input id="serial_3" type="text" name="serial_3" size="5" maxlength="4" />
				-
			<input id="serial_4" type="text" name="serial_4" size="5" maxlength="4" />
	</blockquote>
	
	<input type="hidden" name="type" value="fresh" />
	<?php
}

/**
 * mysql login
 */
else if($step == STEP_MYSQL)
{
	$break = false;
	
	/**
	 * IMPORTANT INFORMATION ABOUT B1GMAIL LICENSING
	 * 
	 * We do know that it is easy to circumvent the following licensing checks.
	 * It is easy to remove the whole check or to write key-generators for
	 * our serial numbers.
	 * 
	 * It is that easy because we do not believe in encrypting or compiling our
	 * PHP source code because we want to give our customers as much flexibility
	 * as possible and because we want to make enhancements like hacks and plugins
	 * possible.
	 * 
	 * We trust in you to be honest and to buy a license if you use b1gMail.
	 * By doing so, you are not only ensuring the further development of b1gMail.
	 * By owning a valid license, you get many benefits, like free E-Mail support,
	 * access to the latest extensions, updates, patches and important security
	 * updates and the ability to have influence in new releases.
	 * 
	 * Thanks for your support and for making b1gMail possible!
	 * 
	 * The b1gMail team
	 */
	if(isset($_REQUEST['serial']))
		$serial = explode('-', $_REQUEST['serial']);
	else
		$serial = array(strtoupper($_REQUEST['serial_1']),
						strtoupper($_REQUEST['serial_2']),
						strtoupper($_REQUEST['serial_3']),
						strtoupper($_REQUEST['serial_4']));
	$check = strtoupper(md5($serial[1] . $serial[0] . $serial[2]));
	if(strlen(implode('-', $serial)) != 19
		|| $serial[3][0] != $check[5]
		|| $serial[3][1] != $check[23]
		|| $serial[3][2] != $check[8]
		|| $serial[3][3] != $check[31])
	{
		$nextStep = STEP_SERIAL;
		?>
		<h1><?php echo($lang_setup['licensing']); ?></h1>
		
		<?php echo($lang_setup['wrongserial']); ?>
		<?php
		$break = true;
	}
	else 
	{
		$serial = implode('-', $serial);
	}
	
	if(!$break)
	{
		$nextStep = STEP_CHECK_MYSQL;
		?>
		<h1><?php echo($lang_setup['db']); ?></h1>
		
		<?php echo($lang_setup['dbfresh_text']); ?>
		
		<blockquote>
			<label for="mysql_host"><?php echo($lang_setup['mysql_host']); ?></label><br />
				<input id="mysql_host" name="mysql_host" type="text" value="" size="32" />
			<br /><br />
			<label for="mysql_user"><?php echo($lang_setup['mysql_user']); ?></label><br />
				<input id="mysql_user" name="mysql_user" type="text" value="" size="32" />
			<br /><br />
			<label for="mysql_pass"><?php echo($lang_setup['mysql_pass']); ?></label><br />
				<input id="mysql_pass" name="mysql_pass" type="text" value="" size="32" />
			<br /><br />
			<label for="mysql_db"><?php echo($lang_setup['mysql_db']); ?></label><br />
				<input id="mysql_db" name="mysql_db" type="text" value="" size="32" />
		</blockquote>
		
		<input type="hidden" name="serial" value="<?php echo($serial); ?>" />
		<?php 
	}
}

/**
 * check mysql login
 */
else if($step == STEP_CHECK_MYSQL)
{
	if($connection = CheckMySQLLogin($_REQUEST['mysql_host'], $_REQUEST['mysql_user'], $_REQUEST['mysql_pass'],
						$_REQUEST['mysql_db']))
	{
		// b1gMail already installed here?
		$b1gMailInDB = false;
		$res = mysql_query('SHOW TABLES');
		while($row = mysql_fetch_array($res, MYSQL_NUM))
			if($row[0] == 'bm60_prefs')
			{
				$b1gMailInDB = true;
				break;
			}
		mysql_free_result($res);
		mysql_close($connection);
		
		if($b1gMailInDB)
		{
			$nextStep = STEP_MYSQL;
			?>
			<h1><?php echo($lang_setup['db']); ?></h1>
				
			<?php echo($lang_setup['dbexists_text']); ?>
			<?php 
		}
		else 
		{
			$nextStep = STEP_CHECK_EMAIL;
			?>
			<h1><?php echo($lang_setup['emailcfg']); ?></h1>
			
			<?php echo($lang_setup['emailcfg_text']); ?>
			
			<br /><br />
			<fieldset>
				<legend><?php echo($lang_setup['receiving']); ?></legend>
				
				<input type="radio" id="receive_method_pop3" name="receive_method" value="pop3" checked="checked" />
				<label for="receive_method_pop3"><?php echo($lang_setup['pop3gateway']); ?></label>
				<blockquote>
					<label for="pop3_host"><?php echo($lang_setup['pop3_host']); ?></label><br />
						<input id="pop3_host" name="pop3_host" type="text" value="" size="32" />
					<br /><br />
					<label for="pop3_user"><?php echo($lang_setup['pop3_user']); ?></label><br />
						<input id="pop3_user" name="pop3_user" type="text" value="" size="32" />
					<br /><br />
					<label for="pop3_pass"><?php echo($lang_setup['pop3_pass']); ?></label><br />
						<input id="pop3_pass" name="pop3_pass" type="text" value="" size="32" />
				</blockquote>
				
				<input type="radio" id="receive_method_pipe" name="receive_method" value="pipe" />
				<label for="receive_method_pipe"><?php echo($lang_setup['pipe']); ?></label>
			</fieldset>
			
			<br />
			<fieldset>
				<legend><?php echo($lang_setup['sending']); ?></legend>
				
				<input type="radio" id="send_method_phpmail" name="send_method" value="php" checked="checked" />
				<label for="send_method_phpmail"><?php echo($lang_setup['phpmail']); ?></label><br />
				
				<input type="radio" id="send_method_smtp" name="send_method" value="smtp" />
				<label for="send_method_smtp"><?php echo($lang_setup['smtp']); ?></label>
				<blockquote>
					<label for="smtp_host"><?php echo($lang_setup['smtp_host']); ?></label><br />
						<input id="smtp_host" name="smtp_host" type="text" value="localhost" size="32" />
				</blockquote>
				
				<input type="radio" id="send_method_sendmail" name="send_method" value="sendmail" />
				<label for="send_method_sendmail"><?php echo($lang_setup['sendmail']); ?></label>
				<blockquote>
					<label for="sendmail_path"><?php echo($lang_setup['sendmail_path']); ?></label><br />
						<input id="sendmail_path" name="sendmail_path" type="text" value="/usr/sbin/sendmail" size="32" />
				</blockquote>
			</fieldset>
			
			<input type="hidden" name="mysql_host" value="<?php echo(htmlentities($_REQUEST['mysql_host'])); ?>" />
			<input type="hidden" name="mysql_user" value="<?php echo(htmlentities($_REQUEST['mysql_user'])); ?>" />
			<input type="hidden" name="mysql_pass" value="<?php echo(htmlentities($_REQUEST['mysql_pass'])); ?>" />
			<input type="hidden" name="mysql_db" value="<?php echo(htmlentities($_REQUEST['mysql_db'])); ?>" />
			<?php 
		}
	}
	else 
	{
		$nextStep = STEP_MYSQL;
		?>
		<h1><?php echo($lang_setup['db']); ?></h1>
			
		<?php echo($lang_setup['dbfail_text']); ?>
		<?php 
	}
	
	?>
	<input type="hidden" name="serial" value="<?php echo($_REQUEST['serial']); ?>" />
	<?php 
}

/**
 * check email config
 */
else if($step == STEP_CHECK_EMAIL)
{
	if($_REQUEST['receive_method'] != 'pop3'
		|| CheckPOP3Login($_REQUEST['pop3_host'], $_REQUEST['pop3_user'], $_REQUEST['pop3_pass']))
	{
		if($_REQUEST['send_method'] != 'sendmail'
			|| (file_exists($_REQUEST['sendmail_path']) && is_executable($_REQUEST['sendmail_path'])))
		{
			$nextStep = STEP_INSTALL;
			?>
			<h1><?php echo($lang_setup['misc']); ?></h1>
				
			<?php echo($lang_setup['misc_text']); ?>
			
			<blockquote>
				<label for="adminpw"><?php echo($lang_setup['adminpw']); ?></label><br />
					<input id="adminpw" name="adminpw" type="text" value="<?php echo(GeneratePW()); ?>" size="32" />
				<br /><br />
				<label for="domains"><?php echo($lang_setup['domains']); ?></label><br />
					<textarea id="domains" name="domains" style="width:220px;height:80px;">example.com
example.net
example.org</textarea>
				<br /><br />
				<label for="url"><?php echo($lang_setup['url']); ?></label><br />
					<input id="url" name="url" type="text" value="http://<?php echo($_SERVER['HTTP_HOST'] . ereg_replace('\/setup\/index\.php(.*)', '/', $_SERVER['REQUEST_URI'])); ?>" size="32" />
			</blockquote>
			
			<input type="hidden" name="receive_method" value="<?php echo(htmlentities($_REQUEST['receive_method'])); ?>" />
			<input type="hidden" name="send_method" value="<?php echo(htmlentities($_REQUEST['send_method'])); ?>" />
			<input type="hidden" name="pop3_host" value="<?php echo(htmlentities($_REQUEST['pop3_host'])); ?>" />
			<input type="hidden" name="pop3_user" value="<?php echo(htmlentities($_REQUEST['pop3_user'])); ?>" />
			<input type="hidden" name="pop3_pass" value="<?php echo(htmlentities($_REQUEST['pop3_pass'])); ?>" />
			<input type="hidden" name="smtp_host" value="<?php echo(htmlentities($_REQUEST['smtp_host'])); ?>" />
			<input type="hidden" name="sendmail_path" value="<?php echo(htmlentities($_REQUEST['sendmail_path'])); ?>" />
			<?php
		}
		else 
		{
			$nextStep = STEP_CHECK_MYSQL;
			?>
			<h1><?php echo($lang_setup['emailcfg']); ?></h1>
				
			<?php echo($lang_setup['emailcfgsmfail_text']); ?>
			<?php 
		}
	}
	else 
	{
		$nextStep = STEP_CHECK_MYSQL;
		?>
		<h1><?php echo($lang_setup['emailcfg']); ?></h1>
			
		<?php echo($lang_setup['emailcfgpop3fail_text']); ?>
		<?php 
	}
	
	?>
	<input type="hidden" name="mysql_host" value="<?php echo(htmlentities($_REQUEST['mysql_host'])); ?>" />
	<input type="hidden" name="mysql_user" value="<?php echo(htmlentities($_REQUEST['mysql_user'])); ?>" />
	<input type="hidden" name="mysql_pass" value="<?php echo(htmlentities($_REQUEST['mysql_pass'])); ?>" />
	<input type="hidden" name="mysql_db" value="<?php echo(htmlentities($_REQUEST['mysql_db'])); ?>" />
	<input type="hidden" name="serial" value="<?php echo($_REQUEST['serial']); ?>" />
	<?php 
}

/**
 * install!
 */
else if($step == STEP_INSTALL)
{
	include('../serverlib/database.struct.php');
	include('./data/example.data.php');
	include('./data/rootcerts.data.php');
	
	// prepare structure
	$databaseStructure = unserialize(base64_decode($databaseStructure));
	
	// sanitize input
	if(substr($_REQUEST['url'], -1) != '/')
		$_REQUEST['url'] .= '/';
	$domains = explode("\n", str_replace(array("\r", '@', ',', ';', ':', ' '), '', $_REQUEST['domains']));
	foreach($domains as $key=>$val)
	{
		$val = trim($val);
		if(strlen($val) < 2)
			unset($domains[$key]);
		else 
			$domains[$key] = $val;
	}
	$domains = count($domains) > 0 ? implode(':', $domains) : 'example.com';
	list($firstDomain) = explode(':', $domains);
	
	// start installation log
	ob_start();
	
	// status
	$dbStructResult 	= 'error';
	$defaultConfigResut	= 'error';
	$defaultGroupResut 	= 'error';
	$exampleDataResult 	= 'error';
	$postmasterResut 	= 'error';
	$configResult 		= 'error';
	
	// install
	$connection = mysql_connect($_REQUEST['mysql_host'], $_REQUEST['mysql_user'], $_REQUEST['mysql_pass'], $_REQUEST['mysql_db']);
	if($connection)
	{
		if(mysql_select_db($_REQUEST['mysql_db']))
		{
			// create db structure
			$dbStructResult = 'ok';
			$result = CreateDatabaseStructure($connection, $databaseStructure);
			foreach($result as $query=>$queryResult)
				if($queryResult !== true)
				{
					$dbStructResult = 'warning';
					echo 'Failed to execute structure query: ' . $queryResult . "\n";
				}
			
			// create default config
			$hostName = @gethostbyname($_SERVER['SERVER_ADDR']);
			if(!$hostName || trim($hostName) == '' || $hostName == $_SERVER['SERVER_ADDR'])
				$hostName = $_SERVER['HTTP_HOST'];
    		$dataFolder = ereg_replace('\/setup\/index\.php(.*)', '/data/', str_replace('\\', '/', $_SERVER['SCRIPT_FILENAME']));
			$prefsQuery = sprintf('INSERT INTO bm60_prefs(language,serial,domains,adminpw,selfurl,send_method,smtp_host,sendmail_path,receive_method,pop3_host,pop3_user,pop3_pass,passmail_abs,titel,datafolder,b1gmta_host,dnsbl,smsreply_abs,widget_order_start,widget_order_organizer,structstorage,search_in) '
							. 'VALUES(\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\',\'%s\')',
							$_REQUEST['lng'] == 'deutsch' ? 'deutsch' : 'english',
							mysql_escape_string($_REQUEST['serial']),
							mysql_escape_string($domains),
							mysql_escape_string($_REQUEST['adminpw']),
							mysql_escape_string($_REQUEST['url']),
							mysql_escape_string($_REQUEST['send_method']),
							mysql_escape_string($_REQUEST['smtp_host']),
							mysql_escape_string($_REQUEST['sendmail_path']),
							mysql_escape_string($_REQUEST['receive_method']),
							mysql_escape_string($_REQUEST['pop3_host']),
							mysql_escape_string($_REQUEST['pop3_user']),
							mysql_escape_string($_REQUEST['pop3_pass']),
							mysql_escape_string('"Postmaster ' . $firstDomain . '" <postmaster@' . $firstDomain . '>'),
							mysql_escape_string($firstDomain . ' Mail'),
							mysql_escape_string($dataFolder),
							$hostName,
							'ex.dnsbl.org:dnsbl.njabl.org',
							mysql_escape_string('postmaster@' . $firstDomain),
							'BMPlugin_Widget_Welcome,BMPlugin_Widget_EMail,BMPlugin_Widget_Websearch;BMPlugin_Widget_Mailspace,,BMPlugin_Widget_Quicklinks;BMPlugin_Widget_Webdiskspace,,',
							'BMPlugin_Widget_Websearch,BMPlugin_Widget_Calendar,BMPlugin_Widget_Notes;,BMPlugin_Widget_Tasks,',
							!ini_get('safe_mode') ? 'yes' : 'no',
							mysql_escape_string('a:7:{s:5:"mails";s:2:"on";s:3:"sms";s:2:"on";s:8:"calendar";s:2:"on";s:5:"tasks";s:2:"on";s:11:"addressbook";s:2:"on";s:5:"notes";s:2:"on";s:7:"webdisk";s:2:"on";}'));
			if(mysql_query($prefsQuery))
				$defaultConfigResut = 'ok';
			else 
			{
				echo 'Failed to create default config: ' . mysql_error($connection) .  "\n";
			}
			
			// create default group
			$groupQuery = sprintf('INSERT INTO bm60_gruppen(id,titel) VALUES(1,\'%s\')',
				mysql_escape_string($lang_setup['defaultgroup']));
			if(mysql_query($groupQuery))
				$defaultGroupResut = 'ok';
			else 
			{
				echo 'Failed to create default group: ' . mysql_error($connection) .  "\n";
			}
			
			// create postmaster
			$postmasterQuery = sprintf('INSERT INTO bm60_users(id,email,vorname,nachname,passwort,gruppe) '
								. 'VALUES(1,\'%s\',\'%s\',\'%s\',\'%s\',1)',
								mysql_escape_string('postmaster@' . $firstDomain),
								'Postmaster',
								mysql_escape_string($firstDomain),
								md5($_REQUEST['adminpw']));
			if(mysql_query($postmasterQuery))
				$postmasterResut = 'ok';
			else 
			{
				echo 'Failed to create postmaster: ' . mysql_error($connection) .  "\n";
			}
			
			// create postmaster aliases
			$domainArray = explode(':', $domains);
			foreach($domainArray as $domain)
				if($domain != $firstDomain)
				{
					$aliasQuery = sprintf('INSERT INTO bm60_aliase(email,user) VALUES(\'%s\',1)',
						mysql_escape_string('postmaster@' . $domain));
					mysql_query($aliasQuery);
				}
		
			// install default data
			$exampleDataResult = 'ok';
			foreach($exampleData as $query)
				if(!mysql_query($query))
				{
					echo 'Failed to execute example data query: ' . mysql_error($connection) . "\n";
					$exampleDataResult = 'warning';
				}
				
			// install default root certs
			foreach($rootCertsData as $query)
				if(!mysql_query($query))
				{
					echo 'Failed to execute root cert insert query: ' . mysql_error($connection) . "\n";
					$exampleDataResult = 'warning';
				}
			
			// create config file
			$configFile = sprintf("<?php\n// Generated %s\n\$mysql = array(\n\t'host'\t\t=> '%s',\n\t'user'\t\t=> '%s',\n\t'pass'\t\t=> '%s',\n\t'db'\t\t=> '%s',\n\t'prefix'\t=> '%s'\n);\n?>",
				date('r'),
				addslashes($_REQUEST['mysql_host']),
				addslashes($_REQUEST['mysql_user']),
				addslashes($_REQUEST['mysql_pass']),
				addslashes($_REQUEST['mysql_db']),
				'bm60_');
			$fp = fopen('../serverlib/config.inc.php', 'w');
			if($fp)
			{
				fwrite($fp, $configFile);
				fclose($fp);
				
				$configResult = 'ok';
			}
			else 
				echo 'Failed to open config.inc.php for writing' . "\n";
		}
		else
			echo 'MySQL database selection failed' . "\n";
	}
	else 
		echo 'MySQL connection failed' . "\n";
	
	// finish installation log
	$installLog = trim(strip_tags(ob_get_contents()));
	ob_end_clean();
	?>
	<h1><?php echo($lang_setup['installing']); ?></h1>
	
	<?php echo($lang_setup['installing_text']); ?>
	
	<br /><br />
	<table class="list">
		<tr>
			<th><?php echo(sprintf($lang_setup['inst_dbstruct'], $databaseStructureVersion)); ?></th>
			<td><img src="../admin/templates/images/<?php echo($dbStructResult); ?>.png" border="0" alt="" width="16" height="16" /></td>
		</tr>
		<tr>
			<th><?php echo($lang_setup['inst_defaultcfg']); ?></th>
			<td><img src="../admin/templates/images/<?php echo($defaultConfigResut); ?>.png" border="0" alt="" width="16" height="16" /></td>
		</tr>
		<tr>
			<th><?php echo($lang_setup['inst_defaultgroup']); ?></th>
			<td><img src="../admin/templates/images/<?php echo($defaultGroupResut); ?>.png" border="0" alt="" width="16" height="16" /></td>
		</tr>
		<tr>
			<th><?php echo($lang_setup['inst_postmaster']); ?></th>
			<td><img src="../admin/templates/images/<?php echo($postmasterResut); ?>.png" border="0" alt="" width="16" height="16" /></td>
		</tr>
		<tr>
			<th><?php echo($lang_setup['inst_exdata']); ?></th>
			<td><img src="../admin/templates/images/<?php echo($exampleDataResult); ?>.png" border="0" alt="" width="16" height="16" /></td>
		</tr>
		<tr>
			<th><?php echo($lang_setup['inst_config']); ?></th>
			<td><img src="../admin/templates/images/<?php echo($configResult); ?>.png" border="0" alt="" width="16" height="16" /></td>
		</tr>
	</table>
	<br />
	
	<?php
	if($installLog != '')
	{
		echo $lang_setup['log_text'];
		?>
		<textarea readonly="readonly" class="installLog"><?php echo(htmlentities($installLog)); ?></textarea>
		<br /><br />
		<?php 
	}
	
	echo $lang_setup['finished_text'];
	?>
	<blockquote>
		<b><?php echo($lang_setup['userlogin']); ?></b><br />
		<a target="_blank" href="<?php echo($_REQUEST['url']); ?>"><?php echo($_REQUEST['url']); ?></a><br /><br />
		
		<b><?php echo($lang_setup['adminlogin']); ?></b><br />
		<a target="_blank" href="<?php echo($_REQUEST['url']); ?>admin/"><?php echo($_REQUEST['url']); ?>admin/</a><br /><br />
		
		<b><?php echo($lang_setup['adminpw']); ?></b><br />
		<?php echo(htmlentities($_REQUEST['adminpw'])); ?>
	</blockquote>
	<?php 
}

//
//
//				UPDATE
//
//

/**
 * mysql
 */
else if($step == STEP_UPDATE_MYSQL)
{
	$nextStep = STEP_UPDATE_CHECK_MYSQL;
	
	?>
	<h1><?php echo($lang_setup['db']); ?></h1>
	
	<?php echo($lang_setup['dbupdate_text']); ?>
	
	<blockquote>
		<label for="mysql_host"><?php echo($lang_setup['mysql_host']); ?></label><br />
			<input id="mysql_host" name="mysql_host" type="text" value="" size="32" />
		<br /><br />
		<label for="mysql_user"><?php echo($lang_setup['mysql_user']); ?></label><br />
			<input id="mysql_user" name="mysql_user" type="text" value="" size="32" />
		<br /><br />
		<label for="mysql_pass"><?php echo($lang_setup['mysql_pass']); ?></label><br />
			<input id="mysql_pass" name="mysql_pass" type="text" value="" size="32" />
		<br /><br />
		<label for="mysql_db"><?php echo($lang_setup['mysql_db']); ?></label><br />
			<input id="mysql_db" name="mysql_db" type="text" value="" size="32" />
	</blockquote>
	<?php 
}

/**
 * check mysql
 */
else if($step == STEP_UPDATE_CHECK_MYSQL)
{
	if($connection = CheckMySQLLogin($_REQUEST['mysql_host'], $_REQUEST['mysql_user'], $_REQUEST['mysql_pass'],
						$_REQUEST['mysql_db']))
	{
		// b1gMail already installed here?
		$b1gMailInDB = false;
		$res = mysql_query('SHOW TABLES');
		while($row = mysql_fetch_array($res, MYSQL_NUM))
			if($row[0] == 'bm60_prefs')
			{
				$b1gMailInDB = true;
				break;
			}
		mysql_free_result($res);
		
		// b1gMail 6.3.1?
		if($b1gMailInDB)
		{
			// check for imap + webdav fields
			$imapField = $webdavField = false;
			$res = mysql_query('SHOW FIELDS FROM bm60_gruppen');
			while($row = mysql_fetch_array($res, MYSQL_NUM))
				if($row[0] == 'imap')
					$imapField = true;
				else if($row[0] == 'webdav')
					$webdavField = true;
			mysql_free_result($res);
			
			// imap field indicates b1gMail >= 6.3.0, webdav field indicates b1gMail >= 7.0.0
			if(!$imapField || $webdavField)
				$b1gMailInDB = false;
		}
		
		mysql_close($connection);
		
		if(!$b1gMailInDB)
		{
			$nextStep = STEP_MYSQL;
			?>
			<h1><?php echo($lang_setup['db']); ?></h1>
				
			<?php echo($lang_setup['dbnotexists_text']); ?>
			<?php 
		}
		else 
		{
			$nextStep = STEP_UPDATE_UPDATE;
			?>
			<h1><?php echo($lang_setup['update']); ?></h1>
			
			<?php echo($lang_setup['update_text']); ?>
			<br />
			
			<ul>
				<li><?php echo($lang_setup['update_note1']); ?><br /><br /></li>
				<li><?php echo($lang_setup['update_note2']); ?><br /><br /></li>
				<li><?php echo($lang_setup['update_note3']); ?><br /><br /></li>
				<li><?php echo($lang_setup['update_note4']); ?><br /><br /></li>
				<li><?php echo($lang_setup['update_note5']); ?><br /></li>
			</ul>
			
			<?php echo($lang_setup['update_text2']); ?>
			
			<input type="hidden" name="mysql_host" value="<?php echo(htmlentities($_REQUEST['mysql_host'])); ?>" />
			<input type="hidden" name="mysql_user" value="<?php echo(htmlentities($_REQUEST['mysql_user'])); ?>" />
			<input type="hidden" name="mysql_pass" value="<?php echo(htmlentities($_REQUEST['mysql_pass'])); ?>" />
			<input type="hidden" name="mysql_db" value="<?php echo(htmlentities($_REQUEST['mysql_db'])); ?>" />
	
			<?php 
		}
	}
	else 
	{
		$nextStep = STEP_UPDATE_MYSQL;
		?>
		<h1><?php echo($lang_setup['db']); ?></h1>
			
		<?php echo($lang_setup['dbfail_text']); ?>
		<?php 
	}
}

/**
 * update client script
 */
else if($step == STEP_UPDATE_UPDATE)
{
	?>
	<h1><?php echo($lang_setup['updating']); ?></h1>
	
	<?php echo($lang_setup['updating_text']); ?>
	
	<br /><br />
	<table class="list">
		<tr>
			<th width="40"></th>
			<th><?php echo($lang_setup['step']); ?></th>
			<th width="180"><?php echo($lang_setup['progress']); ?></th>
		</tr>
		<tr>
			<td id="step_prepare_status">&nbsp;</td>
			<th id="step_prepare_text" style="font-weight:normal;">1. <?php echo($lang_setup['update_prepare']); ?></th>
			<td id="step_prepare_progress">&nbsp;</td>
		</tr>
		<tr>
			<td id="step_struct1_status">&nbsp;</td>
			<th id="step_struct1_text" style="font-weight:normal;">2. <?php echo($lang_setup['update_struct1']); ?></th>
			<td id="step_struct1_progress">&nbsp;</td>
		</tr>
		<tr>
			<td id="step_mails_status">&nbsp;</td>
			<th id="step_mails_text" style="font-weight:normal;">3. <?php echo($lang_setup['update_mails']); ?></th>
			<td id="step_mails_progress">&nbsp;</td>
		</tr>
		<tr>
			<td id="step_folders_status">&nbsp;</td>
			<th id="step_folders_text" style="font-weight:normal;">4. <?php echo($lang_setup['update_folders']); ?></th>
			<td id="step_folders_progress">&nbsp;</td>
		</tr>
		<tr>
			<td id="step_autoresponders_status">&nbsp;</td>
			<th id="step_autoresponders_text" style="font-weight:normal;">5. <?php echo($lang_setup['update_autoresponders']); ?></th>
			<td id="step_autoresponders_progress">&nbsp;</td>
		</tr>
		<tr>
			<td id="step_filters_status">&nbsp;</td>
			<th id="step_filters_text" style="font-weight:normal;">6. <?php echo($lang_setup['update_filters']); ?></th>
			<td id="step_filters_progress">&nbsp;</td>
		</tr>
		<tr>
			<td id="step_calendar_status">&nbsp;</td>
			<th id="step_calendar_text" style="font-weight:normal;">7. <?php echo($lang_setup['update_calendar']); ?></th>
			<td id="step_calendar_progress">&nbsp;</td>
		</tr>
		<tr>
			<td id="step_struct2_status">&nbsp;</td>
			<th id="step_struct2_text" style="font-weight:normal;">8. <?php echo($lang_setup['update_struct2']); ?></th>
			<td id="step_struct2_progress">&nbsp;</td>
		</tr>
		<tr>
			<td id="step_config_status">&nbsp;</td>
			<th id="step_config_text" style="font-weight:normal;">9. <?php echo($lang_setup['update_config']); ?></th>
			<td id="step_config_progress">&nbsp;</td>
		</tr>
		<tr>
			<td id="step_struct3_status">&nbsp;</td>
			<th id="step_struct3_text" style="font-weight:normal;">10. <?php echo($lang_setup['update_struct3']); ?></th>
			<td id="step_struct3_progress">&nbsp;</td>
		</tr>
		<tr>
			<td id="step_optimize_status">&nbsp;</td>
			<th id="step_optimize_text" style="font-weight:normal;">11. <?php echo($lang_setup['update_optimize']); ?></th>
			<td id="step_optimize_progress">&nbsp;</td>
		</tr>
	</table>
	
	<br />
	<?php echo($lang_setup['updating_text2']); ?>
	
	<textarea readonly="readonly" class="installLog" id="log" style="display:none;height:150px;"></textarea>
	<br /><br />
	
	<div align="center" id="done" style="display:none;">
		<b><?php echo($lang_setup['updatedone']); ?></b>
	</div>
	
	<script language="javascript" src="./res/update.js"></script>
	<script language="javascript">
	<!--
		args = '<?php printf('lng=%s&mysql_host=%s&mysql_user=%s&mysql_pass=%s&mysql_db=%s', urlencode($_REQUEST['lng']), urlencode($_REQUEST['mysql_host']), urlencode($_REQUEST['mysql_user']), urlencode($_REQUEST['mysql_pass']), urlencode($_REQUEST['mysql_db'])); ?>';
		window.onload = beginUpdate;
	//-->
	</script>
	
	<?php
	$nextStep = STEP_UPDATE_DONE;
}

/**
 * update worker
 */
else if($step == STEP_UPDATE_STEP)
{
	$do = $_REQUEST['do'];
	$pos = isset($_REQUEST['pos']) ? (int)$_REQUEST['pos'] : 0;
	
	$connection = mysql_connect($_REQUEST['mysql_host'], $_REQUEST['mysql_user'], $_REQUEST['mysql_pass']);
	if(!$connection)
		die('ERROR:MySQL connection failed.');
	if(!mysql_select_db($_REQUEST['mysql_db'], $connection))
		die('ERROR:MySQL database selection failed.');	
	
	//
	// preparation
	//
	if($do == 'prepare')
	{
		mysql_query('UPDATE bm60_prefs SET wartung=\'yes\'', $connection);
		echo 'OK:DONE';
	}
	
	//
	// structure preparation
	//
	else if($do == 'struct1')
	{
		$queries = array(
			'ALTER TABLE bm60_mails ADD userid int(11) NOT NULL DEFAULT 0',
			'ALTER TABLE bm60_mails ADD flags int(11) NOT NULL DEFAULT 0', 
			'ALTER TABLE bm60_mails ADD flags int(11) NOT NULL DEFAULT 0', 
			'ALTER TABLE bm60_folders ADD userid int(11) NOT NULL DEFAULT 0',
			'ALTER TABLE bm60_autoresponder ADD userid int(11) NOT NULL DEFAULT 0',
			'ALTER TABLE bm60_filter ADD userid int(11) NOT NULL DEFAULT 0',
			'ALTER TABLE bm60_filter ADD title varchar(128) NOT NULL DEFAULT \'\'',
			'DROP TABLE bm60_spamindex',
			'ALTER TABLE bm60_uidindex DROP id',
			'DROP TABLE bm60_mods',
			"CREATE TABLE bm60_filter_conditions (
  `id` int(11) NOT NULL auto_increment,
  `filter` int(11) NOT NULL default '0',
  `field` tinyint(4) NOT NULL,
  `op` tinyint(4) NOT NULL default '0',
  `val` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `filter` (`filter`)
)",
			"CREATE TABLE bm60_filter_actions (
  `id` int(11) NOT NULL auto_increment,
  `filter` int(11) NOT NULL default '0',
  `op` tinyint(4) NOT NULL,
  `val` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
)",
			"CREATE TABLE bm60_dates (
  `id` int(11) NOT NULL auto_increment,
  `user` int(11) NOT NULL,
  `title` varchar(128) NOT NULL default '',
  `location` varchar(128) NOT NULL default '',
  `text` text NOT NULL,
  `group` int(11) NOT NULL default '-1',
  `startdate` int(11) NOT NULL,
  `enddate` int(11) NOT NULL,
  `reminder` int(11) NOT NULL default '300',
  `flags` tinyint(4) NOT NULL default '0',
  `repeat_flags` tinyint(4) NOT NULL default '0',
  `repeat_times` int(11) NOT NULL,
  `repeat_value` int(11) NOT NULL,
  `repeat_extra1` varchar(16) NOT NULL default '',
  `repeat_extra2` tinyint(4) NOT NULL default '0',
  `last_reminder` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `user` (`user`)
)"
		);
		
		$count = count($queries);
		
		// done?
		if($pos >= $count)
			echo 'OK:DONE';
		else 
		{
			$query = $queries[$pos++];
			
			mysql_query($query, $connection);
			
			if($pos >= $count)
				echo 'OK:DONE';
			else
				echo 'OK:' . $pos . '/' . $count;
		}
	}
	
	//
	// mail meta/flag refresh
	//
	else if($do == 'mails')
	{
		// get mail count
		$res = mysql_query('SELECT COUNT(*) FROM bm60_mails', $connection);
		list($count) = mysql_fetch_array($res, MYSQL_NUM);
		mysql_free_result($res);
		
		// done?
		if($pos >= $count)
			echo 'OK:DONE';
		else 
		{
			$res = mysql_query('SELECT id,user,fetched,datum,gelesen,beantwortet,weitergeleitet,trashed,attach,is_infected,is_spam,typ,folder FROM bm60_mails ORDER BY id ASC LIMIT ' . $pos . ', ' . CALL_OPS, $connection);
			while($row = mysql_fetch_array($res, MYSQL_ASSOC))
			{
				// generate flags
				$flags = 0;
				if($row['gelesen'] == 'no')
					$flags |= FLAG_UNREAD;
				if($row['beantwortet'] == 'yes')
					$flags |= FLAG_ANSWERED;
				if($row['weitergeleitet'] == 'yes')
					$flags |= FLAG_FORWARDED;
				if($row['trashed'] == 'yes')
					$flags |= FLAG_DELETED;
				if($row['attach'] == 'yes')
					$flags |= FLAG_ATTACHMENT;
				if($row['is_infected'] == 1)
					$flags |= FLAG_INFECTED;
				if($row['is_spam'] == 1)
					$flags |= FLAG_SPAM;
			
				// determine folder id
				$folder = 0;
				if($row['trashed'] == 'yes')
					$folder = FOLDER_TRASH;
				else if($row['typ'] == 'out')
					$folder = FOLDER_OUTBOX;
				else if($row['folder'] == FOLDER_SPAM)
					$folder = FOLDER_SPAM;
				else if($row['folder'] == FOLDER_DRAFTS)
					$folder = FOLDER_DRAFTS;
				else if($row['folder'] == 0)
					$folder = FOLDER_INBOX;
				else 
					$folder = $row['folder'];
					
				// date?
				$date = @strtotime($row['datum']);
				if($date <= 0)
					$date = $row['fetched'] > 0
								? $row['fetched']
								: time();
								
				// user id
				$user = 0;
				$res2 = mysql_query(sprintf('SELECT id FROM bm60_users WHERE email=\'%s\' LIMIT 1',
					mysql_escape_string($row['user'])), $connection);
				if(mysql_num_rows($res2) == 1)
					list($user) = mysql_fetch_array($res2, MYSQL_NUM);
				mysql_free_result($res2);
				
				// update
				mysql_query(sprintf('UPDATE bm60_mails SET userid=\'%d\',flags=\'%d\',folder=\'%d\',datum=\'%d\',fetched=\'%d\' WHERE id=\'%d\'',
					$user,
					$flags,
					$folder,
					$date,
					$row['fetched'] > 0 ? $row['fetched'] : $date,
					$row['id']), $connection);
				$pos++;
			}
			mysql_free_result($res);
			
			if($pos >= $count)
				echo 'OK:DONE';
			else
				echo 'OK:' . $pos . '/' . $count;
		}
	}
	
	//
	// folders
	//
	else if($do == 'folders')
	{
		// get count
		$res = mysql_query('SELECT COUNT(*) FROM bm60_folders', $connection);
		list($count) = mysql_fetch_array($res, MYSQL_NUM);
		mysql_free_result($res);
		
		// done?
		if($pos >= $count)
			echo 'OK:DONE';
		else 
		{
			$res = mysql_query('SELECT id,user FROM bm60_folders ORDER BY id ASC LIMIT ' . $pos . ', ' . CALL_OPS, $connection);
			while($row = mysql_fetch_array($res, MYSQL_ASSOC))
			{
				// user id
				$user = 0;
				$res2 = mysql_query(sprintf('SELECT id FROM bm60_users WHERE email=\'%s\' LIMIT 1',
					mysql_escape_string($row['user'])), $connection);
				if(mysql_num_rows($res2) == 1)
					list($user) = mysql_fetch_array($res2, MYSQL_NUM);
				mysql_free_result($res2);
				
				// update
				mysql_query(sprintf('UPDATE bm60_folders SET userid=\'%d\' WHERE id=\'%d\'',
					$user,
					$row['id']), $connection);
				$pos++;
			}
			mysql_free_result($res);
			
			if($pos >= $count)
				echo 'OK:DONE';
			else
				echo 'OK:' . $pos . '/' . $count;
		}
	}
	
	//
	// autoresponders
	//
	else if($do == 'autoresponders')
	{
		// get count
		$res = mysql_query('SELECT COUNT(*) FROM bm60_autoresponder', $connection);
		list($count) = mysql_fetch_array($res, MYSQL_NUM);
		mysql_free_result($res);
		
		// done?
		if($pos >= $count)
			echo 'OK:DONE';
		else 
		{
			$res = mysql_query('SELECT id,user FROM bm60_autoresponder ORDER BY id ASC LIMIT ' . $pos . ', ' . CALL_OPS, $connection);
			while($row = mysql_fetch_array($res, MYSQL_ASSOC))
			{
				// user id
				$user = 0;
				$res2 = mysql_query(sprintf('SELECT id FROM bm60_users WHERE email=\'%s\' LIMIT 1',
					mysql_escape_string($row['user'])), $connection);
				if(mysql_num_rows($res2) == 1)
					list($user) = mysql_fetch_array($res2, MYSQL_NUM);
				mysql_free_result($res2);
				
				// update
				mysql_query(sprintf('UPDATE bm60_autoresponder SET userid=\'%d\' WHERE id=\'%d\'',
					$user,
					$row['id']), $connection);
				$pos++;
			}
			mysql_free_result($res);
			
			if($pos >= $count)
				echo 'OK:DONE';
			else
				echo 'OK:' . $pos . '/' . $count;
		}
	}
	
	//
	// filters
	//
	else if($do == 'filters')
	{
		// get count
		$res = mysql_query('SELECT COUNT(*) FROM bm60_filter', $connection);
		list($count) = mysql_fetch_array($res, MYSQL_NUM);
		mysql_free_result($res);
		
		// done?
		if($pos >= $count)
			echo 'OK:DONE';
		else 
		{
			$res = mysql_query('SELECT id,user,aktion,folder,rule,rule_type FROM bm60_filter ORDER BY id ASC LIMIT ' . $pos . ', ' . CALL_OPS, $connection);
			while($row = mysql_fetch_array($res, MYSQL_ASSOC))
			{
				// condition
				if($row['rule_type'] == 'to')
					$condField = MAILFIELD_TO;
				else if($row['rule_type'] == 'from')
					$condField = MAILFIELD_FROM;
				else
					$condField = MAILFIELD_SUBJECT;
				mysql_query(sprintf('INSERT INTO bm60_filter_conditions(filter,field,op,val) VALUES(\'%d\',\'%d\',\'%d\',\'%s\')',
					$row['id'],
					$condField,
					BMOP_CONTAINS,
					mysql_escape_string(str_replace(array('*', '(.*)'), '', $row['rule']))), $connection);
				
				// action
				$actVal = max(0, $row['folder']);
				if($row['aktion'] == 'block')
					$actOp = FILTER_ACTION_BLOCK;
				else if($row['aktion'] == 'folder')
					$actOp = FILTER_ACTION_MOVETO;
				else if($row['aktion'] == 'trash')
				{
					$actOp = FILTER_ACTION_MOVETO;
					$actVal = FOLDER_TRASH;
				}
				mysql_query(sprintf('INSERT INTO bm60_filter_actions(filter,op,val) VALUES(\'%d\',\'%d\',\'%d\')',
					$row['id'],
					$actOp,
					$actVal), $connection);
				
				// user id
				$user = 0;
				$res2 = mysql_query(sprintf('SELECT id FROM bm60_users WHERE email=\'%s\' LIMIT 1',
					mysql_escape_string($row['user'])), $connection);
				if(mysql_num_rows($res2) == 1)
					list($user) = mysql_fetch_array($res2, MYSQL_NUM);
				mysql_free_result($res2);
				
				// update
				mysql_query(sprintf('UPDATE bm60_filter SET userid=\'%d\',title=\'%s\' WHERE id=\'%d\'',
					$user,
					mysql_escape_string($row['rule']),
					$row['id']), $connection);
				$pos++;
			}
			mysql_free_result($res);
			
			if($pos >= $count)
				echo 'OK:DONE';
			else
				echo 'OK:' . $pos . '/' . $count;
		}
	}
	
	//
	// calendar
	//
	else if($do == 'calendar')
	{
		// get count
		$res = mysql_query('SELECT COUNT(*) FROM bm60_calendar', $connection);
		list($count) = mysql_fetch_array($res, MYSQL_NUM);
		mysql_free_result($res);
		
		// done?
		if($pos >= $count)
			echo 'OK:DONE';
		else 
		{
			$res = mysql_query('SELECT id,user,type,value,start,end,duration,allday,title,message,webremind,smsremind,smssent,websent FROM bm60_calendar ORDER BY id ASC LIMIT ' . $pos . ', ' . CALL_OPS, $connection);
			while($row = mysql_fetch_array($res, MYSQL_ASSOC))
			{
				$pos++;
				
				$endDate = $reminder = $flags = $repeatFlags = $repeatTimes = $repeatValue
						 = $repeatExtra1 = $repeatExtra2 = $lastReminder = 0;
				
				// start date valid?
				$startDate = $row['start'];
				if($startDate <= 0)
					continue;
				
				// whole day?
				if($row['duration'] == 0 || $row['allday'] == 1)
				{
					$endDate = $row['start'] + 59;
					$flags |= CLNDR_WHOLE_DAY;
				}
				else 
				{
					$endDate = max($row['start'] + 59, $row['start'] + $row['duration']);
				}
				
				// repeating?
				if($row['type'][0] == '2' && $row['type'][2] != 'a')
				{
					// never ending?
					if($row['end'] == 2147483647)
					{
						$repeatFlags |= CLNDR_REPEATING_UNTIL_ENDLESS;
					}
					
					// ending at some day
					else
					{
						$repeatFlags |= CLNDR_REPEATING_UNTIL_DATE;
						$repeatTimes = max($row['start']+60, $row['end']);
					}
					
					// daily?
					if($row['type'][2] == 'b')
					{
						$value = explode(';', $row['value']);
						if(count($value) != 2)
							continue;
						
						$days = explode(':', $value[1]);
						$exceptions = array();
						foreach($days as $day)
							if($day == 0)
								$exceptions[] = $day;
						
						$repeatFlags	|= CLNDR_REPEATING_DAILY;
						$repeatValue	= max(1, $value[0]);
						$repeatExtra1	= count($exceptions) > 0
											? implode(',', $exceptions)
											: '';
					}
					
					// weekly
					else if($row['type'][2] == 'c')
					{
						$repeatFlags	|= CLNDR_REPEATING_WEEKLY;
						$repeatValue	= max(1, $row['value']);
					}
					
					// monthly
					else if($row['type'][2] == 'd')
					{
						$value = explode(';', $row['value']);
						if(count($value) != 3)
							continue;
						
						// monthly_mday
						if($value[2] == 0)
						{
							$repeatFlags	|= CLNDR_REPEATING_MONTHLY_MDAY;
							$repeatValue	= max(1, $value[0]);
							$repeatExtra1	= max(1, min(31, $value[1]));
						}
						
						// monthly_wday
						else 
						{
							$repeatFlags	|= CLNDR_REPEATING_MONTHLY_WDAY;
							$repeatValue	= max(1, $value[0]);
							$repeatExtra1	= max(0, min(4, $value[2]-1));
							$repeatExtra2	= max(0, min(6, $value[1]));
						}
					}
				}
				else 
				{
					// no, or minutely/hourly, which is not supported anymore
					$repeatFlags = 0;
				}
				
				// reminder?
				if($row['smsremind'] > 0)
				{
					$flags |= CLNDR_REMIND_SMS;
					$reminder = $row['smsremind'];
				}
				if($row['webremind'] > 0)
				{
					$flags |= CLNDR_REMIND_EMAIL;
					if($reminder == 0 || $row['webremind'] < $reminder)
						$reminder = $row['webremind'];
				}
				$reminder *= 60;
				
				// last reminder
				$lastReminder = max($row['smssent'], $row['websent']);
				
				// insert
				mysql_query(sprintf('INSERT INTO bm60_dates(user,title,`text`,startdate,enddate,reminder,flags,repeat_flags,repeat_times,repeat_value,repeat_extra1,repeat_extra2,last_reminder) '
						. 'VALUES(\'%d\',\'%s\',\'%s\',\'%d\',\'%d\',\'%d\',\'%d\',\'%d\',\'%d\',\'%d\',\'%s\',\'%d\',\'%d\')',
						$row['user'],
						mysql_escape_string($row['title']),
						mysql_escape_string($row['message']),
						$startDate,
						$endDate,
						$reminder,
						$flags,
						$repeatFlags,
						$repeatTimes,
						$repeatValue,
						$repeatExtra1,
						$repeatExtra2,
						$lastReminder), $connection);
			}
			mysql_free_result($res);
			
			if($pos >= $count)
				echo 'OK:DONE';
			else
				echo 'OK:' . $pos . '/' . $count;
		}
	}
	
	//
	// db structure sync
	//
	else if($do == 'struct2')
	{
		include('../serverlib/database.struct.php');
		
		$databaseStructure = unserialize(base64_decode($databaseStructure));
		$queries = SyncDBStruct($connection, $databaseStructure, true);
		
		if(count($queries) == 0)
		{
			echo 'OK:DONE';
		}
		else 
		{
			$done = true;
			foreach($queries as $query)
				if(mysql_query($query, $connection))
				{
					$done = false;
					break;
				}
				
			if($done)
				echo 'OK:DONE';
			else		
				echo 'OK:' . (++$pos) . '/'  . count($queries);
		}
	}
	
	//
	// update config
	//
	else if($do == 'config')
	{
		// get old config
		$res = mysql_query('SELECT * FROM bm60_prefs LIMIT 1', $connection);
		$old_prefs = mysql_fetch_array($res, MYSQL_ASSOC);
		mysql_free_result($res);
		
		// transfer TOS
		$agb = @unserialize($old_prefs['agb']);
		if(!$agb || !is_array($agb))
			$agb = array($_REQUEST['lng'] == 'deutsch' ? 'deutsch' : 'english' => $old_prefs['agb']);
		foreach($agb as $lang=>$val)
			mysql_query(sprintf('REPLACE INTO bm60_texts(language,`key`,`text`) VALUES(\'%s\',\'%s\',\'%s\')',
				mysql_escape_string($lang),
				'tos',
				mysql_escape_string($val)), $connection);
		
		// collect texts
		$customTexts = array(
			'passmail_sub'		=> $old_prefs['passmail_sub'],
			'passmail_text'		=> $old_prefs['passmail_text'],
			'imprint'			=> nl2br($old_prefs['impressum']),
			'certmail'			=> $old_prefs['einsch_mail'],
			'mail2sms'			=> $old_prefs['mail2sms'],
			'cs_subject'		=> $old_prefs['einsch_seen_subject'],
			'cs_text'			=> $old_prefs['einsch_seen_text'],
			'clndr_subject'		=> $old_prefs['calendar_subject'],
			'clndr_date_msg'	=> $old_prefs['calendar_date_message'],
			'clndr_sms'			=> $old_prefs['calendar_sms'],
			'receipt_text'		=> $old_prefs['receiptmail']
		);
		
		// transfer texts
		foreach($customTexts as $key=>$val)
			mysql_query(sprintf('REPLACE INTO bm60_texts(language,`key`,`text`) VALUES(\'%s\',\'%s\',\'%s\')',
				$_REQUEST['lng'] == 'deutsch' ? 'deutsch' : 'english',
				mysql_escape_string($key),
				mysql_escape_string($val)), $connection);
			
		// mail sender
		$passmailAbs = explode(':', $old_prefs['passmail_abs']);
		if(count($passmailAbs) == 2)
			$passmailAbs = sprintf('"%s" <%s>', $passmailAbs[0], $passmailAbs[1]);
		else 
			$passmailAbs = $passmailAbs[0];
				
		// misc
		mysql_query('UPDATE bm60_users SET spamaction=-4 WHERE spamaction=-1', $connection);
		mysql_query('UPDATE bm60_pop3 SET p_target=-1 WHERE p_target=0', $connection);
		mysql_query(sprintf('UPDATE bm60_prefs SET patchlevel=0,bayes_spam=0,bayes_nonspam=0,language=\'%s\',template=\'%s\',widget_order_start=\'%s\',widget_order_organizer=\'%s\',structstorage=\'%s\',search_in=\'%s\',passmail_abs=\'%s\'',
			$_REQUEST['lng'] == 'deutsch' ? 'deutsch' : 'english',
			'default',
			'BMPlugin_Widget_Welcome,BMPlugin_Widget_EMail,BMPlugin_Widget_Websearch;BMPlugin_Widget_Mailspace,,BMPlugin_Widget_Quicklinks;BMPlugin_Widget_Webdiskspace,,',
			'BMPlugin_Widget_Websearch,BMPlugin_Widget_Calendar,BMPlugin_Widget_Notes;,BMPlugin_Widget_Tasks,',
			!ini_get('safe_mode') ? 'yes' : 'no',
			mysql_escape_string('a:7:{s:5:"mails";s:2:"on";s:3:"sms";s:2:"on";s:8:"calendar";s:2:"on";s:5:"tasks";s:2:"on";s:11:"addressbook";s:2:"on";s:5:"notes";s:2:"on";s:7:"webdisk";s:2:"on";}'),
			mysql_escape_string($passmailAbs)), $connection);
		
		// plugins
		$modQueries = array();
		$modQueries[] = 'INSERT INTO bm60_mods(`modname`,`installed`,`pos`,`packageName`,`signature`,`files`) VALUES(\'B1GMailSearchProvider\',\'1\',\'0\',\'\',\'\',\'\')';
		$modQueries[] = 'INSERT INTO bm60_mods(`modname`,`installed`,`pos`,`packageName`,`signature`,`files`) VALUES(\'BMPlugin_Widget_Notes\',\'1\',\'0\',\'\',\'\',\'\')';
		$modQueries[] = 'INSERT INTO bm60_mods(`modname`,`installed`,`pos`,`packageName`,`signature`,`files`) VALUES(\'BMPlugin_Widget_WebdiskDND\',\'1\',\'0\',\'\',\'\',\'\')';
		$modQueries[] = 'INSERT INTO bm60_mods(`modname`,`installed`,`pos`,`packageName`,`signature`,`files`) VALUES(\'BMPlugin_Widget_Mailspace\',\'1\',\'0\',\'\',\'\',\'\')';
		$modQueries[] = 'INSERT INTO bm60_mods(`modname`,`installed`,`pos`,`packageName`,`signature`,`files`) VALUES(\'BMPlugin_Widget_Quicklinks\',\'1\',\'0\',\'\',\'\',\'\')';
		$modQueries[] = 'INSERT INTO bm60_mods(`modname`,`installed`,`pos`,`packageName`,`signature`,`files`) VALUES(\'BMPlugin_Widget_Calendar\',\'1\',\'0\',\'\',\'\',\'\')';
		$modQueries[] = 'INSERT INTO bm60_mods(`modname`,`installed`,`pos`,`packageName`,`signature`,`files`) VALUES(\'BMPlugin_Widget_Tasks\',\'1\',\'0\',\'\',\'\',\'\')';
		$modQueries[] = 'INSERT INTO bm60_mods(`modname`,`installed`,`pos`,`packageName`,`signature`,`files`) VALUES(\'BMPlugin_Widget_Welcome\',\'1\',\'0\',\'\',\'\',\'\')';
		$modQueries[] = 'INSERT INTO bm60_mods(`modname`,`installed`,`pos`,`packageName`,`signature`,`files`) VALUES(\'BMPlugin_Widget_EMail\',\'1\',\'0\',\'\',\'\',\'\')';
		$modQueries[] = 'INSERT INTO bm60_mods(`modname`,`installed`,`pos`,`packageName`,`signature`,`files`) VALUES(\'BMPlugin_Widget_Webdiskspace\',\'1\',\'0\',\'\',\'\',\'\')';
		$modQueries[] = 'INSERT INTO bm60_mods(`modname`,`installed`,`pos`,`packageName`,`signature`,`files`) VALUES(\'BMPlugin_Widget_Websearch\',\'1\',\'0\',\'\',\'\',\'\')';
		foreach($modQueries as $query)
			mysql_query($query, $connection);
		
		// config file
		$configFile = sprintf("<?php\n// Generated %s\n\$mysql = array(\n\t'host'\t\t=> '%s',\n\t'user'\t\t=> '%s',\n\t'pass'\t\t=> '%s',\n\t'db'\t\t=> '%s',\n\t'prefix'\t=> '%s'\n);\n?>",
			date('r'),
			addslashes($_REQUEST['mysql_host']),
			addslashes($_REQUEST['mysql_user']),
			addslashes($_REQUEST['mysql_pass']),
			addslashes($_REQUEST['mysql_db']),
			'bm60_');
		$fp = fopen('../serverlib/config.inc.php', 'w');
		if($fp)
		{
			fwrite($fp, $configFile);
			fclose($fp);
		}
				
		echo 'OK:DONE';
	}
	
	//
	// optimize and clean up
	//
	else if($do == 'struct3')
	{
		$queries = array(
			'ALTER TABLE bm60_mails DROP user, DROP bcc, DROP gelesen, DROP beantwortet, DROP weitergeleitet, DROP trashed, DROP typ, DROP attach, DROP dele_mark, DROP is_spam, DROP is_infected',
			'ALTER TABLE bm60_autoresponder DROP user',
			'ALTER TABLE bm60_folders DROP user',
			'ALTER TABLE bm60_ads DROP hits, DROP sponsor',
			'ALTER TABLE bm60_filter DROP user, DROP aktion, DROP folder, DROP rule, DROP rule_type',
			'ALTER TABLE bm60_prefs DROP storage, DROP maxsize, DROP signatur, DROP agb, DROP passmail_sub, DROP passmail_text, DROP compresspages, DROP adminlink, DROP impressum, DROP betrefflaenge, DROP sesslife, DROP einsch_mail, DROP badchar, DROP sms_sig, DROP mail2sms, DROP code_einheit, DROP einsch_seen_subject, DROP einsch_seen_text, DROP calendar_subject, DROP calendar_date_message, DROP calendar_sms, DROP calendar_error_subject, DROP calendar_error_message, DROP receiptmail, DROP max_spamscore, DROP noueber, DROP ipsperre, DROP cgiurl, DROP cgilock, DROP coretype, DROP corelocation',
			'ALTER TABLE bm60_users DROP katalog, DROP ueberwachung, DROP ueber_start, DROP ueber_ende, DROP ueber_ref',
			'ALTER TABLE bm60_adressen DROP INDEX email_3',
			'ALTER TABLE bm60_adressen DROP INDEX email_4',
			'ALTER TABLE bm60_mails DROP INDEX msg_id_1',
			'ALTER TABLE bm60_mails DROP INDEX folder',
			'ALTER TABLE bm60_uidindex DROP INDEX pop3',
			'ALTER TABLE bm60_uidindex DROP INDEX pop3_2',
			'DROP TABLE bm60_calendar',
			'DROP TABLE bm60_einschreiben',
			'DROP TABLE bm60_entwuerfe',
			'DROP TABLE bm60_badwords',
			'DROP TABLE bm60_queue',
			'DROP TABLE bm60_sessions',
			'DROP TABLE bm60_sms_status',
			'DROP TABLE bm60_words'
		);
		
		$count = count($queries);
		
		// done?
		if($pos >= $count)
			echo 'OK:DONE';
		else 
		{
			$query = $queries[$pos++];
			
			mysql_query($query, $connection);
			
			if($pos >= $count)
				echo 'OK:DONE';
			else
				echo 'OK:' . $pos . '/' . $count;
		}
	}
	
	//
	// optimize tables
	//
	else if($do == 'optimize')
	{
		// get tables
		$tables = array();
		$res = mysql_query('SHOW TABLES', $connection);
		while($row = mysql_fetch_array($res, MYSQL_NUM))
			if(substr($row[0], 0, 5) == 'bm60_')
				$tables[] = $row[0];
		mysql_free_result($res);
		$count = count($tables);
		
		// done?
		if($pos >= $count)
			echo 'OK:DONE';
		else 
		{
			$table = $tables[$pos++];
			mysql_query('OPTIMIZE TABLE ' . $table, $connection);
			
			if($pos >= $count)
				echo 'OK:DONE';
			else
				echo 'OK:' . $pos . '/' . $count;
		}
	}
	
	//
	// unknown action
	//
	else 
	{
		echo 'ERROR:Unknown action.';
	}
	
	mysql_close($connection);
	
	exit();
}

/**
 * update done
 */
else if($step == STEP_UPDATE_DONE)
{
	?>
	<h1><?php echo($lang_setup['update']); ?></h1>
	
	<?php echo($lang_setup['updatesteps_text']); ?>
	
	<br />
	
	<ol>
		<li><?php echo($lang_setup['update_step1']); ?><br /><br /></li>
		<li><?php echo($lang_setup['update_step2']); ?><br /><br /></li>
		<li><?php echo($lang_setup['update_step3']); ?>
			<ol>
				<li><?php echo($lang_setup['update_step3a']); ?></li>
				<li><?php echo($lang_setup['update_step3b']); ?><br /><br /></li>
			</ol></li>
		<li><?php echo($lang_setup['update_step4']); ?><br /></li>
	</ol>
	<?php 
}

// footer
pageFooter();
?>