<?php 
/*
 * b1gMail7
 * (c) 2002-2006 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: start.php,v 1.16 2008/12/09 19:15:34 patrick Exp $
 *
 */

include('./serverlib/init.inc.php');
include('./serverlib/dashboard.class.php');
RequestPrivileges(PRIVILEGES_USER);

/**
 * file handler for modules
 */
ModuleFunction('FileHandler',
	array(substr(__FILE__, strlen(dirname(__FILE__))+1),
	isset($_REQUEST['action']) ? $_REQUEST['action'] : ''));

/**
 * default action = start
 */
if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'start';
$tpl->assign('activeTab', 'start');
$tpl->assign('pageTitle', $lang_user['start']);

/**
 * page sidebar
 */
$tpl->assign('pageMenuFile', 'li/start.sidebar.tpl');

/**
 * dashboard
 */
$dashboard = _new('BMDashboard', array(BMWIDGET_START));

/**
 * start page
 */
if($_REQUEST['action'] == 'start')
{
	$widgetOrder = $thisUser->GetPref('widgetOrderStart');
	if($widgetOrder === false || trim($widgetOrder) == '')
		$widgetOrder = $bm_prefs['widget_order_start'];
	
	$tpl->assign('pageTitle', $lang_user['welcome']);
	$tpl->assign('widgetOrder', $widgetOrder);
	$tpl->assign('widgets', $dashboard->getWidgetArray($widgetOrder));
	$tpl->assign('pageContent', 'li/start.page.tpl');
	$tpl->display('li/index.tpl');
}

/**
 * save widget order
 */
else if($_REQUEST['action'] == 'saveWidgetOrder'
			&& isset($_REQUEST['order']))
{
	$widgetOrder = $_REQUEST['order'];
	
	if($dashboard->checkWidgetOrder($widgetOrder))			
	{
		$thisUser->SetPref('widgetOrderStart', $widgetOrder);
		die('OK');
	}
	else 
	{
		die('Invalid order');
	}
}

/**
 * customize widgets
 */
else if($_REQUEST['action'] == 'customize')
{
	$widgetOrder = $thisUser->GetPref('widgetOrderStart');
	if($widgetOrder === false || trim($widgetOrder) == '')
		$widgetOrder = $bm_prefs['widget_order_start'];
		
	$tpl->assign('pageTitle', $lang_user['customize']);
	$tpl->assign('possibleWidgets', $dashboard->getPossibleWidgets($widgetOrder));
	$tpl->assign('pageContent', 'li/start.customize.tpl');
	$tpl->display('li/index.tpl');	
}

/**
 * save cutomization
 */
else if($_REQUEST['action'] == 'saveCustomize')
{
	$widgetOrder = $thisUser->GetPref('widgetOrderStart');
	if($widgetOrder === false || trim($widgetOrder) == '')
		$widgetOrder = $bm_prefs['widget_order_start'];
	$newOrder = $dashboard->generateOrderStringFromPostForm($widgetOrder);
	
	$thisUser->SetPref('widgetOrderStart', $newOrder);
	
	header('Location: start.php?sid=' . session_id());
	exit();
}

/**
 * search
 */
else if($_REQUEST['action'] == 'search'
		&& isset($_REQUEST['q']))
{
	$url = sprintf($bm_prefs['search_engine'], urlencode($_REQUEST['q']));
	header('Location: ' . $url);
	exit();
}

/**
 * user search
 */
else if($_REQUEST['action'] == 'userSearch'
		&& isset($_REQUEST['q'])
		&& strlen(trim($_REQUEST['q'])) > 2)
{
	// search
	$resultPieces = $plugins->callFunction('OnSearch', false, true, array($_REQUEST['q']));
	
	// merge results
	$resultCount = 0;
	$results = array();
	foreach($resultPieces as $resultPiece)
	{
		foreach($resultPiece as $subPiece)
			$resultCount += count($subPiece['results']);
		$results = array_merge($results, $resultPiece);
	}
	
	// limit to aprox. 25 results
	if($resultCount > MAX_SEARCH_RESULTS)
	{
		$factor = MAX_SEARCH_RESULTS / $resultCount;
		foreach($results as $key=>$val)
			$results[$key]['results'] = array_slice($val['results'], 0, ceil($factor*count($val['results'])));
	}
	
	// show results
	$tpl->assign('results', $results);
	$tpl->display('li/search.results.tpl');
}

/**
 * logout
 */
else if($_REQUEST['action'] == 'logout')
{
	BMUser::Logout();
	header('Location: ' . $bm_prefs['logouturl']);
	exit();
}
?>