<?php 
/*
 * b1gMail7
 * (c) 2002-2008 B1G Software
 * 
 * Redistribution of this code without explicit permission
 * is forbidden!
 *
 * $Id: webdisk.php,v 1.20 2008/12/19 13:24:47 patrick Exp $
 *
 */

include('./serverlib/init.inc.php');
include('./serverlib/webdisk.class.php');
include('./serverlib/zip.class.php');
RequestPrivileges(PRIVILEGES_USER);

/**
 * file handler for modules
 */
ModuleFunction('FileHandler',
	array(substr(__FILE__, strlen(dirname(__FILE__))+1),
	isset($_REQUEST['action']) ? $_REQUEST['action'] : ''));

/**
 * default action = start
 */
if(!isset($_REQUEST['action']))
	$_REQUEST['action'] = 'folder';
$tpl->assign('activeTab', 'webdisk');
$tpl->assign('pageTitle', $lang_user['webdisk']);

/**
 * webdisk interface
 */
$webdisk 		= _new('BMWebdisk', array($userRow['id']));
$folderID 		= !isset($_REQUEST['folder']) ? 0 : (int)$_REQUEST['folder'];
$folderPath 	= $webdisk->GetFolderPath($folderID);
$spaceLimit 	= $webdisk->GetSpaceLimit();
$usedSpace 		= $webdisk->GetUsedSpace();
$tpl->assign('pageMenuFile', 	'li/webdisk.sidebar.tpl');
$tpl->assign('pageToolbarFile', 'li/webdisk.toolbar.tpl');
$tpl->assign('viewMode', 		($viewMode = $thisUser->GetPref('webdiskViewMode')) === false ? 'icons' : $viewMode);
$tpl->assign('spaceUsed', 		$usedSpace);
$tpl->assign('trafficUsed', 	$userRow['traffic_down'] + $userRow['traffic_up']);
$tpl->assign('clipboard', 		isset($_SESSION['clipboard']) && is_array($_SESSION['clipboard']) && count($_SESSION['clipboard']) == 1);
$tpl->assign('spaceLimit', 		$spaceLimit);
$tpl->assign('trafficLimit', 	$groupRow['traffic']);
$tpl->assign('folderID', 		$folderID);
$tpl->assign('currentPath', 	$folderPath);
$tpl->assign('userAgent',		$_SERVER['HTTP_USER_AGENT']);
$tpl->assign('dndKey',			isset($_COOKIE['sessionSecret_' . session_id()]) ? $_COOKIE['sessionSecret_' . session_id()] : '');
$tpl->assign('allowShare',		$groupRow['share'] == 'yes');

/**
 * folder view
 */
if($_REQUEST['action'] == 'folder')
{
	if(isset($_REQUEST['massAction']))
	{
		$folderIDs 	= isset($_REQUEST['folders']) && is_array($_REQUEST['folders']) ? $_REQUEST['folders'] : array();
		$fileIDs	= isset($_REQUEST['files']) && is_array($_REQUEST['files']) ? $_REQUEST['files'] : array();
		
		if($_REQUEST['massAction'] == 'delete')
		{
			foreach($folderIDs as $theFolderID)
				$webdisk->DeleteFolder((int)$theFolderID);
			foreach($fileIDs as $theFileID)
				$webdisk->DeleteFile((int)$theFileID);
		}
		
		else if($_REQUEST['massAction'] == 'download'
			&& (count($folderIDs) > 0 || count($fileIDs) > 0))
		{
			$tempFileID = RequestTempFile($userRow['id'], time()+TIME_ONE_HOUR);
			$tempFileName = TempFileName($tempFileID);
			
			// create ZIP file
			$fp = fopen($tempFileName, 'wb+');
			$zip = _new('BMZIP', array($fp));
			foreach($folderIDs as $theFolderID)
				$webdisk->ZipFolder((int)$theFolderID, $zip);
			foreach($fileIDs as $theFileID)
				$webdisk->ZipFile((int)$theFileID, $zip);
			$size = $zip->Finish();
			
			// check traffic
			if($groupRow['traffic'] <= 0 || ($userRow['traffic_down']+$userRow['traffic_up']+$size) <= $groupRow['traffic'])
			{
				// ok
				$speedLimit = $groupRow['wd_member_kbs'] <= 0 ? -1 : $groupRow['wd_member_kbs'];
				$db->Query('UPDATE {pre}users SET traffic_down=traffic_down+? WHERE id=?',
					$size,
					$userRow['id']);
					
				// send file
				header('Pragma: public');
				header('Content-Disposition: attachment; filename="webdisk-files.zip"');
				header('Content-Type: application/zip');
				header(sprintf('Content-Length: %d',
					$size));
				Add2Stat('wd_down', ceil($size/1024));
				SendFileFP($fp, $speedLimit);
				
				// clean up
				fclose($fp);
				ReleaseTempFile($userRow['id'], $tempFileID);
				exit();
			}
			else 
			{
				// not enough traffic
				$tpl->assign('msg', $lang_user['notraffic'] . '.');
			}
			
			$tpl->assign('pageContent', 'li/error.tpl');
			$tpl->display('li/index.tpl');
			exit();
		}
	}
	
	// upload mode?
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'uploadFilesForm')
	{
		$count = min(max(isset($_REQUEST['fileCount']) ? (int)$_REQUEST['fileCount'] : 5, 0), 50);
		$tpl->assign('upload', $count);
	}
	
	// change view mode?
	if(isset($_REQUEST['do']) && $_REQUEST['do'] == 'changeViewMode'
		&& isset($_REQUEST['viewmode']))
	{
		$newMode = in_array($_REQUEST['viewmode'], array('icons', 'list'))
					? $_REQUEST['viewmode']
					: 'icons';
		$thisUser->SetPref('webdiskViewMode', $newMode);
		$tpl->assign('viewMode', $newMode);
	}
	
	$titlePath = '/';
	foreach($folderPath as $folderBit)
		$titlePath .= $folderBit['title'] . '/';
	
	$folderInfo 	= $webdisk->GetFolderInfo($folderID);
	$folderContent 	= $webdisk->GetFolderContent($folderID);
	
	$tpl->assign('shareURL', sprintf('%sshare/?user=%s', $bm_prefs['selfurl'], $userRow['email']));
	$tpl->assign('isShared', $folderInfo['share'] == 'yes');
	$tpl->assign('pageTitle', $titlePath);
	$tpl->assign('folderContent', $folderContent);
	$tpl->assign('pageContent', 'li/webdisk.folder.tpl');
	$tpl->display('li/index.tpl');
}

/**
 * download file
 */
else if($_REQUEST['action'] == 'downloadFile'
		&& isset($_REQUEST['id']))
{
	$fileInfo = $webdisk->GetFileInfo((int)$_REQUEST['id']);
	if($fileInfo !== false)
	{
		if($groupRow['traffic'] <= 0 || ($userRow['traffic_down']+$userRow['traffic_up']+$fileInfo['size']) <= $groupRow['traffic'])
		{
			// ok
			$speedLimit = $groupRow['wd_member_kbs'] <= 0 ? -1 : $groupRow['wd_member_kbs'];
			$db->Query('UPDATE {pre}users SET traffic_down=traffic_down+? WHERE id=?',
				$fileInfo['size'],
				$userRow['id']);
			
			// send file
			header('Pragma: public');
			header('Content-Type: ' . $fileInfo['contenttype']);
			header('Content-Length: ' . $fileInfo['size']);
			header('Content-Disposition: ' . (isset($_REQUEST['view']) ? 'inline' : 'attachment') . '; filename="' . addslashes($fileInfo['dateiname']) . '"');
			Add2Stat('wd_down', ceil($fileInfo['size']/1024));
			SendFile(DataFilename($fileInfo['id'], 'dsk'), $speedLimit);
			exit();
		}
		else 
		{
			// not enough traffic
			$tpl->assign('msg', $lang_user['notraffic'] . '.');
		}
	}
	
	$tpl->assign('pageContent', 'li/error.tpl');
	$tpl->display('li/index.tpl');
}

/**
 * create folder
 */
else if($_REQUEST['action'] == 'createFolder' && isset($_REQUEST['folderName']))
{
	$folderName = trim($_REQUEST['folderName']);
	
	if($webdisk->FolderExists($folderID, $folderName) || strlen($folderName) == 0)
	{
		$tpl->assign('msg', $lang_user['foldererror']);
		$tpl->assign('pageContent', 'li/error.tpl');
		$tpl->display('li/index.tpl');
	}
	else 
	{
		$webdisk->CreateFolder($folderID, $folderName);
		header('Location: webdisk.php?folder=' . $folderID . '&sid=' . session_id());
	}
}

/**
 * folder share settings
 */
else if($_REQUEST['action'] == 'shareFolder' && isset($_REQUEST['id']) && $groupRow['share'] == 'yes')
{
	$folderInfo = $webdisk->GetFolderInfo((int)$_REQUEST['id']);
	if($folderInfo !== false)
	{
		$tpl->assign('pageTitle',		$lang_user['sharing']);
		$tpl->assign('id', 				$folderInfo['id']);
		$tpl->assign('folderName', 		$folderInfo['titel']);
		$tpl->assign('folderShared', 	$folderInfo['share'] == 'yes');
		$tpl->assign('folderPW', 		$folderInfo['share_pw']);
		$tpl->assign('pageContent', 	'li/webdisk.share.tpl');
		$tpl->display('li/index.tpl');
	}
}

/**
 * save share settings
 */
else if($_REQUEST['action'] == 'saveShareSettings' && isset($_REQUEST['id']) && $groupRow['share'] == 'yes')
{
	$webdisk->SetShareSettings((int)$_REQUEST['id'], isset($_REQUEST['shareFolder']), $_REQUEST['sharePW']);
	header('Location: webdisk.php?folder=' . $folderID . '&sid=' . session_id());
}

/**
 * rename file/folder
 */
else if($_REQUEST['action'] == 'renameItem'
		&& isset($_REQUEST['type'])
		&& isset($_REQUEST['id'])
		&& isset($_REQUEST['name']))
{
	$newName = trim($_REQUEST['name']);
	
	if($_REQUEST['type'] == WEBDISK_ITEM_FILE)
	{
		$fileInfo = $webdisk->GetFileInfo((int)$_REQUEST['id']);
		if($fileInfo !== false)
		{
			if($newName == $fileInfo['dateiname']
				|| strlen($newName) < 1
				|| $webdisk->FileExists($folderID, $newName))
				die($fileInfo['dateiname']);
			die($webdisk->RenameFile((int)$_REQUEST['id'], $newName) ? $newName : $fileInfo['dateiname']);
		}
	}
	else if($_REQUEST['type'] == WEBDISK_ITEM_FOLDER)
	{
		$folderInfo = $webdisk->GetFolderInfo((int)$_REQUEST['id']);
		if($folderInfo !== false)
		{
			if($newName == $folderInfo['titel']
				|| strlen($newName) < 1
				|| $webdisk->FolderExists($folderID, $newName))
				die($folderInfo['titel']);
			die($webdisk->RenameFolder((int)$_REQUEST['id'], $newName) ? $newName : $folderInfo['titel']);
		}
	}
}

/**
 * delete file
 */
else if($_REQUEST['action'] == 'deleteItem'
		&& isset($_REQUEST['type'])
		&& isset($_REQUEST['id']))
{
	if($_REQUEST['type'] == WEBDISK_ITEM_FILE)
	{
		$webdisk->DeleteFile((int)$_REQUEST['id']);
	}
	else 
	{
		$webdisk->DeleteFolder((int)$_REQUEST['id']);
	}
	header('Location: webdisk.php?folder=' . $folderID . '&sid=' . session_id());
}

/**
 * clipboard copy/cut
 */
else if($_REQUEST['action'] == 'clipboardAction'
		&& isset($_REQUEST['do'])
		&& in_array($_REQUEST['do'], array('cut', 'copy'))
		&& isset($_REQUEST['type'])
		&& isset($_REQUEST['id']))
{
	$_SESSION['clipboard'] = array(
		0 => array('do' => $_REQUEST['do'], 'type' => (int)$_REQUEST['type'], 'id' => (int)$_REQUEST['id'])
	);
	die('Ok');
}

/**
 * clipboard paste
 */
else if($_REQUEST['action'] == 'pasteHere')
{
	$ok = false;
	
	foreach($_SESSION['clipboard'] as $key=>$clipboardItem)
	{
		// cut
		if($clipboardItem['do'] == 'cut')
		{
			// file
			if($clipboardItem['type'] == WEBDISK_ITEM_FILE)
			{
				$fileInfo = $webdisk->GetFileInfo($clipboardItem['id']);
				if($webdisk->FileExists($folderID, $fileInfo['dateiname']))
				{
					// exists
					$tpl->assign('msg', $lang_user['fileexists'] . '.');
				}
				else 
				{
					// ok!
					$webdisk->MoveFile($folderID, $clipboardItem['id']);
					unset($_SESSION['clipboard'][$key]);
					$ok = true;
				}
			}
			
			// folder
			else if($clipboardItem['type'] == WEBDISK_ITEM_FOLDER)
			{
				$folderInfo = $webdisk->GetFolderInfo($clipboardItem['id']);
				if($webdisk->FolderExists($folderID, $folderInfo['titel']))
				{
					// exists
					$tpl->assign('msg', $lang_user['foldererror']);
				}
				else 
				{
					// ok!
					$webdisk->MoveFolder($folderID, $clipboardItem['id']);
					unset($_SESSION['clipboard'][$key]);
					$ok = true;
				}		
			}
		}
		
		// copy
		else if($clipboardItem['do'] == 'copy')
		{
			// file
			if($clipboardItem['type'] == WEBDISK_ITEM_FILE)
			{ 
				$fileInfo = $webdisk->GetFileInfo($clipboardItem['id']);
				if($fileInfo !== false && $webdisk->FileExists($folderID, $fileInfo['dateiname']))
				{
					// exists
					$tpl->assign('msg', $lang_user['fileexists'] . '.');					
				}
				else if($fileInfo !== false)
				{
					if($spaceLimit == -1 || ($usedSpace+$fileInfo['size']) <= $spaceLimit)
					{
						// ok!
						$webdisk->CopyFile($folderID, $clipboardItem['id']);
						$ok = true;
					}
					else 
					{
						// not enough space
						$tpl->assign('msg', $lang_user['nospace'] . '.');						
					}
				}
				else 
				{
					$tpl->assign('msg', $lang_user['sourcenex']);					
				}
			}
			
			// folder
			else if($clipboardItem['type'] == WEBDISK_ITEM_FOLDER)
			{
				$folderInfo = $webdisk->GetFolderInfo($clipboardItem['id']);
				if($folderInfo !== false && $webdisk->FolderExists($folderID, $folderInfo['titel']))
				{
					// exists
					$tpl->assign('msg', $lang_user['foldererror']);
				}
				else if($folderInfo !== false)
				{
					// copy folder
					$maxSpace = $spaceLimit == -1 ? -1 : $spaceLimit - $usedSpace;
					if(!$webdisk->CopyFolder($folderID, $clipboardItem['id'], $maxSpace))
					{
						// not enough space
						$tpl->assign('msg', $lang_user['nospace2'] . '.');	
					}
					else 
					{
						$ok = true;
					}
				}
				else 
				{
					$tpl->assign('msg', $lang_user['sourcenex']);					
				}
			}
		}
	}
	
	if($ok)
	{
		header('Location: webdisk.php?folder=' . $folderID . '&sid=' . session_id());
	}
	else 
	{
		$tpl->assign('pageContent', 'li/error.tpl');
		$tpl->display('li/index.tpl');
	}
}

/**
 * upload files
 */
else if($_REQUEST['action'] == 'uploadFiles')
{
	$error = $success = array();
	
	foreach($_FILES as $key=>$value)
	{
		if(is_array($value) && substr($key, 0, 4) == 'file' && isset($value['name']) && trim($value['name']) != '')
		{
			$fileName = isset($value['name']) ? $value['name'] : 'unknown';
			$fileSize = (int)$value['size'];
			$mimeType = $value['type'];
			
			if($groupRow['traffic'] <= 0 || ($userRow['traffic_down']+$userRow['traffic_up']+$fileSize) <= $groupRow['traffic'])
			{
				if($spaceLimit == -1 || $usedSpace+$fileSize <= $spaceLimit)
				{
					if(($fileID = $webdisk->CreateFile($folderID, $fileName, $mimeType, $fileSize)) !== false)
					{
						if(!@move_uploaded_file($value['tmp_name'], DataFilename($fileID, 'dsk')))
						{
							$webdisk->DeleteFile($fileID);
							$error[$fileName] = $lang_user['internalerror'];
							
							// log
							PutLog(sprintf('Failed to move uploaded file <%s> to <%s>, deleting webdisk file',
								$value['tmp_name'],
								DataFilename($fileID, 'dsk')),
								PRIO_ERROR,
								__FILE__,
								__LINE__);
						}
						else 
						{
							$usedSpace += $fileSize;
							$db->Query('UPDATE {pre}users SET traffic_up=traffic_up+? WHERE id=?',
								$fileSize,
								$userRow['id']);
							Add2Stat('wd_up', ceil($fileSize/1024));
							$success[$fileName] = $lang_user['success'];
						}
					}
					else 
					{
						$error[$fileName] = $lang_user['fileexists'];
					}
				}
				else 
				{
					$error[$fileName] = $lang_user['nospace'];
				}
			}
			else 
			{
				$error[$fileName] = $lang_user['notraffic'];
			}
		}
	}
	
	if(count($error) > 0 || count($success) > 0)
	{
		$tpl->assign('error', $error);
		$tpl->assign('success', $success);
		$tpl->assign('pageContent', 'li/webdisk.uploadresult.tpl');
		$tpl->display('li/index.tpl');
	}
	else 
	{
		header('Location: webdisk.php?folder=' . $folderID . '&sid=' . session_id());
	}
}

/**
 * extension image
 */
else if($_REQUEST['action'] == 'displayExtension')
{
	if(isset($_REQUEST['ext']))
		$ext = ereg_replace('[^a-zA-Z\.]', '', $_REQUEST['ext']);
	else 
		$ext = '.?';
	$webdisk->DisplayExtension($ext);
}

/**
 * dialog
 */
else if($_REQUEST['action'] == 'webdiskDialog')
{
	// type
	if(isset($_REQUEST['type']) && $_REQUEST['type']=='save')
		$type = 'save';
	else 
		$type = 'open';
		
	$tpl->assign('type', $type);
	$tpl->display('li/webdisk.dialog.tpl');
}

/**
 * dialog content
 */
else if($_REQUEST['action'] == 'webdiskDialogContent')
{
	// path
	if(!isset($_REQUEST['path']))
		$path = 0;
	else 
		$path = (int)$_REQUEST['path'];
	
	// get path
	$pathArray = array_merge(array(0 => array('id' => '0', 'title' => '/')), $webdisk->GetFolderPath($path));
	$pathIDs = array();
	foreach($pathArray as $item)
		$pathIDs[] = $item['id'];

	// process path	
	$contentColumns = array();
	foreach($pathArray as $pathFolder)
	{
		$content = $webdisk->GetFolderContent($pathFolder['id'], 'dateiname', 'ASC');
		foreach($content as $key=>$val)
		{
			$content[$key]['folderID'] = $pathFolder['id'];
			if($val['type'] == WEBDISK_ITEM_FOLDER && in_array($val['id'], $pathIDs))
				$content[$key]['inPath'] = true;
		}
		$contentColumns[] = $content;
	}
	
	// assign & display
	$tpl->assign('height', (int)$_REQUEST['height']);
	$tpl->assign('columns', $contentColumns);
	$tpl->assign('pathID', $path);
	$tpl->assign('history', array_reverse($pathArray));
	$tpl->display('li/webdisk.dialog.content.tpl');
}

/**
 * import from mail dialog
 */
else if($_REQUEST['action'] == 'importFromMail')
{
	$tpl->assign('params', 'webdisk.php?action=doImportFromMail&sid=' . session_id() . '&id=' . (int)$_REQUEST['id'] . '&attachment=' . ereg_replace('[^\.0-9]', '', $_REQUEST['attachment']));
	$tpl->assign('filename', $_REQUEST['filename']);
	$tpl->assign('type', 'save');
	$tpl->display('li/webdisk.dialog.tpl');
}

/**
 * import attachment
 */
else if($_REQUEST['action'] == 'doImportFromMail'
		&& isset($_REQUEST['id'])
		&& isset($_REQUEST['attachment'])
		&& isset($_REQUEST['filename'])
		&& isset($_REQUEST['path']))
{
	$mailID = (int)$_REQUEST['id'];
	$attachment = $_REQUEST['attachment'];
	$fileName = trim($_REQUEST['filename']);
	$folderID = (int)$_REQUEST['path'];
	
	echo '<script language="javascript">' . "\n";
	echo '<!--' . "\n";
	
	// load class, if needed
	if(!class_exists('BMMailbox'))
		include(B1GMAIL_DIR . 'serverlib/mailbox.class.php');
	
	// open mailbox
	$mailbox = _new('BMMailbox', array($userRow['id'], $userRow['email'], $thisUser));

	// get mail
	$mail = $mailbox->GetMail($mailID);
	if($mail !== false)
	{
		$parts = $mail->GetPartList();
		if(isset($parts[$attachment]))
		{
			$part = $parts[$attachment];
			
			// attachment => temp file
			$tempFileID = RequestTempFile($userRow['id']);
			$tempFileName = TempFileName($tempFileID);
			$fp = fopen($tempFileName, 'wb');
			$attData = &$part['body'];
			$attData->Init();
			while($block = $attData->DecodeBlock(PART_CHUNK_SIZE))
			{
				fwrite($fp, $block);
			}
			$attData->Finish();
			$fileSize = ftell($fp);
			fclose($fp);
			
			// limit?
			if($spaceLimit == -1 || $usedSpace+$fileSize <= $spaceLimit)
			{
				// try to create file
				if(!($fileID = $webdisk->CreateFile($folderID, $fileName, $part['content-type'], $fileSize))
					|| !copy($tempFileName, DataFilename($fileID, 'dsk')))
				{
					echo 'alert(\'' . addslashes($lang_user['fileexists']) . '\');' . "\n";
				}
			}
			else 
			{
				// too less space
				echo 'alert(\'' . addslashes($lang_user['nospace']) . '\');' . "\n";
			}
			
			// release temp file
			ReleaseTempFile($userRow['id'], $tempFileID);
		}
	
	}
	
	echo 'parent.hideOverlay();' . "\n";
	echo '//-->' . "\n";
	echo '</script>' . "\n";
}

/**
 * create folder RPC
 */
else if($_REQUEST['action'] == 'webdiskDialogCreateFolder' && isset($_REQUEST['title']))
{
	$folderName = trim($_REQUEST['title']);
	$folderID = (int)$_REQUEST['path'];
	
	if(!$webdisk->FolderExists($folderID, $folderName) && strlen($folderName) > 0)
	{
		$newFolderID = $webdisk->CreateFolder($folderID, $folderName);
		echo($newFolderID);
		die();
	}
	
	die('0');
}
?>